<?php
/**
* @package: phpBB 3.0.8 :: phpBB Web => phpbb root/includes/acp/
* @version: $Id: acp_phpbbweb.php, v1.0.4 2011-01-20 11:01:20 leviatan21 Exp $
* @copyright: leviatan21 < info@mssti.com > (Gabriel) http://www.mssti.com/phpbb3/
* @license: http://opensource.org/licenses/gpl-license.php GNU Public License 
* @author: leviatan21 - http://www.phpbb.com/community/memberlist.php?mode=viewprofile&u=345763
**/

/**
* @ignore
**/
if (!defined('IN_PHPBB'))
{
	exit;
}
define('IN_PHPBBWEB', true);
// define('PHPBBWEB_ROOT', './');
   define('PHPBBWEB_ROOT', './../web/');
define('PHPBB_ROOT_PATH', $phpbb_root_path);
define('PHP_EXT', $phpEx);

/**
* @todo 
*	SEO : URL user friendly 
**/
/**
* @package acp
**/
class acp_phpbbweb
{
	var $u_action;

	function main($id, $mode)
	{
		global $user, $phpbbweb;

		// Make sure that phpbbweb is always usable
		require(PHPBB_ROOT_PATH . 'includes/functions_phpbbweb.' . PHP_EXT);

		$action = request_var('action', '');
		$page_id = request_var('page_id', 0);
		$category_id = request_var('category_id', 0);
		$section_id = request_var('section_id', 0);
		$block_id = request_var('block_id', 0);
/**		
		// Remove previously added "action" and "mode"
		if ((strpos($this->u_action, 'action=') !== false) || (strpos($this->u_action, 'mode=') !== false))
		{
			// All kind of links
			$this->u_back = preg_replace('/(\?)?(&amp;|&)?(action|mode)=[a-z0-9]+/', '', $this->u_action);
			// if the sid was the first param, make the old second as first ones
			$this->u_back = preg_replace("/$phpEx(&amp;|&)+?/", "$phpEx?", $this->u_back);
		}
**/
//print_r("mode=($mode) action=($action) category_id=($category_id) section_id=($section_id) block_id=($block_id)");
		switch ($mode)
		{
			default:
			case 'settings':
				return $this->phpbbweb_settings();
			break;

			case 'features':
				return $this->phpbbweb_features();
			break;

			case 'stylesheet':
				return $this->phpbbweb_stylesheet($action);
			break;

			case 'message':
				return $this->phpbbweb_message($action);
			break;

			case 'manage':
				switch ($action)
				{
					case 'activate':
					case 'deactivate':
					//	no return here ;)
						$page_id = $this->phpbbweb_moderate($id, $mode, $action, $page_id);
					break;

					case 'move_up':
					case 'move_down':
					//	no return here ;)
						$page_id = $this->phpbbweb_move($page_id, $action);
					break;

					case 'remove':
						return $this->phpbbweb_remove($page_id);
					break;

					case 'add':
					case 'edit':
						return $this->phpbbweb_editor($page_id, $action);
					break;

					case 'sync':
						return $this->phpbbweb_sync();
					break;

					case 'orphan':
						return $this->phpbbweb_orphan($action);
					break;
				}

				// Avoid recursion
				if ($action && !$section_id)
				{
				//	$category_id = 0;
				}
				return $this->phpbbweb_frontend($page_id);

			break;
		}
/**
		// In case everything fails, this help me in DEV stage
		global $module, $template;
		// Generate the page
		adm_page_header($user->lang[$this->page_title]);

		$template->set_filenames(array(
			'body' => $this->tpl_name . '.html',
		));

		adm_page_footer();
**/
	}

	/**
	* @description: Display settings
	*
	* @version: 1.0.0
	**/
	function phpbbweb_settings()
	{
		global $user, $template;
		global $webconfig;

		$error = array();

		$this->tpl_name = 'phpbbweb/acp_phpbbweb_settings';
		$this->page_title = 'ACP_PHPBBWEB_SETTINGS';
		$update = (isset($_POST['update'])) ? true : false;

		$form_key = 'acp_phpbbweb_settings';
		add_form_key($form_key);

		$config_data = array(
			'disable' 		=> request_var('disable', (int) $webconfig['disable']),
			'disable_msg'	=> utf8_normalize_nfc(request_var('disable_msg', $webconfig['disable_msg'], true)),
			'sitename'		=> utf8_normalize_nfc(request_var('sitename', $webconfig['sitename'], true)),
			'description'	=> utf8_normalize_nfc(request_var('description', $webconfig['description'], true)),
		);

		if ($update)
		{
			if (!check_form_key($form_key))
			{
				trigger_error($user->lang['FORM_INVALID'] . adm_back_link($this->u_action), E_USER_WARNING);
			}

			// I know, this is nor true, but is how it should be
			$range_test_ary = array(
				array(
					'lang' => 'ACP_DISABLE', 'value' => $config_data['disable'], 'column_type' => 'BOOL',
					'lang' => 'ACP_DISABLE', 'value' => $config_data['disable_msg'], 'column_type' => 'VCHAR',
					'lang' => 'ACP_SITENAME', 'value' => $config_data['sitename'], 'column_type' => 'VCHAR',
					'lang' => 'ACP_DESCRIPTION', 'value' => $config_data['description'], 'column_type' => 'VCHAR',
				),
			);
			validate_range($range_test_ary, $error);

			if (!sizeof($error))
			{
				foreach ($config_data as $config_name => $config_value)
				{
					$this->phpbbweb_set_config($config_name, $config_value);
				}
				trigger_error($user->lang['CONFIG_UPDATED'] . adm_back_link($this->u_action));
			}
		}

		$this->phpbbweb_version_check(PHPBBWEB_VERSION);

		// Display some relevant informations
		if (isset($user->lang['ACP_CONFIG_HELP']) && is_array($user->lang['ACP_CONFIG_HELP']) && sizeof($user->lang['ACP_CONFIG_HELP']))
		{
			foreach ($user->lang['ACP_CONFIG_HELP'] as $help_title => $help_ary)
			{
				$template->assign_block_vars('faq_block', array(
					'BLOCK_TITLE'		=> $help_title,
				));
				foreach ($help_ary as $help)
				{
					$template->assign_block_vars('faq_block.faq_row', array(
						'FAQ_ANSWER'		=> $help,
					));
				}
			}
		}

		$template->assign_vars(array(
			'S_SETTINGS'	=> true,
			'L_TITLE'		=> $user->lang[$this->page_title],
			'L_EXPLAIN'		=> $user->lang[$this->page_title . '_EXPLAIN'],
			'S_ERROR_MSG'	=> (sizeof($error)) ? true : false,
			'ERROR_MSG'		=> (sizeof($error)) ? implode('<br />', $error) : '',
			'U_ACTION'		=> $this->u_action . '&amp;mode=settings',
			'U_BACK'		=> $this->u_action,

			'DISABLE'		=> ($config_data['disable']) ? true : false,
			'DISABLE_MSG'	=> $config_data['disable_msg'],
			'SITENAME'		=> $config_data['sitename'],
			'DESCRIPTION'	=> $config_data['description'],

			'U_PHPBBWEB_INDEX'	=> append_sid(PHPBBWEB_INDEX),
		));
	}

	/**
	* @description: Check if the mod is up to date
	* 
	* @param: $current_version
	* @version: 1.0.0
	**/
	function phpbbweb_version_check($current_version)
	{
		global $module, $cache, $template;

		// First we need to know owr version, got it from the files
		$parent_module = "{$module->p_class}_{$module->p_name}_info";
		$module_file = "{$module->include_path}{$module->p_class}/info/{$module->p_class}_{$module->p_name}." . PHP_EXT;

		if (!class_exists($parent_module))
		{
			include($module_file);

			$module_info = new $parent_module();

			$module_data = $module_info->module();

			$current_version = $module_data['version'];
		}

		// Now check version against mssti web
		$version_up_to_date = true;
		$version_check_fails = false;
		$version_check_link = '';
		$ttl = 86400;

		$info = $cache->get('phpbbweb_versioncheck');

		if ($info === false)
		{
			$errstr = '';
			$errno = 0;

			$info = get_remote_file('www.mssti.com', '/phpbb3/store/updatecheck', 'phpbbweb.txt', $errstr, $errno);

			if ($info === false)
			{
				$version_check_fails = true;
				$cache->destroy('phpbbweb_versioncheck');
			}
		}

		if ($info !== false)
		{
			$cache->put('phpbbweb_versioncheck', $info, $ttl);
			$latest_version_info = explode("\n", $info);
			$latest_version = strtolower(trim($latest_version_info[0]));
			$current_version = strtolower(trim($current_version));
			$version_up_to_date = version_compare($current_version, $latest_version, '<') ? false : true;
			$version_check_link = ($version_up_to_date) ? '' : $latest_version_info[1];
		}

		$template->assign_vars(array(
			'SCRIPT_VERSION'		=> $current_version,
			'S_VERSIONCHECK_FAIL'	=> $version_check_fails,
			'S_VERSION_UP_TO_DATE'	=> $version_up_to_date,
			'U_VERSIONCHECK'		=> $version_check_link,
		));

		return;
	}

	/**
	* @description: Display features
	*
	* @version: 1.0.4
	**/
	function phpbbweb_features()
	{
		global $db, $user, $template;
		global $phpbbweb;
		global $webconfig;

		$error = array();

		$this->tpl_name = 'phpbbweb/acp_phpbbweb_features';
		$this->page_title = 'ACP_PHPBBWEB_FEATURES';
		$update = (isset($_POST['update'])) ? true : false;

		$form_key = 'acp_phpbbweb_features';
		add_form_key($form_key);
// $webconfig['portal_important_posts'] = array(0 => 0);

		$config_data = array(
		// Style
			'column_design'				=> request_var('column_design', (int) $webconfig['column_design']), 
			'leftsidebar_width'			=> request_var('leftsidebar_width', (int) $webconfig['leftsidebar_width']),
			'rightsidebar_width'		=> request_var('rightsidebar_width', (int) $webconfig['rightsidebar_width']),
			'favicon'					=> request_var('favicon', (int) $webconfig['favicon']),
			'logo' 						=> utf8_normalize_nfc(request_var('logo', $webconfig['logo'], true)),
			'random_logo'				=> request_var('random_logo', (int) $webconfig['random_logo']),
			'random_bg'					=> request_var('random_bg', (int) $webconfig['random_bg']),
			'meta_disable'				=> request_var('meta_disable', (int) $webconfig['meta_disable']),
			'meta_abstract' 			=> utf8_normalize_nfc(request_var('meta_abstract', $webconfig['meta_abstract'], true)),
			'meta_description'			=> utf8_normalize_nfc(request_var('meta_description', $webconfig['meta_description'], true)),
			'meta_description_dynamic'	=> request_var('meta_description_dynamic', (int) $webconfig['meta_description_dynamic']),
			'meta_keywords' 			=> utf8_normalize_nfc(request_var('meta_keywords', $webconfig['meta_keywords'], true)),
			'meta_google_verify'		=> utf8_normalize_nfc(request_var('meta_google_verify', $webconfig['meta_google_verify'], true)),
		// Extra
			'views_counter'				=> request_var('views_counter', (int) $webconfig['views_counter']),
			'live_clock'				=> request_var('live_clock', (int) $webconfig['live_clock']),
			'breadcrumbs'				=> request_var('breadcrumbs', (int) $webconfig['breadcrumbs']),

			'allow_search'				=> request_var('allow_search', (int) $webconfig['allow_search']),
			'contact'					=> request_var('contact', (int) $webconfig['contact']),
			'contact_captcha'			=> request_var('contact_captcha', (int) $webconfig['contact_captcha']),
			'email'						=> strtolower(request_var('email', $webconfig['email'])),
			'email_display'				=> request_var('email_display', (int) $webconfig['email_display']),
			'messenger'					=> request_var('messenger', $webconfig['messenger']),
			'messenger_display'			=> request_var('messenger_display', (int) $webconfig['messenger_display']),
		// Modules
			'site_map'					=> request_var('site_map', (int) $webconfig['site_map']),
			'portal_recent_topics'		=> request_var('portal_recent_topics', $webconfig['portal_recent_topics']),
			'portal_recent_topics_limit'=> request_var('portal_recent_topics_limit', (int) $webconfig['portal_recent_topics_limit']),
			'portal_stat'				=> request_var('portal_stat', $webconfig['portal_stat']),
			'portal_important_topics'	=> request_var('portal_important_topics', array(0 => 0)),
			'portal_important_posts'	=> request_var('portal_important_posts', array(0 => 0)),
		);

		if ($update)
		{
			if (!check_form_key($form_key))
			{
				trigger_error($user->lang['FORM_INVALID'] . adm_back_link($this->u_action), E_USER_WARNING);
			}

			// I know, this is nor true, but is how it should be
			$range_test_ary = array(
				array(
					'lang' => 'ACP_DESIGN', 'value' => $config_data['column_design'], 'column_type' => 'TINT:0',
					'lang' => 'ACP_COLUMN_LEFT_WIDE', 'value' => $config_data['leftsidebar_width'], 'column_type' => 'TINT:0',
					'lang' => 'ACP_COLUMN_RIGHT_WIDE', 'value' => $config_data['rightsidebar_width'], 'column_type' => 'TINT:0',

					'lang' => 'ACP_META_FAVICON', 'value' => $config_data['favicon'], 'column_type' => 'BOOL',
					'lang' => 'ACP_LOGO', 'value' => $config_data['logo'], 'column_type' => 'VCHAR',
					'lang' => 'ACP_RANDOM_LOGO', 'value' => $config_data['random_logo'], 'column_type' => 'BOOL',
					'lang' => 'ACP_BACKGROUND', 'value' => $config_data['random_bg'], 'column_type' => 'BOOL',
					'lang' => 'ACP_META_DISABLE', 'value' => $config_data['meta_disable'], 'column_type' => 'BOOL',
					'lang' => 'ACP_META_ABSTRACT', 'value' => $config_data['meta_abstract'], 'column_type' => 'USINT',
					'lang' => 'ACP_META_DESCRIPTION', 'value' => $config_data['meta_description'], 'column_type' => 'USINT',
					'lang' => 'ACP_META_DESCRIPTION_DYNAMIC', 'value' => $config_data['meta_description_dynamic'], 'column_type' => 'BOOL',
					'lang' => 'ACP_META_KEYWORDS', 'value' => $config_data['meta_keywords'], 'column_type' => 'USINT',
					'lang' => 'ACP_META_GOOGLE_VERIFY', 'value' => $config_data['meta_google_verify'], 'column_type' => 'USINT',

					'lang' => 'ACP_VIEWS', 'value' => $config_data['views_counter'], 'column_type' => 'BOOL',
					'lang' => 'ACP_LIVE_CLOCK', 'value' => $config_data['live_clock'], 'column_type' => 'BOOL',
					'lang' => 'ACP_NAVBAR', 'value' => $config_data['breadcrumbs'], 'column_type' => 'BOOL',

					'lang' => 'ACP_SEARCH_DISABLE', 'value' => $config_data['allow_search'], 'column_type' => 'BOOL',
					'lang' => 'ACP_CONTACT_DISABLE', 'value' => $config_data['contact'], 'column_type' => 'BOOL',
					'lang' => 'ACP_CONTACT_CAPTCHA', 'value' => $config_data['contact_captcha'], 'column_type' => 'BOOL',
					'lang' => 'ACP_CONTACT_MAIL', 'value' => $config_data['email'], 'column_type' => 'USINT',
					'lang' => 'ACP_CONTACT_MAIL_DISPLAY', 'value' => $config_data['email_display'], 'column_type' => 'BOOL',
					'lang' => 'ACP_CONTACT_MESSENGER', 'value' => $config_data['messenger'], 'column_type' => 'USINT',
					'lang' => 'ACP_CONTACT_MESSENGER_DISPLAY', 'value' => $config_data['messenger_display'], 'column_type' => 'BOOL',
					'lang' => 'ACP_RECENT_TOPICS', 'value' => $config_data['portal_recent_topics'], 'column_type' => 'VCHAR',
					'lang' => 'ACP_RECENT_TOPICS_LIMIT', 'value' => $config_data['portal_recent_topics_limit'], 'column_type' => 'TINT:0',
					'lang' => 'ACP_PORTAL_STAT', 'value' => $config_data['portal_stat'], 'column_type' => 'BOOL',
					'lang' => 'ACP_SITEMAP', 'value' => $config_data['site_map'], 'column_type' => 'BOOL',
				),
			);
			validate_range($range_test_ary, $error);

			if (!sizeof($error))
			{
				foreach ($config_data as $config_name => $config_value)
				{
					if ($config_name == 'portal_important_topics')
					{
						$portal_important_topics = request_var('portal_important_topics', array(0 => 0));
						$this->phpbbweb_set_config('portal_important_topics', serialize($portal_important_topics));
						continue;
					}
					if ($config_name == 'portal_important_posts')
					{
						$portal_important_topics = request_var('portal_important_posts', array(0 => 0));
						$this->phpbbweb_set_config('portal_important_posts', serialize($portal_important_topics));
						continue;
					}
					$this->phpbbweb_set_config($config_name, $config_value);
				}
				trigger_error($user->lang['CONFIG_UPDATED'] . adm_back_link($this->u_action));
			}
		}

//	$webconfig['seo'] = true;
//	$webconfig['seo_phpbb'] = 'RAIZ/phpbb3/';
//	$webconfig['seo_phpbbweb'] = 'RAIZ/phpbb3/web';

		$template->assign_vars(array(
			'S_FEATURES'	=> true,
			'L_TITLE'		=> $user->lang[$this->page_title],
			'L_EXPLAIN'		=> $user->lang[$this->page_title . '_EXPLAIN'],
			'S_ERROR_MSG'	=> (sizeof($error)) ? true : false,
			'ERROR_MSG'		=> (sizeof($error)) ? implode('<br />', $error) : '',
			'U_ACTION'		=> $this->u_action . '&amp;mode=features',
			'U_BACK'		=> $this->u_action,
		// Style
			'COLUMN_DESIGN'				=> $config_data['column_design'],
			'COLUMN_LEFT_WIDE'			=> $config_data['leftsidebar_width'],
			'COLUMN_RIGHT_WIDE'			=> $config_data['rightsidebar_width'],
			'FAVICON'					=> ($config_data['favicon']) ? true : false,
			'L_FAVICON_IMAGES_NOTE'		=> sprintf($user->lang['ACP_IMAGES_NOTE'], $user->theme['template_path'], ''),
			'LOGO'						=> $config_data['logo'],
			'RANDOM_LOGO'				=> ($config_data['random_logo']) ? 1 : 0,
			'L_LOGO_IMAGES_NOTE'		=> sprintf($user->lang['ACP_IMAGES_NOTE'], $user->theme['template_path'], '/logo'),
			'RANDOM_BG'					=> ($config_data['random_bg']) ? 1 : 0,
			'L_BG_IMAGES_NOTE'			=> sprintf($user->lang['ACP_IMAGES_NOTE'], $user->theme['template_path'], '/bg'),
			'META_DISABLE'				=> ($config_data['meta_disable']) ? true : false,
			'META_ABSTRACT'				=> $config_data['meta_abstract'],
			'META_DESCRIPTION'			=> $config_data['meta_description'],
			'META_DESCRIPTION_DYNAMIC'	=> $config_data['meta_description_dynamic'],
			'META_KEYWORDS'				=> $config_data['meta_keywords'],
			'META_GOOGLE_VERIFY'		=> $config_data['meta_google_verify'],
		// Extra
			'VIEWS_COUNTER'				=> ($config_data['views_counter']) ? true : false,
			'LIVE_CLOCK'				=> ($config_data['live_clock']) ? true : false,
			'NAVBAR'					=> ($config_data['breadcrumbs']) ? true : false,
			'U_SEO_PHPBBWEB'			=> $phpbbweb->phpbbweb_build_url(true, true),
			'U_SEO_PHPBB'				=> $phpbbweb->phpbbweb_build_url(false, false),
		// Modules
			'SEARCH_FORM'				=> ($config_data['allow_search']) ? true : false,
			'CONTACT'					=> ($config_data['contact']) ? true : false,
			'CONTACT_CAPTCHA'			=> ($config_data['contact_captcha']) ? true : false,
			'CONTACT_MAIL'				=> $config_data['email'],
			'CONTACT_MAIL_DISPLAY'		=> ($config_data['email_display']) ? true : false,
			'CONTACT_MESSENGER'			=> $config_data['messenger'],
			'CONTACT_MESSENGER_DISPLAY'	=> ($config_data['messenger_display']) ? true : false,
			'RECENT_TOPICS'				=> $config_data['portal_recent_topics'],
			'RECENT_TOPICS_LIMIT'		=> $config_data['portal_recent_topics_limit'],
			'PORTAL_STAT'				=> ($config_data['portal_stat']) ? true : false,
			'PORTAL_TOPICS_OPTIONS'		=> $this->portal_select_topic('portal_important_topics', false, $webconfig['portal_important_topics']),
			'PORTAL_POSTS_OPTIONS'		=> $this->portal_select_topic('portal_important_posts', false, $webconfig['portal_important_posts']),
			'SITEMAP'					=> ($config_data['site_map']) ? true : false,
		));
	}

	/**
	* Pick a forum/topic...
	*
	* @param bool		$select_forum	true = forum+topic | false = forums
	* @return html option/s
	* @version: 1.0.4
	**/
	function portal_select_topic($id = 'portal_important_topics', $select_forum = false, $selected_ids)
	{
		global $user, $db;

		$selected_ids = (!empty($selected_ids)) ? unserialize(trim($selected_ids)) : array();

		// Get Forums - Start
		$forum_rows = array();

		$sql = 'SELECT forum_id, forum_name, parent_id, forum_type, left_id, right_id
				FROM ' . FORUMS_TABLE . ' 
				ORDER BY left_id ASC';
		$result = $db->sql_query($sql);
		while ($row = $db->sql_fetchrow($result))
		{
			$forum_rows[] = $row;
		}
		$db->sql_freeresult($result);
		$total_forums = count($forum_rows);
		// Get Forums - End

		// Get topics - Start
		$topic_rows = array();
		if (!$select_forum)
		{
			$sql = "SELECT t.topic_id, t.topic_title, f.forum_id 
					FROM " . TOPICS_TABLE . " t, " . FORUMS_TABLE . " f 
					WHERE f.forum_id = t.forum_id 
					GROUP BY t.topic_id, t.topic_title";
			$result = $db->sql_query($sql);
			while ($row = $db->sql_fetchrow($result))
			{
				$topic_rows[] = $row;
			}
			$db->sql_freeresult($result);
		}
		$total_topics = count($topic_rows);
		// Get topics - End

		$s_list	= '<select id="' . $id . '" name="' . $id . '[]" size="10" multiple="multiple">' . "\n";

		if (sizeof($forum_rows))
		{
			$s_list .= '<option disabled="disabled" class="disabled-option">----------------</option>' . "\n";

			$right = $padding = 0;
			$padding_store = array('0' => 0);
			for($i = 0; $i < $total_forums; $i++)
			{
				if ($forum_rows[$i]['forum_type'] == FORUM_CAT && ($forum_rows[$i]['left_id'] + 1 == $forum_rows[$i]['right_id']))
				{
					// Non-postable forum with no subforums, don't display
					continue;
				}

				// sepatate forum ans sub-forums - Start
				if ($forum_rows[$i]['left_id'] < $right)
				{
					$padding++;
					$padding_store[$forum_rows[$i]['parent_id']] = $padding;
				}
				else if ($forum_rows[$i]['left_id'] > $right + 1)
				{
					// Ok, if the $padding_store for this parent is empty there is something wrong. For now we will skip over it.
					$padding = (isset($padding_store[$forum_rows[$i]['parent_id']])) ? $padding_store[$forum_rows[$i]['parent_id']] : $padding;
				}
				$right = $forum_rows[$i]['right_id'];

				$spaces = '';
				for ($x = 0; $x < $padding; $x++)
				{
					$spaces .= '&nbsp;&nbsp;';
				}
				// sepatate forum ans sub-forums - End

				if (!$select_forum)
				{
					$s_list .= '<optgroup class="disabled-option" label="' . $spaces . $user->lang['FORUM'] . ' : ' . $forum_rows[$i]['forum_name'] . '">' . "\n";
				}
				else
				{
					if ($forum_rows[$i]['forum_type'] == FORUM_CAT)
					{
						$s_list .= '<optgroup class="sep" label="' . $spaces . $user->lang['FORUM'] . ' : ' . $forum_rows[$i]['forum_name'] . '">' . "\n";
					}
					else
					{
						$selected = (in_array($forum_rows[$i]['forum_id'], $selected_ids)) ? ' selected="selected"' : '';
						$s_list .= '<option value="' . $forum_rows[$i]['forum_id'] . '"'. $selected .'>' . $spaces . '(' . $forum_rows[$i]['forum_id'] . ')&nbsp;' . $forum_rows[$i]['forum_name'] . '</option>' . "\n";
					}
				}

				for($j = 0; $j < $total_topics; $j++)
				{
					if ($topic_rows[$j]['forum_id'] == $forum_rows[$i]['forum_id'])
					{
						$selected = (in_array($topic_rows[$j]['topic_id'], $selected_ids)) ? ' selected="selected"' : '';
						$s_list .=  '<option value="' . $topic_rows[$j]['topic_id'] . '"'. $selected .'>&nbsp;&nbsp;' . $spaces . '(' . $topic_rows[$j]['topic_id'] . ')&nbsp;' . $topic_rows[$j]['topic_title'] . '</option>' . "\n";
					}
				}

				if (!$select_forum)
				{
					$s_list .= '</optgroup>' . "\n";
				}
			}
			$padding = 0;
		}
		else
		{
			$s_list .= '<option value="-1" disabled="disabled" class="disabled-option">' . $user->lang['NO_TOPIC'] . '</option>' . "\n";
		}
		$s_list .= '</select>' . "\n";

		return $s_list;
	}

	/**
	* @description: Edit the stylesheet
	*
	* @param: (string)		$action
	* 
	* @version: 1.0.0
	**/
	function phpbbweb_stylesheet($action)
	{
		global $user, $template;
		global $webconfig;

		$this->tpl_name = 'phpbbweb/acp_phpbbweb_stylesheet';
		$this->page_title = 'ACP_PHPBBWEB_CSS';

		$error				= array();
		$save_changes		= (isset($_POST['save'])) ? true : false;

		$stylesheet_data	= utf8_normalize_nfc(request_var('stylesheet', $webconfig['stylesheet'], true));
		$stylesheet_data	= htmlspecialchars_decode($stylesheet_data);
		$text_rows			= max(5, min(999, request_var('text_rows', 20)));
		$form_name = 'acp_stylesheet_editor';
		add_form_key($form_name);

		// save changes to the theme if the user submitted any
		if ($save_changes && !check_form_key($form_name))
		{
			trigger_error($user->lang['FORM_INVALID'] . adm_back_link($this->u_action . "&amp;text_rows=$text_rows"), E_USER_WARNING);
		}

		// Write stylesheet to db
		if ($save_changes)
		{
			$this->phpbbweb_set_config('stylesheet', $stylesheet_data);

			trigger_error($user->lang['ACP_PHPBBWEB_STYLESHEET_STORED'] . adm_back_link($this->u_action));
		}

		$template->assign_vars(array(
			'S_EDIT_THEME'		=> true,
			'L_TITLE'			=> $user->lang[$this->page_title],
			'L_EXPLAIN'			=> $user->lang[$this->page_title . '_EXPLAIN'],
			'U_ACTION'			=> $this->u_action . "&amp;text_rows=$text_rows",

			'TEMPLATE_DATA'		=> utf8_htmlspecialchars($stylesheet_data),
			'TEXT_ROWS'			=> $text_rows,
		));
	}

	/**
	* @description: Edit the main/welcome message
	*
	* @param: (string)		$action
	* 
	* @version: 1.0.0
	**/
	function phpbbweb_message($action)
	{
		global $db, $user, $template;
		global $config, $webconfig;

		$error		= array();
		$submit		= (isset($_POST['update'])) ? true : false;
		$preview	= request_var('preview', 0);
		$cancel		= (isset($_POST['cancel'])) ? true : false;
		$refresh	= (isset($_POST['add_file']) || isset($_POST['delete_file'])) ? true : false;
		// Show attachment box for adding attachments if true
		$allow_attachments = $config['allow_attachments'];

		$user->add_lang('posting');
		$this->tpl_name = 'phpbbweb/acp_phpbbweb_editor';
		$this->page_title = 'ACP_PHPBBWEB_WELCOME';

		$form_name = 'phpbbweb_message';
		add_form_key($form_name);

		include_once(PHPBB_ROOT_PATH . 'includes/functions_posting.' . PHP_EXT);
		include_once(PHPBB_ROOT_PATH . 'includes/functions_display.' . PHP_EXT);

		// HTML, BBCode, Smilies, Images and Flash status
		$allow_bbcode		= ($config['allow_bbcode'] && $user->optionget('bbcode'))	? true : false;
		$allow_smilies		= ($config['allow_smilies'] && $user->optionget('smilies'))	? true : false;
		$allow_img_bbcode	= ($allow_bbcode) ? true : false;
		$allow_url_bbcode	= ($config['allow_post_links']) ? true : false;
		$allow_flash_bbcode	= ($allow_bbcode && $config['allow_post_flash']) ? true : false;
		$allow_quote_bbcode	= ($allow_bbcode) ? true : false;

		// HTML, BBCode, Smilies, Images and Flash status for this post
		$bbcode_status		= ($allow_bbcode) ? (bool) $webconfig['welcome_message_enable_bbcode'] : false;
		$smilies_status		= ($allow_smilies) ? (bool) $webconfig['welcome_message_enable_smilies'] : false;
		$magic_url_status	= ($allow_url_bbcode) ? (bool) $webconfig['welcome_message_enable_urls'] : false;
		$approved			= request_var('approved', (bool) $webconfig['welcome_message_approved']);
		$reset_views		= request_var('reset_views', 0);
		$page_views 		= $webconfig['page_views'];
		$message			= utf8_normalize_nfc(request_var('message', (string) $webconfig['welcome_message'], true));

		$message_parser = new message_parse($message);

		// Always check if the submitted attachment data is valid and belongs to the user.
		// Further down (especially in submit_post()) we do not check this again.
		$message_parser->phpbbweb_get_submitted_attachment_data($user->data['user_id']);

		if ($webconfig['welcome_message_attachment'] && !$submit && !$preview && !$refresh)
		{
			// Do not change to SELECT *
			$sql = 'SELECT attach_id, is_orphan, attach_comment, real_filename
				FROM ' . PHPBBWEB_ATTACHMENTS_TABLE . "
				WHERE page_id = 0
					AND in_message = 0
					AND is_orphan = 0
				ORDER BY filetime DESC";
			$result = $db->sql_query($sql);
			$message_parser->attachment_data = array_merge($message_parser->attachment_data, $db->sql_fetchrowset($result));
			$db->sql_freeresult($result);
		}

		if ($submit || $preview || $refresh)
		{
			if (!check_form_key($form_name))
			{
				$error[] = $user->lang['FORM_INVALID'];
			}

			$bbcode_status		= (isset($_POST['disable_bbcode'])) ? false : true;
			$smilies_status		= (isset($_POST['disable_smilies'])) ? false : true;
			$magic_url_status	= (isset($_POST['disable_magic_url'])) ? false : true;

			$message_parser->message = $message;

			// Parse Attachments - before checksum is calculated
			$message_parser->phpbbweb_parse_attachments('fileupload', 'post', 0, $submit, $preview, $refresh, false);

			$message_parser->parse($bbcode_status, $magic_url_status, $smilies_status, $allow_img_bbcode, $allow_flash_bbcode, $allow_quote_bbcode, $allow_url_bbcode, true, 'post');

			if (sizeof($message_parser->warn_msg))
			{
				$error[] = implode('<br />', $message_parser->warn_msg);
			}

			// Now parse it for displaying
			$attachment_data = '';
			if ($preview)
			{
				$data = array(
					'mode'				=> 'welcome', 
					'id'				=> 1,
					'class'				=> 'wide',
					'subject'			=> '',
					'text'				=> (string) $message_parser->message,
					'bbcode_bitfield'	=> (string) $message_parser->bbcode_bitfield,
					'bbcode_uid'		=> (string) $message_parser->bbcode_uid,
					// Force this : main page can't be redirected ;)
				//	'redirect'			=> 0,
				//	'redirect_url'		=> '',
					'attachment'		=> (!empty($message_parser->attachment_data)) ? 1 : 0,
				);

				unset($message_parser);

				return $this->phpbbweb_generate_preview($data, 'main');
			}

			if (!sizeof($error) && $submit)
			{
				$data = array(
					'welcome_message_approved'			=> ($approved) ? 1 : 0,
					'welcome_message'					=> (string) $message_parser->message,
					'welcome_message_bbcode_uid'		=> (string) $message_parser->bbcode_uid,
					'welcome_message_bbcode_bitfield'	=> (string) $message_parser->bbcode_bitfield,
					'welcome_message_enable_bbcode'		=> ($bbcode_status) ? 1 : 0,
					'welcome_message_enable_smilies'	=> ($smilies_status) ? 1 : 0,
					'welcome_message_enable_urls'		=> ($magic_url_status) ? 1 : 0,
					'welcome_message_attachment'		=> (!empty($message_parser->attachment_data)) ? 1 : 0,
					// We always update the user ID with the last who edit it
					'owner_id'							=> $user->data['user_id'],
				);
				($reset_views) ? $data['page_views'] = 0 : false;

				foreach ($data as $config_name => $config_value)
				{
					$this->phpbbweb_set_config($config_name, $config_value);
				}

				// Submit Attachments
				$data['attachment_data'] = $message_parser->attachment_data;
				$this->phpbbweb_update_attachments($data, 0);

				trigger_error($user->lang['ACP_MESSAGE_UPDATED'] . adm_back_link($this->u_action));
			}
		}

		$attachment_data = $message_parser->attachment_data;
		$filename_data = $message_parser->filename_data;

		// Generate inline attachment select box
		posting_gen_inline_attachments($attachment_data);

		// Attachment entry
		posting_gen_attachment_entry($attachment_data, $filename_data, $allow_attachments);

		// Decode text for message display
		decode_message($message, $webconfig['welcome_message_bbcode_uid']);

		$form_enctype = (@ini_get('file_uploads') == '0' || strtolower(@ini_get('file_uploads')) == 'off' || !$config['allow_attachments']) ? '' : ' enctype="multipart/form-data"';

		$template->assign_vars(array(
			'S_EDITOR_MESSAGE'		=> true,
			'L_TITLE'				=> $user->lang[$this->page_title],
			'L_TITLE_EXPLAIN'		=> $user->lang[$this->page_title . '_EXPLAIN'],
			'U_ACTION'				=> $this->u_action . '&amp;action=' . $action,
			'UA_ACTION'				=> addslashes($this->u_action),
			'S_ERROR_MSG'			=> (sizeof($error)) ? true : false,
			'ERROR_MSG'				=> (sizeof($error)) ? implode('<br />', $error) : '',

			'S_FORM_ENCTYPE'		=> $form_enctype,
			'S_SHOW_ATTACH_BOX'		=> true,

			'PAGE_WELCOME'			=> true,
			'CURRENT_CATEGORY_ID'	=> 0,
			'PARENT_ID'				=> 0,
			

			'S_DISPLAY_VIEWS'		=> (bool) $webconfig['views_counter'],
			'S_VIEWS'				=> (int) $page_views,
			'S_NUM_VIEWS'			=> (!isset($page_views) || $page_views == 0) ? $user->lang['VIEWED_COUNT_NONE'] : (($page_views == 1) ? sprintf($user->lang['VIEWED_COUNT'], $page_views) : sprintf($user->lang['VIEWED_COUNTS'], $page_views)),
			
			'APPROVED'				=> $approved,
			'MESSAGE'				=> $message,

			'S_BBCODE_CHECKED'		=> (!$bbcode_status) ? ' checked="checked"' : '',
			'S_SMILIES_CHECKED'		=> (!$smilies_status) ? ' checked="checked"' : '',
			'S_MAGIC_URL_CHECKED'	=> (!$magic_url_status) ? ' checked="checked"' : '',

			'BBCODE_STATUS'			=> ($allow_bbcode) ? sprintf($user->lang['BBCODE_IS_ON'], '<a href="' . append_sid(PHPBB_ROOT_PATH . "faq." . PHP_EXT, 'mode=bbcode') . '">', '</a>') : sprintf($user->lang['BBCODE_IS_OFF'], '<a href="' . append_sid(PHPBB_ROOT_PATH . "faq." . PHP_EXT, 'mode=bbcode') . '">', '</a>'),
			'SMILIES_STATUS'		=> ($allow_smilies) ? $user->lang['SMILIES_ARE_ON'] : $user->lang['SMILIES_ARE_OFF'],
			'IMG_STATUS'			=> ($allow_img_bbcode) ? $user->lang['IMAGES_ARE_ON'] : $user->lang['IMAGES_ARE_OFF'],
			'FLASH_STATUS'			=> ($allow_flash_bbcode) ? $user->lang['FLASH_IS_ON'] : $user->lang['FLASH_IS_OFF'],
			'URL_STATUS'			=> ($allow_url_bbcode) ? $user->lang['URL_IS_ON'] : $user->lang['URL_IS_OFF'],

			'S_BBCODE_ALLOWED'		=> $allow_bbcode,
			'S_SMILIES_ALLOWED'		=> $allow_smilies,
			'S_LINKS_ALLOWED'		=> $allow_url_bbcode,
			'S_BBCODE_IMG'			=> $allow_img_bbcode,
			'S_BBCODE_FLASH'		=> $allow_flash_bbcode,
			'S_BBCODE_QUOTE'		=> $allow_quote_bbcode,
		));

		// Assigning custom bbcodes
	//	global $mode;
	//	$mode = POSTING_MODE;
		display_custom_bbcodes();

		// Generate smiley listing
		generate_smilies('inline', 0);
	}

	/**
	* @description: Build Frontend with supplied options
	*
	* @param: (integer)		$page_id = page identifier
	* 
	* @version: 1.0.0
	**/
	function phpbbweb_frontend($page_id)
	{
		global $db, $user, $template;
		global $webconfig;

		$this->tpl_name = 'phpbbweb/acp_phpbbweb_frontend';
		$this->page_title = 'ACP_PHPBBWEB_MANAGE';

		$error	= array();
		$submit	= (isset($_POST['update'])) ? true : false;
		$category_subject = '';
		$categoryid = 0;
		$sectionid = 0;
		$page_id = (int) $page_id;

		// Default management page
		if (!$page_id)
		{
			$navigation = $user->lang['INDEX'];
		}
		else
		{
			$navigation = '<a href="' . $this->u_action . '">' . $user->lang['INDEX'] . '</a>';

			$pages_nav = $this->get_page_branch($page_id, 'parents', 'ascending');

			foreach ($pages_nav as $row)
			{
				if ($row['page_id'] == $page_id)
				{
					$navigation .= ' -&gt; ' . $row['page_subject'];
				}
				else
				{
					$navigation .= ' -&gt; <a href="' . $this->u_action . '&amp;page_id=' . $row['page_id'] . '">' . $row['page_subject'] . '</a>';
				}
			}
		}

		$sql = 'SELECT *
			FROM ' . PHPBBWEB_PAGE_TABLE . '
			WHERE parent_id = ' . $page_id . ' AND page_type <> ' . PAGE_BLOCK . '
			ORDER BY page_order ASC';
		$result_pages = $db->sql_query($sql);

		if ($pages_row = $db->sql_fetchrow($result_pages))
		{
			do
			{
				$pageid = $pages_row['page_id'];

				$page_branch = $this->get_page_branch($pageid, 'all');

				$num_blocks = $num_sections = 0;
				foreach ($page_branch as $rows => $row)
				{
					if ($row['page_type'] == PAGE_SECTION)
					{
						$num_sections++;
					}
					else if ($row['page_type'] == PAGE_BLOCK)
					{
						$num_blocks++;
					}
				}

				$template->assign_block_vars('pages', array(
				//	'PAGE_ID'			=> $pages_row['page_id'],
					'PAGE_NAME'			=> $pages_row['page_subject'],
					'PAGE_APPROVED'		=> $pages_row['page_approved'],

					'S_IS_CAT'			=> ($pages_row['page_type'] == PAGE_CATEGORY) ? true : false,
					'S_NUM_SECTIONS'	=> (!$pages_row['parent_id']) ? (int) $num_sections : -1,
					'S_NUM_BLOCKS'		=> (int) $num_blocks,
					'S_NUM_VIEWS'		=> ($webconfig['views_counter']) ? (int) $pages_row['page_views'] : -1,
					'S_HAVE_ATTACH'		=> ($pages_row['page_attachment']) ? true : false,

					'S_AUTHOR_FULL'		=> $this->get_user($pages_row['owner_id']),
					'S_REDIRECT'		=> $pages_row['redirect'],

					'U_PAGE'			=> $this->u_action . '&amp;page_id=' . $pageid,
					'U_PAGE_DISABLE'	=> $this->u_action . '&amp;page_id=' . $pageid . '&amp;action=deactivate',
					'U_PAGE_ENABLE'		=> $this->u_action . '&amp;page_id=' . $pageid . '&amp;action=activate',
					'U_PAGE_MOVE_UP'	=> $this->u_action . '&amp;page_id=' . $pageid . '&amp;action=move_up',
					'U_PAGE_MOVE_DOWN'	=> $this->u_action . '&amp;page_id=' . $pageid . '&amp;action=move_down',
					'U_PAGE_EDIT'		=> $this->u_action . '&amp;page_id=' . $pageid . '&amp;action=edit',
					'U_PAGE_REMOVE'		=> $this->u_action . '&amp;page_id=' . $pageid . '&amp;action=remove',
				));
			}
			while ($pages_row = $db->sql_fetchrow($result_pages));
		}
		else if ($page_id)
		{
			$template->assign_vars(array(
				'S_NO_PAGES'		=> true,

				'U_EDIT'			=> $this->u_action . '&amp;page_id=' . $page_id . '&amp;action=edit',
				'U_DELETE'			=> $this->u_action . '&amp;page_id=' . $page_id . '&amp;action=remove',
			));
		}
		$db->sql_freeresult($result_pages);

		// Blocks
		$sql = 'SELECT *
			FROM ' . PHPBBWEB_PAGE_TABLE . '
			WHERE parent_id = ' . $page_id . ' AND page_type = ' . PAGE_BLOCK . '
			ORDER BY page_order ASC';
		$result_blocks = $db->sql_query($sql);

		while ($row_block = $db->sql_fetchrow($result_blocks))
		{
			$blockid = $row_block['page_id'];

			$template->assign_block_vars('blocks', array(
				'BLOCK_ID'			=> $blockid,
				'BLOCK_NAME'		=> $row_block['page_subject'],
				'BLOCK_APPROVED'	=> $row_block['page_approved'],

				'U_BLOCK_DISABLE'	=> $this->u_action . '&amp;page_id=' . $blockid . '&amp;action=deactivate',
				'U_BLOCK_ENABLE'	=> $this->u_action . '&amp;page_id=' . $blockid . '&amp;action=activate',
				'U_BLOCK_MOVE_UP'	=> $this->u_action . '&amp;page_id=' . $blockid . '&amp;action=move_up',
				'U_BLOCK_MOVE_DOWN'	=> $this->u_action . '&amp;page_id=' . $blockid . '&amp;action=move_down',
				'U_BLOCK_EDIT'		=> $this->u_action . '&amp;page_id=' . $blockid . '&amp;action=edit',
				'U_BLOCK_REMOVE'	=> $this->u_action . '&amp;page_id=' . $blockid . '&amp;action=remove',
			));
		}
		$db->sql_freeresult($result_blocks);

		$template->assign_vars(array(
			'S_FRONTEND'	=> true,
			'L_TITLE'		=> $user->lang[$this->page_title],
			'L_EXPLAIN'		=> $user->lang[$this->page_title . '_EXPLAIN'],
			'NAVIGATION'	=> $navigation,

			'U_ACTION'		=> $this->u_action,
			'U_BACK'		=> ($page_id) ? $this->u_action : '',
			'U_SYNC'		=> $this->u_action . '&amp;action=sync',

			'CURRENT_CATEGORY_ID'	=> $page_id,
			'PAGE_CATEGORY'			=> PAGE_CATEGORY,
			'PAGE_SECTION'			=> PAGE_SECTION,
			'PAGE_BLOCK'			=> PAGE_BLOCK,
		));

		$this->phpbbbweb_need_icons();
	}

	/**
	* @description: Enable or Disable a category or section
	*
	* @param: (integer)		$id = the module id
	* @param: (string)		$mode = the module mode
	* @param: (string)		$action
	* @param: (integer)		$page_id = page identifier
	* 
	* @version: 1.0.0
	**/
	function phpbbweb_moderate($id, $mode, $action, $page_id)
	{
		global $db, $user, $template;

		$page_id = (int) $page_id;

		if (!$page_id)
		{
			trigger_error($user->lang['NO_PAGE'] . adm_back_link($this->u_action), E_USER_WARNING);
		}

		$page_data = $this->get_page_data($page_id);

		if (!$page_data)
		{
			trigger_error($user->lang['NO_PAGE'] . adm_back_link($this->u_action), E_USER_WARNING);
		}

		if (confirm_box(true))
		{
			$sql = 'UPDATE ' . PHPBBWEB_PAGE_TABLE . ' 
				SET page_approved = ' . (($action == 'activate') ? 1 : 0) . '
				WHERE page_id = ' . $page_id;
			$db->sql_query($sql);
		}
		else
		{
			$confirm_msg = ($action == 'activate') ? 'ACP_CATEGORY_DISABLE' : 'ACP_CATEGORY_ENABLE';
			$confirm_msg = (!empty($user->lang[$confirm_msg])) ? $confirm_msg : 'CONFIRM_OPERATION';
			confirm_box(false, $user->lang[$confirm_msg], build_hidden_fields(array(
				'i'			=> $id,
				'mode'		=> $mode,
				'action'	=> $action,
				'page_id'	=> $page_id,
			)));
		}

		return $page_data['parent_id'];
	}

	/**
	* @description: Move categories or section position
	*
	* @param: (integer)		$page_id = page identifier
	* @param: (string)		$action = move_up|move_down
	* 
	* @version: 1.0.0
	**/
	function phpbbweb_move($page_id, $action)
	{
		global $db, $user;

		$page_id = (int) $page_id;

		if (!$page_id)
		{
			trigger_error($user->lang['NO_PAGE'] . adm_back_link($this->u_action), E_USER_WARNING);
		}

		$page_data = $this->get_page_data($page_id);

		if (!$page_data)
		{
			trigger_error($user->lang['NO_PAGE'] . adm_back_link($this->u_action), E_USER_WARNING);
		}

		$current_type = $page_data['page_type'];
		$current_parent = $page_data['parent_id'];

		// Get current order id...
		$sql = 'SELECT page_order as current_order 
				FROM ' . PHPBBWEB_PAGE_TABLE . " 
				WHERE page_id = $page_id";
		$result = $db->sql_query($sql);
		$current_order = (int) $db->sql_fetchfield('current_order');
		$db->sql_freeresult($result);

		if ($current_order == 0 && $action == 'move_up')
		{
			break;
		}

		// on move_down, switch position with next order_id...
		// on move_up, switch position with previous order_id...
		$switch_order_id = ($action == 'move_down') ? $current_order + 1 : $current_order - 1;

		$sql = "UPDATE " . PHPBBWEB_PAGE_TABLE . " 
				SET page_order = $current_order 
				WHERE (page_type = $current_type AND parent_id = $current_parent AND page_order = $switch_order_id) 
					AND page_id <> $page_id";
		$db->sql_query($sql);

		// Only update the other entry too if the previous entry got updated
		if ($db->sql_affectedrows())
		{
			$sql = "UPDATE " . PHPBBWEB_PAGE_TABLE . " 
					SET page_order = $switch_order_id 
					WHERE (page_type = $current_type AND parent_id = $current_parent AND page_order = $current_order) 
						AND page_id = $page_id";
			$db->sql_query($sql);
		}

		return $current_parent;
	}
	
	/**
	* @description: Add/Edit categories or section page content
	*
	* @param: (integer)		$page_id = page identifier
	* @param: (string)		$action = edit|add
	* 
	* @version: 1.0.4
	**/
	function phpbbweb_editor($page_id, $action)
	{
		global $db, $user, $template;
		global $config, $webconfig;

		$error			= array();
		$submit			= (isset($_POST['update'])) ? true : false;
		$preview		= request_var('preview', 0);
		$cancel			= (isset($_POST['cancel'])) ? true : false;
		$refresh		= (isset($_POST['add_file']) || isset($_POST['delete_file'])) ? true : false;
		$page_id		= (int) $page_id;
		// Show attachment box for adding attachments if true
		$allow_attachments = $config['allow_attachments'];

		$user->add_lang('posting');
		$this->page_title = 'ACP_MESSAGE_EDITOR_TITLE';
		$this->tpl_name = 'phpbbweb/acp_phpbbweb_editor';

		$form_name = 'phpbbweb_editor';
		add_form_key($form_name);

		include_once(PHPBB_ROOT_PATH . 'includes/functions_posting.' . PHP_EXT);
		include_once(PHPBB_ROOT_PATH . 'includes/functions_display.' . PHP_EXT);

		// HTML, BBCode, Smilies, Images and Flash status
		$allow_bbcode		= ($config['allow_bbcode'] && $user->optionget('bbcode'))	? true : false;
		$allow_smilies		= ($config['allow_smilies'] && $user->optionget('smilies'))	? true : false;
		$allow_img_bbcode	= ($allow_bbcode) ? true : false;
		$allow_url_bbcode	= ($config['allow_post_links']) ? true : false;
		$allow_flash_bbcode	= ($allow_bbcode && $config['allow_post_flash']) ? true : false;
		$allow_quote_bbcode	= ($allow_bbcode) ? true : false;

		$bbcode_uid = '';
		$add = ($action == 'add') ? true : false;

		if (!$page_id && !$add)
		{
			trigger_error($user->lang['NO_PAGE'] . adm_back_link($this->u_action), E_USER_WARNING);
		}

		$page_data = $this->get_page_data($page_id, $add);

		$bbcode_uid = $page_data['bbcode_uid'];
		$page_views = $page_data['page_views'];
		$message_attachment = $page_data['page_attachment'];

		// HTML, BBCode, Smilies, Images and Flash status for this Category
		$bbcode_status		= ($allow_bbcode) ? (bool) $page_data['enable_bbcode'] : false;
		$smilies_status		= ($allow_smilies) ? (bool) $page_data['enable_smilies'] : false;
		$magic_url_status	= ($allow_url_bbcode) ? (bool) $page_data['enable_magic_url'] : false;
		$approved			= request_var('approved', (bool) $page_data['page_approved']);
		$global_block		= request_var('global_block', (bool) $page_data['global_block']);

		$message			= utf8_normalize_nfc(request_var('message', (string) $page_data['page_text'], true));
		$subject			= utf8_normalize_nfc(request_var('page_subject', $page_data['page_subject'], true));
		$description		= utf8_normalize_nfc(request_var('page_description', (string) $page_data['page_description'], true));
		$class				= utf8_normalize_nfc(request_var('page_class', $page_data['page_class'], true));
		$redirect			= request_var('redirect', (int) $page_data['redirect']);
		$redirect_url		= request_var('redirect_url', (string) $page_data['redirect_url']);
		$redirect_open		= request_var('redirect_open', (int) $page_data['redirect_open']);
		$reset_views		= request_var('reset_views', 0); // (string) $page_data['reset_views']);
		$page_type			= request_var('page_type', (int) $page_data['page_type']);
		$parent_id			= request_var('parent_id', (int) $page_data['parent_id']);

		//	include_once(PHPBB_ROOT_PATH . 'includes/message_parser.' . PHP_EXT);
		$message_parser = new message_parse($message);

		// Always check if the submitted attachment data is valid and belongs to the user.
		// Further down (especially in submit_post()) we do not check this again.
		$message_parser->phpbbweb_get_submitted_attachment_data($user->data['user_id']);

		if ($message_attachment && !$submit && !$preview && !$refresh)
		{
			// Do not change to SELECT *
			$sql = 'SELECT attach_id, is_orphan, attach_comment, real_filename
				FROM ' . PHPBBWEB_ATTACHMENTS_TABLE . "
				WHERE page_id = $page_id
					AND in_message = 0
					AND is_orphan = 0
				ORDER BY filetime DESC";
			$result = $db->sql_query($sql);
			$message_parser->attachment_data = array_merge($message_parser->attachment_data, $db->sql_fetchrowset($result));
			$db->sql_freeresult($result);
		}

		$childrens = $this->get_page_branch($page_id, 'childrens', 'descending', false);

		// Sections move options
		if ($action == 'edit' && $page_data['page_type'] == PAGE_CATEGORY)
		{
			$template->assign_vars(array(
				'S_HAVE_SECTIONS'			=> sizeof($childrens) ? true : false,
				'S_MOVE_CATEGORY_OPTIONS'	=> $this->make_page_select($page_id, (($page_data['parent_id']) ? false : true)),
			));
		}

		if ($submit || $preview || $refresh)
		{
			if (!check_form_key($form_name))
			{
				$error[] = $user->lang['FORM_INVALID'];
			}

			$bbcode_status		= (isset($_POST['disable_bbcode'])) ? false : true;
			$smilies_status		= (isset($_POST['disable_smilies'])) ? false : true;
			$magic_url_status	= (isset($_POST['disable_magic_url'])) ? false : true;

			$message_parser->message = $message;

			// Parse Attachments - before checksum is calculated
			$message_parser->phpbbweb_parse_attachments('fileupload', 'post', 0, $submit, $preview, $refresh, false);

			$message_parser->parse($bbcode_status, $magic_url_status, $smilies_status, $allow_img_bbcode, $allow_flash_bbcode, $allow_quote_bbcode, $allow_url_bbcode, true, 'phpbbweb');

			if (sizeof($message_parser->warn_msg))
			{
				$error[] = implode('<br />', $message_parser->warn_msg);
			}

			// Parse subject
			if ($submit && utf8_clean_string($subject) === '')
			{
				$error[] = $user->lang['NO_SUBJECT'];
			}

			// We only allow empty categories but not sections ;)
			if (!$parent_id && !$redirect_url && !$message_parser->message)
			{
				$error[] = $user->lang['NO_SECTION_DATA'];
			}

			// Now parse it for displaying
			$attachment_data = '';
			if ($preview)
			{
				$data = array(
					'mode'				=> ($page_type == PAGE_CATEGORY) ? 'category' : 'section',
					'id'				=> ($page_type == PAGE_CATEGORY) ? $page_id : 0,
					'class'				=> $class,
					'subject'			=> $subject,
					'text'				=> (string) $message_parser->message,
					'bbcode_bitfield'	=> (string) $message_parser->bbcode_bitfield,
					'bbcode_uid'		=> (string) $message_parser->bbcode_uid,
					// Force this : main page can't be redirected ;)
				//	'redirect'			=> 0,
				//	'redirect_url'		=> '',
					'attachment'		=> (!empty($message_parser->attachment_data)) ? 1 : 0,
				);

				unset($message_parser);

				$mode = ($page_type == PAGE_CATEGORY) ? 'main' : (($page_type == PAGE_SECTION) ? 'section' : 'block');
				return $this->phpbbweb_generate_preview($data, $mode);
			}

			if (!sizeof($error) && $submit)
			{
				$data = array(
				//	'page_id'			=> 0,	// MEDIUMINT(8)
					'parent_id'			=> ($page_type == PAGE_CATEGORY) ? PAGE_CATEGORY : $parent_id,
				//	'page_order'		=> 0,	// MEDIUMINT(8)
					'page_subject'		=> $subject,
					'page_description'	=> $description,
					'page_class'		=> $class,
					'page_approved'		=> ($approved) ? 1 : 0,
					'global_block'		=> ($page_type == PAGE_BLOCK && $global_block) ? 1 : 0,
					'page_text'			=> (string) $message_parser->message,
					'enable_bbcode'		=> ($bbcode_status) ? 1 : 0,
					'enable_smilies'	=> ($smilies_status) ? 1 : 0,
					'enable_magic_url'	=> ($magic_url_status) ? 1 : 0,
					'bbcode_bitfield'	=> (string) $message_parser->bbcode_bitfield,
					'bbcode_uid'		=> (string) $message_parser->bbcode_uid,
				//	'page_views'		=> 0,	// MEDIUMINT(8)
					// We always update the user ID with the last who edit it
					'owner_id'			=> $user->data['user_id'],
					// We always update the date
					'page_time'			=> time(),
					'redirect'			=> $redirect,
					'redirect_url'		=> $redirect_url,
					'redirect_open'		=> $redirect_open,
					'page_attachment'	=> (!empty($message_parser->attachment_data)) ? 1 : 0,
					'page_type'			=> $page_type,
					'is_orphan'			=> 0,
				);
				($reset_views) ? $data['page_views'] = 0 : false;

				// Add the new Category
				if ($action == 'add')
				{
					// We need some extra data when add 
					$data['page_id'] = $this->get_new_id();
					$data['page_order'] = $this->get_new_order($parent_id, $page_type);

					$sql = 'INSERT INTO ' . PHPBBWEB_PAGE_TABLE . $db->sql_build_array('INSERT', $data);
					$db->sql_query($sql);

					// Submit Attachments
					$data['attachment_data'] = $message_parser->attachment_data;
					$this->phpbbweb_update_attachments($data, $data['page_id']);

					trigger_error($user->lang['ACP_MESSAGE_UPDATED'] . adm_back_link($this->u_action . '&amp;page_id=' . $data['parent_id']));
				}

				if ($action == 'edit')
				{
					$msg = '';
					// We are turning a category into a link - but need to decide what to do with the subforums.
					$action_sections = (sizeof($childrens)) ? request_var('action_sections', '') : '';
					$sections_to_ids = (sizeof($childrens)) ? request_var('sections_to_id', 0) : 0;

					if ($action_sections == 'delete' || $action_sections == 'move')
					{
						$childrens = $this->get_page_branch($page_id, 'childrens', 'descending', false);

						$sections_ids = array();
						foreach ($childrens as $_row)
						{
							$sections_ids[] = $_row['page_id'];
						}

						if ($action_sections == 'delete')
						{
							if (sizeof($sections_ids))
							{
								// Delete sectins under this category
								$sql = 'DELETE FROM ' . PHPBBWEB_PAGE_TABLE . '
										WHERE ' . $db->sql_in_set('page_id', $sections_ids);
								$db->sql_query($sql);

								// Delete attach under this deleted sections
								$this->phpbbweb_delete_attachments($sections_ids);
							}
							$msg = $user->lang['ACP_CATEGORY_DELETED'];
						}

						if ($action_sections == 'move')
						{
							if (!$sections_to_ids)
							{
								trigger_error($user->lang['ACP_CATEGORY_NO_DESTINATION_FOUND'] . adm_back_link($this->u_action . '&amp;page_id=' . $parent_id));
							}

							$sql = 'UPDATE ' . PHPBBWEB_PAGE_TABLE . "
									SET parent_id = $sections_to_ids
									WHERE " . $db->sql_in_set('page_id', $sections_ids);
							$db->sql_query($sql);

							$msg = $user->lang['ACP_PAGE_MOVED'];
						//	trigger_error($user->lang['ACP_CATEGORY_MOVED'] . adm_back_link($this->u_action . '&amp;page_id=' . $parent_id));
						}
					}

					if ($data['parent_id'] != $page_data['parent_id'])
					{
						$data['page_order'] = $this->get_new_order($parent_id, $page_type);						
					}

					$sql = 'UPDATE ' . PHPBBWEB_PAGE_TABLE . '
							SET ' . $db->sql_build_array('UPDATE', $data) . '
							WHERE page_id = ' . $page_id;
					$result = $db->sql_query($sql);

					// Submit Attachments
					$data['attachment_data'] = $message_parser->attachment_data;
					$this->phpbbweb_update_attachments($data, $page_id);

					$msg = $user->lang['ACP_MESSAGE_UPDATED'] . '<br />' . $msg;
					trigger_error($msg . adm_back_link($this->u_action . '&amp;page_id=' . $parent_id));
				}
			}
		}

		$attachment_data = $message_parser->attachment_data;
		$filename_data = $message_parser->filename_data;

		// Generate inline attachment select box
		posting_gen_inline_attachments($attachment_data);

		// Attachment entry
		posting_gen_attachment_entry($attachment_data, $filename_data, $allow_attachments);

		// Decode text for message display
		decode_message($message, $bbcode_uid);

		$page_type_options = '';
		$page_type_ary = array(PAGE_CATEGORY => 'TYPE_CATEGORY', PAGE_SECTION => 'TYPE_SECTION', PAGE_BLOCK => 'TYPE_BLOCK');
		foreach ($page_type_ary as $value => $lang)
		{
			$page_type_options .= '<option value="' . $value . '"' . (($value == $page_data['page_type']) ? ' selected="selected"' : '') . '>' . $user->lang[$lang] . '</option>';
		}

		if ($action == 'add')
		{
			$this->page_title = ($page_data['page_type'] == PAGE_CATEGORY) ? 'ACP_MESSAGE_CREATE_CATEGORY_TITLE' : (($page_data['page_type'] == PAGE_SECTION) ? 'ACP_MESSAGE_CREATE_SECTION_TITLE' : 'ACP_MESSAGE_CREATE_BLOCK_TITLE');
		}
		else
		{
			$this->page_title = ($page_data['page_type'] == PAGE_CATEGORY) ? 'ACP_MESSAGE_EDIT_CATEGORY_TITLE' : (($page_data['page_type'] == PAGE_SECTION) ? 'ACP_MESSAGE_EDIT_SECTION_TITLE' : 'ACP_MESSAGE_EDIT_BLOCK_TITLE');
		}

		$form_enctype = (@ini_get('file_uploads') == '0' || strtolower(@ini_get('file_uploads')) == 'off' || !$config['allow_attachments']) ? '' : ' enctype="multipart/form-data"';

		$old_page_type = $page_data['page_type'];

		$template->assign_vars(array(
			'S_EDITOR_MESSAGE'		=> true,
			'L_TITLE'				=> $user->lang[$this->page_title],
		//	'L_EXPLAIN'				=> $user->lang[$this->page_title . '_EXPLAIN'],
			'U_BACK'				=> $this->u_action . '&amp;page_id=' . $parent_id, //$page_id,
			'U_ACTION'				=> $this->u_action . '&amp;action=' . $action,
			'UA_ACTION'				=> addslashes($this->u_action . '&amp;action=' . $action),
			'S_ERROR_MSG'			=> (sizeof($error)) ? true : false,
			'ERROR_MSG'				=> (sizeof($error)) ? implode('<br />', $error) : '',

			'S_FORM_ENCTYPE'		=> ($page_data['page_type'] == PAGE_BLOCK) ? '' : $form_enctype,
			'S_SHOW_ATTACH_BOX'		=> ($page_data['page_type'] == PAGE_BLOCK) ? false : true,

		// used in categories, sections, and blocks - Start
			'PAGE_ID'				=> $page_id,
			'PARENT_ID'				=> $page_data['parent_id'],

			'S_PAGE_ORIG_CATEGORY'	=> (isset($old_page_type) && $old_page_type == PAGE_CATEGORY) ? true : false,
			'S_PAGE_ORIG_SECTION'	=> (isset($old_page_type) && $old_page_type == PAGE_SECTION) ? true : false,
			'S_PAGE_ORIG_BLOCK'		=> (isset($old_page_type) && $old_page_type == PAGE_BLOCK) ? true : false,

			'PAGE_CATEGORY'			=> PAGE_CATEGORY,
			'S_PAGE_CATEGORY'		=> ($page_data['page_type'] == PAGE_CATEGORY) ? true : false,
			'PAGE_SECTION'			=> PAGE_SECTION,
			'S_PAGE_SECTION'		=> ($page_data['page_type'] == PAGE_SECTION) ? true : false,
			'PAGE_BLOCK'			=> PAGE_BLOCK,
			'S_PAGE_BLOCK'			=> ($page_data['page_type'] == PAGE_BLOCK) ? true : false,
			'BLOCK_GLOBAL'			=> $global_block,

			'S_PAGE_TYPE'			=> $page_data['page_type'],
			'S_PAGE_TYPE_OPTIONS'	=> $page_type_options,
//			'S_PARENT_OPTIONS'		=> $this->make_page_select((($add) ? $parent_id : $page_id), $page_data['page_type']),
			'S_PARENT_OPTIONS'		=> $this->make_page_select((($add || $page_data['page_type'] != PAGE_CATEGORY) ? $parent_id : $page_id), $page_data['page_type']),
			'PARENT_ID'				=> $parent_id,
			'SUBJECT'				=> $subject,
			'S_DISPLAY_DESCRIPTION'	=> ($webconfig['meta_description_dynamic'] && $page_data['page_type'] != PAGE_BLOCK) ? true : false,
			'DESCRIPTION'			=> $description,
			'CLASS'					=> $class,
			'REDIRECT'				=> $redirect,
			'REDIRECT_URL'			=> $redirect_url,
			'REDIRECT_OPEN'			=> $this->radio_options_redirect($redirect_open, false),

		// used in categories, sections, and blocks - End

			'S_DISPLAY_VIEWS'		=> (bool) $webconfig['views_counter'],
			'S_VIEWS'				=> (int) $page_views,
			'S_NUM_VIEWS'			=> (!isset($page_views) || $page_views == 0) ? $user->lang['VIEWED_COUNT_NONE'] : (($page_views == 1) ? sprintf($user->lang['VIEWED_COUNT'], $page_views) : sprintf($user->lang['VIEWED_COUNTS'], $page_views)),
			'APPROVED'				=> $approved,
			'MESSAGE'				=> $message,

			'S_BBCODE_CHECKED'		=> (!$bbcode_status) ? ' checked="checked"' : '',
			'S_SMILIES_CHECKED'		=> (!$smilies_status) ? ' checked="checked"' : '',
			'S_MAGIC_URL_CHECKED'	=> (!$magic_url_status) ? ' checked="checked"' : '',

			'BBCODE_STATUS'			=> ($allow_bbcode) ? sprintf($user->lang['BBCODE_IS_ON'], '<a href="' . append_sid(PHPBB_ROOT_PATH . "faq." . PHP_EXT, 'mode=bbcode') . '">', '</a>') : sprintf($user->lang['BBCODE_IS_OFF'], '<a href="' . append_sid(PHPBB_ROOT_PATH . "faq." . PHP_EXT, 'mode=bbcode') . '">', '</a>'),
			'SMILIES_STATUS'		=> ($allow_smilies) ? $user->lang['SMILIES_ARE_ON'] : $user->lang['SMILIES_ARE_OFF'],
			'IMG_STATUS'			=> ($allow_img_bbcode) ? $user->lang['IMAGES_ARE_ON'] : $user->lang['IMAGES_ARE_OFF'],
			'FLASH_STATUS'			=> ($allow_flash_bbcode) ? $user->lang['FLASH_IS_ON'] : $user->lang['FLASH_IS_OFF'],
			'URL_STATUS'			=> ($allow_url_bbcode) ? $user->lang['URL_IS_ON'] : $user->lang['URL_IS_OFF'],

			'S_BBCODE_ALLOWED'		=> $allow_bbcode,
			'S_SMILIES_ALLOWED'		=> $allow_smilies,
			'S_LINKS_ALLOWED'		=> $allow_url_bbcode,
			'S_BBCODE_IMG'			=> $allow_img_bbcode,
			'S_BBCODE_FLASH'		=> $allow_flash_bbcode,
			'S_BBCODE_QUOTE'		=> $allow_quote_bbcode,
		));

		// Assigning custom bbcodes
	//	global $mode;
	//	$mode = POSTING_MODE;
		display_custom_bbcodes();

		// Generate smiley listing
		generate_smilies('inline', 0);
	}

	/**
	* Write secure_allow_deny config field
	*/
	function radio_options_redirect($value, $key = '')
	{
		$radio_ary = array(2 => 'ACP_REDIRECT_POPWINDOWS', 1 => 'ACP_REDIRECT_NEWWINDOWS', 0 => 'ACP_REDIRECT_SAMEWINDOWS');

		return h_radio('redirect_open', $radio_ary, $value, 'redirect_open', $key);
	}

	/**
	* @description: Remove a category/Section/Block
	*
	* @param: (integer)		$page_id = page identifier
	* 
	* @version: 1.0.0
	**/
	function phpbbweb_remove($page_id)
	{
		global $db, $user, $template;

		$this->tpl_name = 'phpbbweb/acp_phpbbweb_remove';
		$this->page_title = 'ACP_CATEGORY_DELETE';
		$form_key = 'phpbbweb_remove';
		add_form_key($form_key);

		$error = array();
		$submit = (isset($_POST['update'])) ? true : false;

		$page_id = (int) $page_id;

		if (!$page_id)
		{
			trigger_error($user->lang['NO_PAGE'] . adm_back_link($this->u_action), E_USER_WARNING);
		}

		$page_data = $this->get_page_data($page_id);

		if ($submit)
		{
			if (!check_form_key($form_key))
			{
				$error[] = $user->lang['FORM_INVALID'];
			}

			$msg = '';
			// We are turning a category into a section - but need to decide what to do with the sections on it.
			$action_sections = request_var('action_sections', '');
			$sections_to_ids = request_var('sections_to_id', 0);

			$db->sql_transaction('begin');

			$childrens = $this->get_page_branch($page_id, 'childrens', 'descending', false);

			$sections_ids = array();
			foreach ($childrens as $_row)
			{
				$sections_ids[] = $_row['page_id'];
			}

			if ($action_sections == 'delete')
			{
				if (sizeof($sections_ids))
				{
					// Delete childrens under this page
					$sql = 'DELETE FROM ' . PHPBBWEB_PAGE_TABLE . '
							WHERE ' . $db->sql_in_set('page_id', $sections_ids);
					$db->sql_query($sql);
				}

				// Detete this page
				$sql = 'DELETE FROM ' . PHPBBWEB_PAGE_TABLE . '
					WHERE ' . $db->sql_in_set('page_id', $page_id);
				$db->sql_query($sql);

				// Delete all attach for this page and all under it
				$sections_ids[] = $page_id;
				$this->phpbbweb_delete_attachments($sections_ids);

				$msg = 'ACP_PAGE_DELETED';
			}

			if ($action_sections == 'move')
			{
				if (!$sections_to_ids)
				{
					trigger_error($user->lang['ACP_CATEGORY_NO_DESTINATION_FOUND'] . adm_back_link($this->u_action . '&amp;page_id=' . $parent_id));
				}	

				$sql = 'UPDATE ' . PHPBBWEB_PAGE_TABLE . "
						SET parent_id = $sections_to_ids
						WHERE " . $db->sql_in_set('page_id', $sections_ids);
				$db->sql_query($sql);

				$msg = 'ACP_PAGE_MOVED';
			}

			$db->sql_transaction('commit');
			
			trigger_error($user->lang[$msg] . adm_back_link($this->u_action));
		}

		// We need to decide what will happen within the sections (if it have)

		// This categorie have sections ?
		$page_branch = $this->get_page_branch($page_id, 'childrens', 'descending', false);

		$num_blocks = $num_sections = 0;
		foreach ($page_branch as $rows => $row)
		{
			if ($row['page_id'] == $page_id)
			{
				continue;
			}
			if ($row['page_type'] == PAGE_SECTION)
			{
				$num_sections++;
			}
			else if ($row['page_type'] == PAGE_BLOCK)
			{
				$num_blocks++;
			}
		}

		$page_select = $this->make_page_select($page_id, PAGE_CATEGORY);

		$num_child = $num_blocks + $num_sections;
		
		$this->page_title = ($page_data['page_type'] == PAGE_CATEGORY) ? 'ACP_CATEGORY_DELETE' : (($page_data['page_type'] == PAGE_SECTION) ? 'ACP_SECTION_DELETE' : 'ACP_BLOCK_DELETE');

		$lang_subject = ($page_data['page_type'] == PAGE_CATEGORY) ? 'ACP_CATEGORY_NAME' : (($page_data['page_type'] == PAGE_SECTION) ? 'ACP_SECTION_NAME' : 'ACP_BLOCK_TITLE');

		$lang_delete = ($page_data['page_type'] == PAGE_CATEGORY) ? 'ACP_CATEGORY_DELETE' : (($page_data['page_type'] == PAGE_SECTION) ? 'ACP_SECTION_DELETE' : 'ACP_BLOCK_DELETE');

		$template->assign_vars(array(
			'S_DELETE'		=> true,
			'L_TITLE'		=> $user->lang[$this->page_title],
			'U_BACK'		=> $this->u_action,
			'U_ACTION'		=> $this->u_action . '&amp;page_id=' . $page_id . '&amp;action=remove',
			'S_ERROR_MSG'	=> (sizeof($error)) ? true : false,
			'ERROR_MSG'		=> (sizeof($error)) ? implode('<br />', $error) : '',

			'L_ACP_DELETE'				=> $user->lang[$lang_delete],
			'L_ACP_SUBJECT'				=> $user->lang[$lang_subject],// . "(num_child=$num_child)",
			'PAGE_SUBJECT'				=> $page_data['page_subject'],
			'S_HAVE_CHILD'				=> ($num_child) ? true : false,
			'S_MOVE_CATEGORY_OPTIONS'	=> $page_select,
		));
	}

	/**
	* @description: Submit Attachments
	*
	* @param unknown_type $data
	* @param: (integer)		$page_id = page identifier
	* 
	* @version: 1.0.1
	**/
	function phpbbweb_update_attachments(&$data, $page_id)
	{
		global $db;
		global $phpbb_root_path, $config;

		// Submit Attachments
		if (!empty($data['attachment_data'])/* && $page_id*/)
		{
			$space_taken = $files_added = 0;
			$orphan_rows = array();

			foreach ($data['attachment_data'] as $pos => $attach_row)
			{
				$orphan_rows[(int) $attach_row['attach_id']] = array();
			}

			if (sizeof($orphan_rows))
			{
				$sql = 'SELECT attach_id, filesize, physical_filename
					FROM ' . PHPBBWEB_ATTACHMENTS_TABLE . '
					WHERE ' . $db->sql_in_set('attach_id', array_keys($orphan_rows)) . '
						AND is_orphan = 1
						AND poster_id = ' . $data['owner_id'];
				$result = $db->sql_query($sql);

				$orphan_rows = array();
				while ($row = $db->sql_fetchrow($result))
				{
					$orphan_rows[$row['attach_id']] = $row;
				}
				$db->sql_freeresult($result);
			}

			foreach ($data['attachment_data'] as $pos => $attach_row)
			{
				if ($attach_row['is_orphan'] && !isset($orphan_rows[$attach_row['attach_id']]))
				{
					continue;
				}

				if (!$attach_row['is_orphan'])
				{
					// update entry in db if attachment already stored in db and filespace
					$sql = 'UPDATE ' . PHPBBWEB_ATTACHMENTS_TABLE . "
						SET attach_comment = '" . $db->sql_escape($attach_row['attach_comment']) . "'
						WHERE attach_id = " . (int) $attach_row['attach_id'] . '
							AND is_orphan = 0';
					$db->sql_query($sql);
				}
				else
				{
					// insert attachment into db
					if (!@file_exists($phpbb_root_path . $config['upload_path'] . '/' . utf8_basename($orphan_rows[$attach_row['attach_id']]['physical_filename'])))
					{
						continue;
					}

					$space_taken += $orphan_rows[$attach_row['attach_id']]['filesize'];
					$files_added++;

					$attach_sql = array(
						'page_id'			=> $page_id,
						'is_orphan'			=> 0,
						'poster_id'			=> $data['owner_id'],
						'attach_comment'	=> $attach_row['attach_comment'],
					);

					$sql = 'UPDATE ' . PHPBBWEB_ATTACHMENTS_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $attach_sql) . '
						WHERE attach_id = ' . $attach_row['attach_id'] . '
							AND is_orphan = 1';
					$db->sql_query($sql);
				}
			}
		}
	}
	
	/**
	* Delete Attachments
	* 
	* @param string $mode can be: post|message|topic|attach|user
	* @param mixed $ids can be: post_ids, message_ids, topic_ids, attach_ids, user_ids
	* @param bool $resync set this to false if you are deleting posts or topics
	**/
	function phpbbweb_delete_attachments($ids)
	{
		global $db, $config;

		// 0 is as bad as an empty array
		if (empty($ids))
		{
			return false;
		}

		if (is_array($ids))
		{
			$ids = array_unique($ids);
			$ids = array_map('intval', $ids);
		}
		else
		{
			$ids = array((int) $ids);
		}

		$physical = array();

		// Collect ids for later use if we need to touch remaining entries (if resync is enabled)
		$sql = 'SELECT * 
				FROM ' . PHPBBWEB_ATTACHMENTS_TABLE . '
				WHERE ' . $db->sql_in_set('page_id', $ids);
		$result = $db->sql_query($sql);

		while ($row = $db->sql_fetchrow($result))
		{
			$physical[] = array('filename' => $row['physical_filename'], 'thumbnail' => $row['thumbnail'], 'filesize' => $row['filesize'], 'is_orphan' => $row['is_orphan']);
		}
		$db->sql_freeresult($result);

		// Delete attachments from filesystem
		$space_removed = $files_removed = 0;
		foreach ($physical as $file_ary)
		{
			if (phpbb_unlink($file_ary['filename'], 'file', true))
			{
				// Only non-orphaned files count to the file size
				$space_removed += $file_ary['filesize'];
				$files_removed++;
			}

			if ($file_ary['thumbnail'])
			{
				phpbb_unlink($file_ary['filename'], 'thumbnail', true);
			}
		}

		// Delete attachments
		$sql = 'DELETE FROM ' . PHPBBWEB_ATTACHMENTS_TABLE . '
			WHERE ' . $db->sql_in_set('page_id', $ids);
		$db->sql_query($sql);
		$num_deleted = $db->sql_affectedrows();

		if (!$num_deleted)
		{
			return 0;
		}

		return $num_deleted;
	}

	/**
	* @description: Resynchronise category/Section/Block/attachment 
	*	We check for sections without a valid parent category
	* 	We check for blocks without a valid parent section or category
	* 	We check for the attach flag
	* 	we re-order Section and Block order
	* 	we check for attachment without a parent
	* @version: 1.0.2
	**/
	function phpbbweb_sync()
	{
		global $db, $user;

		$category_row = array();
		$section_row = $orphan_sections = array();
		$bock_row = $orphan_blocks = array();
		$sql_category = 'SELECT page_id, parent_id, page_type, page_order, is_orphan, page_attachment, page_subject 
				FROM ' . PHPBBWEB_PAGE_TABLE . ' 
				ORDER BY page_order ASC';
		$result_category = $db->sql_query($sql_category);
		while ($row = $db->sql_fetchrow($result_category))
		{
			// Get all categories
			if ($row['page_type'] == PAGE_CATEGORY)
			{
				$category_row[$row['page_id']] = $row;
			}
			// Get all sections
			if ($row['page_type'] == PAGE_SECTION)
			{
				$section_row[$row['page_id']] = $row;
			}
			// Get all bocks
			if ($row['page_type'] == PAGE_BLOCK)
			{
				$bock_row[$row['page_id']] = $row;
			}
		}
		$db->sql_freeresult($result_category);

		// Get all attachments
		$attach_row = $orphan_attachments = array();
		$sql_attach = 'SELECT *
				FROM ' . PHPBBWEB_ATTACHMENTS_TABLE . '
				ORDER BY attach_id ASC';
		$result_attach = $db->sql_query($sql_attach);
		while ($row = $db->sql_fetchrow($result_attach))
		{
		//	$attach_row[$row['attach_id']] = $row;
			$attach_row[$row['page_id']] = $row;
		}
		$db->sql_freeresult($result_attach);

		// Going through every category and section, re-ordering and check for orphans - Start
		foreach ($category_row as $categories => $category)
		{
			// No attachments exist, but page table thinks they do so go ahead and reset page_attachment flags
			if ($category['page_attachment'] && !isset($attach_row[$category['page_id']]))
			{
				$db->sql_query('UPDATE ' . PHPBBWEB_PAGE_TABLE . ' SET ' . $db->sql_build_array('UPDATE', array('page_attachment' => false)) . " WHERE page_id = {$category['page_id']}");
			}

			$new_section_order = 1;
			foreach ($section_row as $sections => $section)
			{
				// No attachments exist, but page table thinks they do so go ahead and reset page_attachment flags
				if ($section['page_attachment'] && !isset($attach_row[$section['page_id']]))
				{
					$db->sql_query('UPDATE ' . PHPBBWEB_PAGE_TABLE . ' SET ' . $db->sql_build_array('UPDATE', array('page_attachment' => false)) . " WHERE page_id = {$section['page_id']}");
				}

				// The parent do not exist? mark it as orphan
				if (!isset($category_row[$section['parent_id']]))
				{
					// Only run the query if we need it
					if (!$section['is_orphan'])
					{
						$db->sql_query('UPDATE ' . PHPBBWEB_PAGE_TABLE . ' SET ' . $db->sql_build_array('UPDATE', array('is_orphan' => true)) . " WHERE page_id = {$section['page_id']}");
					}
					$orphan_sections[$section['page_id']] = $section;
				}

				// Syncronize sections by categories
				if (($section['parent_id'] == $category['page_id']) && ($section['page_order'] != $new_section_order))
				{
					$db->sql_query('UPDATE ' . PHPBBWEB_PAGE_TABLE . ' SET ' . $db->sql_build_array('UPDATE', array('page_order' => $new_section_order)) . " WHERE page_id = {$section['page_id']}");
					$new_section_order++;
				}
			}
		}
		// Going through every category and section, re-ordering and check for orphans - End

		// Going through every bock and categories, re-ordering and check for orphans - Start
		$new_block_category_order = 1;
		foreach ($category_row as $categories => $category)
		{
			foreach ($bock_row as $bocks => $bock)
			{
				// The parent do not exist? mark it as orphan
				if (!isset($section_row[$bock['parent_id']]) && !isset($category_row[$bock['parent_id']]))
				{
					// Only run the query if we need it
					if (!$bock['is_orphan'])
					{
						$db->sql_query('UPDATE ' . PHPBBWEB_PAGE_TABLE . ' SET ' . $db->sql_build_array('UPDATE', array('is_orphan' => true)) . " WHERE page_id = {$bock['page_id']}");
					}
					$orphan_blocks[$bock['page_id']] = $bock;
				}

				// Syncronize bocks by categories
				if (($bock['parent_id'] == $category['page_id']) && ($bock['page_order'] != $new_block_category_order))
				{
					$db->sql_query('UPDATE ' . PHPBBWEB_PAGE_TABLE . ' SET ' . $db->sql_build_array('UPDATE', array('page_order' => $new_block_category_order)) . " WHERE page_id = {$bock['page_id']}");
					$new_block_category_order++;
				}
			}
			$new_block_category_order = 1;
		}
		// Going through every bock and categories, re-ordering and check for orphans - End

		// Going through every bock and sections, re-ordering and check for orphans - Start
		$new_block_section_order = 1;
		foreach ($section_row as $sections => $section)
		{
			foreach ($bock_row as $bocks => $bock)
			{
				// The parent do not exist? mark it as orphan
				if (!isset($section_row[$bock['parent_id']]) && !isset($category_row[$bock['parent_id']]))
				{
					// Only run the query if we need it
					if (!$bock['is_orphan'])
					{
						$db->sql_query('UPDATE ' . PHPBBWEB_PAGE_TABLE . ' SET ' . $db->sql_build_array('UPDATE', array('is_orphan' => true)) . " WHERE page_id = {$bock['page_id']}");
					}
					$orphan_blocks[$bock['page_id']] = $bock;
				}

				// Syncronize bocks by sections
				if ($bock['parent_id'] == $section['page_id'])
				{
					$db->sql_query('UPDATE ' . PHPBBWEB_PAGE_TABLE . ' SET ' . $db->sql_build_array('UPDATE', array('page_order' => $new_block_section_order)) . " WHERE page_id = {$bock['page_id']}");
					$new_block_section_order++;
				}
			}
			$new_block_section_order = 1;
		}
		// Going through every bock and sections, re-ordering and check for orphans - End

		// Going through every attachments and check for orphans - Start
		foreach ($attach_row as $attachments => $attach)
		{
			// It's already marked as orphan?
			if ($attach['is_orphan'])
			{
				$orphan_attachments[] = $attach;
				continue;
			}
			// If we have an attacnment not asigned to a page, mark it as orphan
			if ($attach['page_id'] && (!isset($category_row[$attach['page_id']]) && !isset($section_row[$attach['page_id']])))
			{
				$db->sql_query('UPDATE ' . PHPBBWEB_ATTACHMENTS_TABLE . ' SET ' . $db->sql_build_array('UPDATE', array('is_orphan' => true)) . " WHERE page_id = {$attach['page_id']}");
				// No attachments exist, but page table thinks they do so go ahead and reset page_attach flags
				$orphan_attachments[] = $attach;
			}
		}
		// Going through every attachments and check for orphans - End

		if (sizeof($orphan_sections) || sizeof($orphan_blocks) || sizeof($orphan_attachments))
		{
			global $template;

			$this->tpl_name = 'phpbbweb/acp_phpbbweb_frontend';
			$this->page_title = 'ACP_PHPBBWEB_MANAGE';

			$template->assign_vars(array(
				'S_ERROR_MSG'	=> true,
				'ERROR_MSG'		=> $user->lang['ACP_ORPHANS_EXPLAIN'] . '<p><a href="' . $this->u_action . '&amp;action=orphan' . '" title="' . $user->lang['ACP_ORPHANS'] . '">' . $user->lang['ACP_ORPHANS'] . '</a></p>',
			));
		}
		else
		{
			trigger_error($user->lang['ACP_RESYNC_SUCCESS'] . adm_back_link($this->u_action));
		}
	}

	/**
	* Enter description here...
	*
	* @param unknown_type $action
	* &mode=manage&action=orphan
	**/
	function phpbbweb_orphan($action)
	{
		global $db, $user, $template;

		$submit = (isset($_POST['submit'])) ? true : false;

		$this->tpl_name = 'phpbbweb/acp_phpbbweb_orphan';
		$this->page_title = 'ACP_ORPHAN_ATTACHMENTS';

		$form_key = 'acp_attach';
		add_form_key($form_key);

		if ($submit)
		{
			if (!check_form_key($form_key))
			{
				trigger_error($user->lang['FORM_INVALID'] . adm_back_link($this->u_action), E_USER_WARNING);
			}

			$delete_files = (isset($_POST['delete'])) ? array_keys(request_var('delete', array('' => 0))) : array();
		//	$add_files = (isset($_POST['add'])) ? array_keys(request_var('add', array('' => 0))) : array();
			$post_ids = request_var('post_id', array('' => 0));

			// Check for files to delete - Start
			if (sizeof($delete_files))
			{
				$sql = 'SELECT *
					FROM ' . PHPBBWEB_ATTACHMENTS_TABLE . '
					WHERE ' . $db->sql_in_set('attach_id', $delete_files) . '
						AND is_orphan = 1';
				$result = $db->sql_query($sql);

				$delete_files = array();
				while ($row = $db->sql_fetchrow($result))
				{
					phpbb_unlink($row['physical_filename'], 'file');

					if ($row['thumbnail'])
					{
						phpbb_unlink($row['physical_filename'], 'thumbnail');
					}

					$delete_files[$row['attach_id']] = $row['real_filename'];
				}
				$db->sql_freeresult($result);
			}

			if (sizeof($delete_files))
			{
				$sql = 'DELETE FROM ' . PHPBBWEB_ATTACHMENTS_TABLE . '
					WHERE ' . $db->sql_in_set('attach_id', array_keys($delete_files));
				$db->sql_query($sql);

				$notify[] = sprintf($user->lang['LOG_ATTACH_ORPHAN_DEL'], implode(', ', $delete_files));
			}
			// Check for files to delete - End

			// Check for files to attach into a page - Start
			$attach_list = array();
			foreach ($post_ids as $attach => $attach_id)
			{
				if ($attach_id)
				{
					$attach_list[$attach] = $attach_id;
				}
			}
			unset($post_ids);

			if (sizeof($attach_list))
			{
				foreach ($attach_list as $attach_id => $page_id)
				{
					$db->sql_query('UPDATE ' . PHPBBWEB_ATTACHMENTS_TABLE . ' SET ' . $db->sql_build_array('UPDATE', array('is_orphan' => false, 'page_id' => $page_id)) . " WHERE attach_id = $attach_id");
					$db->sql_query('UPDATE ' . PHPBBWEB_PAGE_TABLE . ' SET ' . $db->sql_build_array('UPDATE', array('page_attachment' => true)) . " WHERE page_id = $page_id");				
				}
			}
			// Check for files to attach into a page - End

			trigger_error($user->lang['ACP_RESYNC_SUCCESS'] . adm_back_link($this->u_action . '&amp;action=orphan'));
		}

		$tpl_fields = array();
		$tpl_fields['section'] = $tpl_fields['blocks'] = array();
		$sql = 'SELECT * 
				FROM ' . PHPBBWEB_PAGE_TABLE . '
				WHERE is_orphan = 1
				ORDER BY page_id ASC';
		$result = $db->sql_query($sql);
		while ($row = $db->sql_fetchrow($result))
		{
			if ($row['page_type'] == PAGE_SECTION)
			{
				$tpl_fields['section'][] = array(
					'PAGE_NAME'			=> $row['page_subject'],
					'PAGE_ID'			=> $row['page_id'],
					'U_PAGE_EDIT'		=> $this->u_action . '&amp;page_id=' . $row['page_id'] . '&amp;action=edit',
					'U_PAGE_REMOVE'		=> $this->u_action . '&amp;page_id=' . $row['page_id'] . '&amp;action=remove',
				);
			}
			if ($row['page_type'] == PAGE_BLOCK)
			{
				$tpl_fields['blocks'][] = array(
					'PAGE_NAME'			=> $row['page_subject'],
					'PAGE_ID'			=> $row['page_id'],
					'U_PAGE_EDIT'		=> $this->u_action . '&amp;page_id=' . $row['page_id'] . '&amp;action=edit',
					'U_PAGE_REMOVE'		=> $this->u_action . '&amp;page_id=' . $row['page_id'] . '&amp;action=remove',
				);
			}
		}
		$db->sql_freeresult($result);

		if (!empty($tpl_fields['section']))
		{
			foreach ($tpl_fields['section'] as $field_data)
			{
				$template->assign_block_vars('section', $field_data);
			}
		}
		if (!empty($tpl_fields['blocks']))
		{
			foreach ($tpl_fields['blocks'] as $field_data)
			{
				$template->assign_block_vars('blocks', $field_data);
			}
		}

		// Just get the files with is_orphan set and older than 3 hours
		$sql = 'SELECT *
				FROM ' . PHPBBWEB_ATTACHMENTS_TABLE . '
				WHERE is_orphan = 1
					AND filetime < ' . (time() - 3*60*60) . '
				ORDER BY filetime DESC';
		$result = $db->sql_query($sql);

		while ($row = $db->sql_fetchrow($result))
		{
			$template->assign_block_vars('attach', array(
				'FILESIZE'		=> get_formatted_filesize($row['filesize']),
				'FILETIME'		=> $user->format_date($row['filetime']),
				'REAL_FILENAME'	=> utf8_basename($row['real_filename']),
				'ATTACH_ID'		=> $row['attach_id'],
				'PAGE_ID'		=> (!empty($post_ids[$row['attach_id']])) ? $post_ids[$row['attach_id']] : '',
				'U_FILE'		=> append_sid(PHPBBWEB_FILE, 'mode=view&amp;id=' . $row['attach_id']),
			));
		}
		$db->sql_freeresult($result);

		$template->assign_vars(array(
			'S_ORPHAN'	=> true,
			'U_ACTION'	=> $this->u_action . '&amp;action=orphan',
		));

		$this->phpbbbweb_need_icons();
	}

	/**
	* Enter description here...
	*
	**/
	function phpbbbweb_need_icons()
	{
		global $template, $user;

		$template->assign_vars(array(
			'ICON_LINK'					=> '<img src="' . PHPBB_ROOT_PATH . 'adm/images/icon_folder_link.gif" alt="' . $user->lang['ACP_ICON_LINK_TITLE'] . '" title="' . $user->lang['ACP_ICON_LINK_TITLE'] . '" />',
			'ICON_CATEGORY'				=> '<img src="' . PHPBB_ROOT_PATH . 'adm/images/icon_subfolder.gif" alt="' . $user->lang['ACP_ICON_CATEGORY_TITLE'] . '" title="' . $user->lang['ACP_ICON_CATEGORY_TITLE'] . '" />',
			'ICON_SECTION'				=> '<img src="' . PHPBB_ROOT_PATH . 'adm/images/icon_folder.gif" alt="' . $user->lang['ACP_ICON_SECTION_TITLE'] . '" title="' . $user->lang['ACP_ICON_SECTION_TITLE'] . '" />',
			'ICON_BLOCK'				=> '<img src="' . PHPBB_ROOT_PATH . 'adm/images/file_new.gif" alt="' . $user->lang['ACP_ICON_BLOCK_TITLE'] . '" title="' . $user->lang['ACP_ICON_BLOCK_TITLE'] . '" />',
			'ICON_MOVE_UP'				=> '<img src="' . PHPBB_ROOT_PATH . 'adm/images/icon_up.gif" alt="' . $user->lang['ACP_ICON_MOVE_UP'] . '" title="' . $user->lang['ACP_ICON_MOVE_UP'] . '" />',
			'ICON_MOVE_UP_DISABLED'		=> '<img src="' . PHPBB_ROOT_PATH . 'adm/images/icon_up_disabled.gif" alt="' . $user->lang['ACP_ICON_MOVE_UP_DISABLED'] . '" title="' . $user->lang['ACP_ICON_MOVE_UP_DISABLED'] . '" />',
			'ICON_MOVE_DOWN'			=> '<img src="' . PHPBB_ROOT_PATH . 'adm/images/icon_down.gif" alt="' . $user->lang['ACP_ICON_MOVE_DOWN'] . '" title="' . $user->lang['ACP_ICON_MOVE_DOWN'] . '" />',
			'ICON_MOVE_DOWN_DISABLED'	=> '<img src="' . PHPBB_ROOT_PATH . 'adm/images/icon_down_disabled.gif" alt="' . $user->lang['ACP_ICON_MOVE_DOWN_DISABLED'] . '" title="' . $user->lang['ACP_ICON_MOVE_DOWN_DISABLED'] . '" />',
			'ICON_EDIT'					=> '<img src="' . PHPBB_ROOT_PATH . 'adm/images/icon_edit.gif" alt="' . $user->lang['ACP_ICON_EDIT'] . '" title="' . $user->lang['ACP_ICON_EDIT'] . '" />',
			'ICON_EDIT_DISABLED'		=> '<img src="' . PHPBB_ROOT_PATH . 'adm/images/icon_edit_disabled.gif" alt="' . $user->lang['ACP_ICON_EDIT_DISABLED'] . '" title="' . $user->lang['ACP_ICON_EDIT_DISABLED'] . '" />',
			'ICON_DELETE'				=> '<img src="' . PHPBB_ROOT_PATH . 'adm/images/icon_delete.gif" alt="' . $user->lang['ACP_ICON_DELETE'] . '" title="' . $user->lang['ACP_ICON_DELETE'] . '" />',
			'ICON_DELETE_DISABLED'		=> '<img src="' . PHPBB_ROOT_PATH . 'adm/images/icon_delete_disabled.gif" alt="' . $user->lang['ACP_ICON_DELETE_DISABLED'] . '" title="' . $user->lang['ACP_ICON_DELETE_DISABLED'] . '" />',
			'ICON_ENABLED'				=> '<img src="' . PHPBB_ROOT_PATH . 'adm/images/icon_sync.gif" alt="' . $user->lang['ACP_ICON_ENABLED'] . '" title="' . $user->lang['ACP_ICON_ENABLED'] . '" />',
			'ICON_DISABLED'				=> '<img src="' . PHPBB_ROOT_PATH . 'adm/images/icon_sync_disabled.gif" alt="' . $user->lang['ACP_ICON_DISABLED'] . '" title="' . $user->lang['ACP_ICON_DISABLED'] . '" />',
			'ICON_ATTACH'				=> '<img src="' . PHPBB_ROOT_PATH . 'adm/style/phpbbweb/images/icon_topic_attach.gif" alt="' . $user->lang['ATTACHMENTS'] . '" title="' . $user->lang['ATTACHMENTS'] . '" />',
		));
	}

	/**
	* @description: Set config value. Creates missing config entry.
	*
	* @param: (string)		$config_name = column name 
	* @param: (string)		$config_value = column value
	* 
	* @version: 1.0.0
	**/
	function phpbbweb_set_config($config_name, $config_value)
	{
		global $db, $phpbbweb, $webconfig;

		$webconfig_old = $phpbbweb->obtain_config();

		$sql = 'UPDATE ' . PHPBBWEB_CONFIG_TABLE . "
			SET config_value = '" . $db->sql_escape($config_value) . "'
			WHERE config_name = '" . $db->sql_escape($config_name) . "'";
		$db->sql_query($sql);

	//	if (!$db->sql_affectedrows() && !isset($webconfig[$config_name]))
		if (!$db->sql_affectedrows() && !isset($webconfig_old[$config_name]))
		{
			$sql = 'INSERT INTO ' . PHPBBWEB_CONFIG_TABLE . ' ' . $db->sql_build_array('INSERT', array(
				'config_name'	=> $config_name,
				'config_value'	=> $config_value,
			));
			$db->sql_query($sql);
		}

		$webconfig[$config_name] = $config_value;
	}

	/**
	* @description: Get link to an user prifile placing into templates.
	* @param: (integer)		$user_id = The users id
	* @return: (string)		A link
	* 
	* @version: 1.0.0
	**/
	function get_user($user_id)
	{
		global $db, $user;

		$user_id = (int) $user_id;

		if (!$user_id)
		{
			return false;
		}

		// Grab the user records
		$sql = 'SELECT user_id, username, user_colour
				FROM ' . USERS_TABLE . "
				WHERE user_id = $user_id";
		$result = $db->sql_query($sql);

		if (!($row = $db->sql_fetchrow($result)))
		{
			$db->sql_freeresult($result);
			return false;
		}

		do
		{
			$profile = '<a href="' . append_sid(PHPBB_ROOT_PATH . "memberlist." . PHP_EXT, "mode=viewprofile&amp;u=$user_id") . '" style="color: #' . $row['user_colour'] . ';" class="username-coloured" onclick="window.open(this.href);return false;">' . $row['username'] . '</a>';
		}
		while ($row = $db->sql_fetchrow($result));
		$db->sql_freeresult($result);

		return $profile;
	}

	/**
	* @description: Get page|block info
	* @param: (integer)		$page_id = page identifier
	* @param: (boolean)		$add = flag
	* @return: (array)		page data
	* 
	* @version: 1.0.0
	**/
	function get_page_data($page_id, $add = false)
	{
		global $user, $db;

		$page_id = (int) $page_id;

		$sql = 'SELECT * 
			FROM ' . PHPBBWEB_PAGE_TABLE . " 
			WHERE page_id = $page_id";
		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);

		if (!$row && !$add)
		{
			phpbbweb_msg_handler($user->lang['NO_CATEGORY'] . " :: $page_id");
		}
		else if ($add)
		{
			$row = array(
				'page_id'			=> 0,	// MEDIUMINT(8)
				'parent_id'			=> 0,	// MEDIUMINT(8)
				'page_order'		=> 0,	// MEDIUMINT(8)
				'page_subject'		=> '',	// VARCHAR(255)
				'page_description'	=> '',	// VARCHAR(255)
				'page_class'		=> '',	// VARCHAR(255)
				'page_approved'		=> 1,	// TINYINT(1)
				'page_text'			=> '',	// MEDIUMTEXT
				'enable_bbcode'		=> 1,	// TINYINT(1)
				'enable_smilies'	=> 1,	// TINYINT(1)
				'enable_magic_url'	=> 1,	// TINYINT(1)
				'bbcode_bitfield'	=> '',	// VARCHAR(255)
				'bbcode_uid'		=> '',	// VARCHAR(8)
				'page_views'		=> 0,	// MEDIUMINT(8)
				'owner_id'			=> 0,	// MEDIUMINT(8)
				'redirect'			=> 0,	// TINYINT(1)
				'redirect_url'		=> '',	// VARCHAR(255)
				'redirect_open'		=> 0,	// TINYINT(1)
				'page_attachment'	=> 0,	// TINYINT(1)
				'page_type'			=> request_var('page_type', PAGE_CATEGORY),
				'global_block'		=> 0,	// TINYINT(1)
				'is_orphan'			=> 0,
			);
		}

		return $row;
	}

	/**
	* @description: Get a new id
	*
	* @param: (string)		$table = table name
	* @return: (integer)	new id
	* 
	* @version: 1.0.0
	**/
	function get_new_id()
	{
		global $db;
		
		$sql = "SELECT MAX(page_id) AS mew_id 
				FROM " . PHPBBWEB_PAGE_TABLE . "
				ORDER BY page_id";
		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);

		return $row['mew_id'] + 1;	
	}

	/**
	* @description: Get a new order 
	*
	* @param: (string)		$table = table name
	* @param: (integer)		$parent_id = page parent identifier
	* @return: (integer)	$page_type = PAGE_CATEGORY|PAGE_SECTION|PAGE_BLOCK
	* 
	* @version: 1.0.0
	**/
	function get_new_order($parent_id = 0, $page_type = PAGE_CATEGORY)
	{
		global $db;

		$sql = "SELECT MAX(page_order) AS mew_order 
				FROM " . PHPBBWEB_PAGE_TABLE . " 
				WHERE parent_id = $parent_id AND page_type = $page_type
				ORDER BY page_order";
		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);

		return $row['mew_order'] + 1;
	}

	/**
	* Get a full page branch
	**/
	function get_page_branch($page_id, $type = 'all', $order = 'descending', $include_forum = true, $include_blocks = true)
	{
		global $db;

		$rows = array();
		$sql_where = '';

		switch ($type)
		{
			case 'parents':
				$condition = "p2.page_id = p1.parent_id OR p2.page_id = $page_id";
			break;

			case 'children':
				$condition = 'p1.page_id = p2.parent_id';
				$sql_where = ' AND p2.page_type <> ' . PAGE_BLOCK;
			break;

			default:
				$condition = "p2.page_id = p1.parent_id OR p2.page_id = $page_id OR p1.page_id = p2.parent_id";
			break;
		}

		$sql = 'SELECT p2.*
			FROM ' . PHPBBWEB_PAGE_TABLE . ' p1
			LEFT JOIN ' . PHPBBWEB_PAGE_TABLE . " p2 ON ($condition)
			WHERE p1.page_id = $page_id $sql_where
			ORDER BY p2.page_order " . (($order == 'descending') ? 'ASC' : 'DESC');
		$result = $db->sql_query($sql);

		while ($row = $db->sql_fetchrow($result))
		{
			if (!$include_forum && $row['page_id'] == $page_id)
			{
				continue;
			}

			$rows[] = $row;
		}
		$db->sql_freeresult($result);

		return $rows;
	}

	/**
	* @description: build a select with cateories and sections
	* 
	* @version: 1.0.0
	**/
	function make_page_select($select_id = 0, $type = '')
	{
		global $db;

		// Get Sections
		$row_s = array();
		$sql_s = 'SELECT * 
				FROM ' . PHPBBWEB_PAGE_TABLE . ' 
				WHERE page_type = ' . PAGE_SECTION . ' 
				ORDER BY page_order ASC';
		$result_s = $db->sql_query($sql_s);
		while ($row = $db->sql_fetchrow($result_s))
		{
			$row_s[] = $row;
		}
		$db->sql_freeresult($result_s);

		// Get Categories
		$row_c = array();
		$sql_c = 'SELECT * 
				FROM ' . PHPBBWEB_PAGE_TABLE . ' 
				WHERE page_type = ' . PAGE_CATEGORY . ' 
				ORDER BY page_order ASC';
		$result_c = $db->sql_query($sql_c);
		while ($row = $db->sql_fetchrow($result_c))
		{
			$row_c[] = $row;
		}
		$db->sql_freeresult($result_c);

		$option_list = '';
		// Go trough categories
		foreach ($row_c as $rowc)
		{
			$selectedc = ($rowc['page_id'] == $select_id) ? ' selected="selected"' : '';
			$disabledc = ($type == PAGE_CATEGORY && $selectedc) ? true : false;

			$option_list .= '<option value="' . $rowc['page_id'] . '"' . (($disabledc) ? ' disabled="disabled" class="disabled-option"' : $selectedc) . '>' . $rowc['page_subject'] . '</option>' . "\r";

			// Go trough Sections
			foreach ($row_s as $rows)
			{
				if ($rows['parent_id'] == $rowc['page_id'])
				{
					$selecteds = ($rows['page_id'] == $select_id) ? ' selected="selected"' : '';
					$disableds = ($type != PAGE_BLOCK) ? true : false;

					$option_list .= '<option value="' . $rows['page_id'] . '"' . (($disableds) ? ' disabled="disabled" class="disabled-option"' : $selecteds) . '>&nbsp;&nbsp;' . $rows['page_subject'] . '</option>' . "\r";
				}
			}
		}

		return $option_list;

	}

	/**
	* @description: Get dropdown list with all categories
	*
	* @param: (integer)		$category_id = category identifier
	* @return (mixed)		html options|number 
	* 
	* @version: 1.0.0
	**/
	function get_branch_list($parent_id, $return_amount = false)
	{
		global $db;

		$parent_id = (int) $parent_id;

		$sql = 'SELECT * 
				FROM ' . PHPBBWEB_PAGE_TABLE . " 
				WHERE parent_id = $parent_id
					AND page_type = " . PAGE_SECTION;
		if ($return_amount)
		{
			$result_sections = $db->sql_query($sql);
			$db->sql_freeresult($result_sections);
			return $db->sql_affectedrows();
		}
		$result_sections = $db->sql_query_limit($sql, 1);

		// If true, we build the dropdown for move the sections into anohter category
		if ($db->sql_fetchrow($result_sections))
		{
			$sql = 'SELECT * 
					FROM ' . PHPBBWEB_CATEGORY_TABLE . ' 
					ORDER BY category_order ASC';
			$result_categories = $db->sql_query($sql);

			while ($row = $db->sql_fetchrow($result_categories))
			{
				$disabled = ($category_id == $row['category_id']) ? true : false;
				$category_option .= '<option value="' . $row['category_id'] . '"' . (($disabled) ? ' disabled="disabled" class="disabled-option"' : '') . '>' . $row['category_subject'] . '</option>';
			}
			$db->sql_freeresult($result_categories);
		}
		$db->sql_freeresult($result_sections);

		return $category_option;
	}

	/**
	* @description: Preview is style dependance,
	* 	so we need to use the user template here
	* @param: (string)		$message = text to display
	* 
	* @version: 1.0.0
	**/
	function phpbbweb_generate_preview($data, $mode = 'main')
	{
		global $user, $template, $phpbbweb;

		// Setup the template
	//	$template->set_custom_template(PHPBB_ROOT_PATH . 'styles/' . $user->theme['template_path'] . "/template/", 'phpbbweb');
		$user->setup();

		$subject = $data['subject'];
		$message = $phpbbweb->parse_content($data);

		$phpbbweb->page_header($user->lang['ACP_PREVIEW']);

		$template->set_filenames(array(
			'body' => 'phpbbweb/phpbbweb_preview.html')
		);
		
		$template->assign_vars(array(
			'S_MESSAGE_PREVIEW'	=> true,
			'MAIN_CLASS'		=> ($mode == 'main') ? 'wide' : '',
			'MAIN_SUBJECT'		=> ($mode !== 'block') ? $subject : '',
			'MAIN_CONTENT'		=> ($mode !== 'block') ? $message : '',
/**
			'MAIN_CLASS'		=> ($mode == 'main') ? 'wide' : '',
			'MAIN_SUBJECT'		=> ($mode == 'main') ? $subject : '',
			'MAIN_CONTENT'		=> ($mode == 'main') ? $message : '',

			'SECTION_CLASS'		=> ($mode == 'section') ? '' : '',
			'SECTION_SUBJECT'	=> ($mode == 'section') ? $subject : '',
			'SECTION_CONTENT'	=> ($mode == 'section') ? $message : '',
**/
			'BLOCK_CLASS'		=> ($mode == 'block') ? '' : '',
			'BLOCK_SUBJECT'		=> ($mode == 'block') ? $subject : '',
			'BLOCK_CONTENT'		=> ($mode == 'block') ? $message : '',
		));

		page_footer();
	}
}

if (!class_exists('parse_message'))
{
	include_once(PHPBB_ROOT_PATH . 'includes/message_parser.' . PHP_EXT);
}

class message_parse extends parse_message
{
	/**
	* @description: Parse Attachments
	*	basically wirls like parse_attachments only change the table name
	* @see: root/includes/message_parser.php -> parse_attachments()
	**/
	function phpbbweb_parse_attachments($form_name,   $mode,  $forum_id, $submit, $preview, $refresh, $is_message = false)
	{
		global $config, $auth, $user, $db;

		$error = array();

		$num_attachments = sizeof($this->attachment_data);
		$this->filename_data['filecomment'] = utf8_normalize_nfc(request_var('filecomment', '', true));
		$upload_file = (isset($_FILES[$form_name]) && $_FILES[$form_name]['name'] != 'none' && trim($_FILES[$form_name]['name'])) ? true : false;

		$add_file		= (isset($_POST['add_file'])) ? true : false;
		$delete_file	= (isset($_POST['delete_file'])) ? true : false;

		// First of all adjust comments if changed
		$actual_comment_list = utf8_normalize_nfc(request_var('comment_list', array(''), true));

		foreach ($actual_comment_list as $comment_key => $comment)
		{
			if (!isset($this->attachment_data[$comment_key]))
			{
				continue;
			}

			if ($this->attachment_data[$comment_key]['attach_comment'] != $actual_comment_list[$comment_key])
			{
				$this->attachment_data[$comment_key]['attach_comment'] = $actual_comment_list[$comment_key];
			}
		}

		$cfg = array();
		$cfg['max_attachments'] = ($is_message) ? $config['max_attachments_pm'] : $config['max_attachments'];
		$forum_id = ($is_message) ? $forum_id : 0;

		if ($submit && $upload_file)
		{
			if ($num_attachments < $cfg['max_attachments'])
			{
				$filedata = upload_attachment($form_name, $forum_id, false, '', $is_message);
				$error = $filedata['error'];

				if ($filedata['post_attach'] && !sizeof($error))
				{
					$sql_ary = array(
						'physical_filename'	=> $filedata['physical_filename'],
						'attach_comment'	=> $this->filename_data['filecomment'],
						'real_filename'		=> $filedata['real_filename'],
						'extension'			=> $filedata['extension'],
						'mimetype'			=> $filedata['mimetype'],
						'filesize'			=> $filedata['filesize'],
						'filetime'			=> $filedata['filetime'],
						'thumbnail'			=> $filedata['thumbnail'],
						'is_orphan'			=> 1,
						'in_message'		=> ($is_message) ? 1 : 0,
						'poster_id'			=> $user->data['user_id'],
					);

					$db->sql_query('INSERT INTO ' . PHPBBWEB_ATTACHMENTS_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary));

					$new_entry = array(
						'attach_id'		=> $db->sql_nextid(),
						'is_orphan'		=> 1,
						'real_filename'	=> $filedata['real_filename'],
						'attach_comment'=> $this->filename_data['filecomment'],
					);

					$this->attachment_data = array_merge(array(0 => $new_entry), $this->attachment_data);
					$this->message = preg_replace('#\[attachment=([0-9]+)\](.*?)\[\/attachment\]#e', "'[attachment='.(\\1 + 1).']\\2[/attachment]'", $this->message);

					$this->filename_data['filecomment'] = '';

					// This Variable is set to false here, because Attachments are entered into the
					// Database in two modes, one if the id_list is 0 and the second one if post_attach is true
					// Since post_attach is automatically switched to true if an Attachment got added to the filesystem,
					// but we are assigning an id of 0 here, we have to reset the post_attach variable to false.
					//
					// This is very relevant, because it could happen that the post got not submitted, but we do not
					// know this circumstance here. We could be at the posting page or we could be redirected to the entered
					// post. :)
					$filedata['post_attach'] = false;
				}
			}
			else
			{
				$error[] = sprintf($user->lang['TOO_MANY_ATTACHMENTS'], $cfg['max_attachments']);
			}
		}

		if ($preview || $refresh || sizeof($error))
		{
			// Perform actions on temporary attachments
			if ($delete_file)
			{
				include_once(PHPBB_ROOT_PATH . 'includes/functions_admin.' . PHP_EXT);

				$index = array_keys(request_var('delete_file', array(0 => 0)));
				$index = (!empty($index)) ? $index[0] : false;

				if ($index !== false && !empty($this->attachment_data[$index]))
				{
					// delete selected attachment
					if ($this->attachment_data[$index]['is_orphan'])
					{
						$sql = 'SELECT attach_id, physical_filename, thumbnail
							FROM ' . PHPBBWEB_ATTACHMENTS_TABLE . '
							WHERE attach_id = ' . (int) $this->attachment_data[$index]['attach_id'] . '
								AND is_orphan = 1
								AND poster_id = ' . $user->data['user_id'];
						$result = $db->sql_query($sql);
						$row = $db->sql_fetchrow($result);
						$db->sql_freeresult($result);

						if ($row)
						{
							phpbb_unlink($row['physical_filename'], 'file');

							if ($row['thumbnail'])
							{
								phpbb_unlink($row['physical_filename'], 'thumbnail');
							}

							$db->sql_query('DELETE FROM ' . PHPBBWEB_ATTACHMENTS_TABLE . ' WHERE attach_id = ' . (int) $this->attachment_data[$index]['attach_id']);
						}
					}
					else
					{
						delete_attachments('attach', array(intval($this->attachment_data[$index]['attach_id'])));
					}

					unset($this->attachment_data[$index]);
					$this->message = preg_replace('#\[attachment=([0-9]+)\](.*?)\[\/attachment\]#e', "(\\1 == \$index) ? '' : ((\\1 > \$index) ? '[attachment=' . (\\1 - 1) . ']\\2[/attachment]' : '\\0')", $this->message);

					// Reindex Array
					$this->attachment_data = array_values($this->attachment_data);
				}
			}
			else if (($add_file || $preview) && $upload_file)
			{
				if ($num_attachments < $cfg['max_attachments'])
				{
					$filedata = upload_attachment($form_name, $forum_id, false, '', $is_message);
					$error = array_merge($error, $filedata['error']);

					if (!sizeof($error))
					{
						$sql_ary = array(
							'physical_filename'	=> $filedata['physical_filename'],
							'attach_comment'	=> $this->filename_data['filecomment'],
							'real_filename'		=> $filedata['real_filename'],
							'extension'			=> $filedata['extension'],
							'mimetype'			=> $filedata['mimetype'],
							'filesize'			=> $filedata['filesize'],
							'filetime'			=> $filedata['filetime'],
							'thumbnail'			=> $filedata['thumbnail'],
							'is_orphan'			=> 1,
							'in_message'		=> ($is_message) ? 1 : 0,
							'poster_id'			=> $user->data['user_id'],
						);

						$db->sql_query('INSERT INTO ' . PHPBBWEB_ATTACHMENTS_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary));

						$new_entry = array(
							'attach_id'		=> $db->sql_nextid(),
							'is_orphan'		=> 1,
							'real_filename'	=> $filedata['real_filename'],
							'attach_comment'=> $this->filename_data['filecomment'],
						);

						$this->attachment_data = array_merge(array(0 => $new_entry), $this->attachment_data);
						$this->message = preg_replace('#\[attachment=([0-9]+)\](.*?)\[\/attachment\]#e', "'[attachment='.(\\1 + 1).']\\2[/attachment]'", $this->message);
						$this->filename_data['filecomment'] = '';
					}
				}
				else
				{
					$error[] = sprintf($user->lang['TOO_MANY_ATTACHMENTS'], $cfg['max_attachments']);
				}
			}
		}

		foreach ($error as $error_msg)
		{
			$this->warn_msg[] = $error_msg;
		}
	}

	/**
	* @description: Get Attachment Data
	*	basically wirls like get_submitted_attachment_data only change the table name
	* @see: root/includes/message_parser.php -> get_submitted_attachment_data()
	**/
	function phpbbweb_get_submitted_attachment_data($check_user_id = false)
	{
		global $user, $db, $config;

		$this->filename_data['filecomment'] = utf8_normalize_nfc(request_var('filecomment', '', true));
		$attachment_data = (isset($_POST['attachment_data'])) ? $_POST['attachment_data'] : array();
		$this->attachment_data = array();

		$check_user_id = ($check_user_id === false) ? $user->data['user_id'] : $check_user_id;

		if (!sizeof($attachment_data))
		{
			return;
		}

		$not_orphan = $orphan = array();

		foreach ($attachment_data as $pos => $var_ary)
		{
			if ($var_ary['is_orphan'])
			{
				$orphan[(int) $var_ary['attach_id']] = $pos;
			}
			else
			{
				$not_orphan[(int) $var_ary['attach_id']] = $pos;
			}
		}

		// Regenerate already posted attachments
		if (sizeof($not_orphan))
		{
			// Get the attachment data, based on the poster id...
			$sql = 'SELECT attach_id, is_orphan, real_filename, attach_comment
				FROM ' . PHPBBWEB_ATTACHMENTS_TABLE . '
				WHERE ' . $db->sql_in_set('attach_id', array_keys($not_orphan)) . '
					AND poster_id = ' . $check_user_id;
			$result = $db->sql_query($sql);

			while ($row = $db->sql_fetchrow($result))
			{
				$pos = $not_orphan[$row['attach_id']];
				$this->attachment_data[$pos] = $row;
				set_var($this->attachment_data[$pos]['attach_comment'], $_POST['attachment_data'][$pos]['attach_comment'], 'string', true);

				unset($not_orphan[$row['attach_id']]);
			}
			$db->sql_freeresult($result);
		}

		if (sizeof($not_orphan))
		{
			trigger_error('NO_ACCESS_ATTACHMENT', E_USER_ERROR);
		}

		// Regenerate newly uploaded attachments
		if (sizeof($orphan))
		{
			$sql = 'SELECT attach_id, is_orphan, real_filename, attach_comment
				FROM ' . PHPBBWEB_ATTACHMENTS_TABLE . '
				WHERE ' . $db->sql_in_set('attach_id', array_keys($orphan)) . '
					AND poster_id = ' . $user->data['user_id'] . '
					AND is_orphan = 1';
			$result = $db->sql_query($sql);

			while ($row = $db->sql_fetchrow($result))
			{
				$pos = $orphan[$row['attach_id']];
				$this->attachment_data[$pos] = $row;
				set_var($this->attachment_data[$pos]['attach_comment'], $_POST['attachment_data'][$pos]['attach_comment'], 'string', true);

				unset($orphan[$row['attach_id']]);
			}
			$db->sql_freeresult($result);
		}

		if (sizeof($orphan))
		{
			trigger_error('NO_ACCESS_ATTACHMENT', E_USER_ERROR);
		}

		ksort($this->attachment_data);
	}
}

?>