<?php
/**
* @package: phpBB 3.0.8 :: phpBB Web => phpbb root/includes/
* @version: $Id: functions_phpbbweb.php, v1.0.4 2011-01-20 11:01:20 leviatan21 Exp $
* @copyright: leviatan21 < info@mssti.com > (Gabriel) http://www.mssti.com/phpbb3/
* @license: http://opensource.org/licenses/gpl-license.php GNU Public License 
* @author: leviatan21 - http://www.phpbb.com/community/memberlist.php?mode=viewprofile&u=345763
**/

/**
* @ignore
**/

if (!defined('IN_PHPBBWEB'))
{
	exit;
}
/**
foreach($_SERVER as $key => $value)
{
	print_r("key=($key) value=($value)<br />");
}
print_r("absolute=($url)");
**/

// Make sure that phpbbweb is always usable
$phpbbweb = new phpbbweb();

class phpbbweb
{
	var $template_path = 'prosilver';

	/**
	* Constructor
	**/
	function phpbbweb()
	{
		global $user;
		global $table_prefix, $webconfig;

		// phpBB Web Version
		define('PHPBBWEB_VERSION', '1.0.4');

		// Table names
		define('PHPBBWEB_CONFIG_TABLE', $table_prefix . 'phpbbweb_config');
		define('PHPBBWEB_PAGE_TABLE', $table_prefix . 'phpbbweb_pages');
		define('PHPBBWEB_ATTACHMENTS_TABLE', $table_prefix . 'phpbbweb_attachments');

		// Posting page vars
		define('POSTING_MODE', 'post');

		// Site design
		define('COLUMN2_LEFT', 20);		// 2 columns menu & block sidebar on left side
		define('COLUMN2_RIGHT', 21);	// 2 columns menu & block sidebar on right side
		define('COLUMN3_LEFT', 30);		// 3 columns menu sidebar on left side, blocks on right side
		define('COLUMN3_RIGHT', 31);	// 3 columns menu sidebar on right side, blocks on left side
		define('MARGIN_EXTRA', 10);

		// Page types
		define('PAGE_CATEGORY', 0);
		define('PAGE_SECTION', 1);
		define('PAGE_BLOCK', 2);

		// Redirect opctions
		define('REDIRECT_POPWINDOWS', 2);
		define('REDIRECT_NEWWINDOWS', 1);

		// Grab global variables
		$webconfig = $this->obtain_config();

		$this->absolute_path = $this->phpbbweb_build_url(true);
		$this->absolute_board = $this->phpbbweb_build_url(false);

		// Page links
		define('PHPBBWEB_INDEX', $this->absolute_path . 'index.' . PHP_EXT);
		define('PHPBBWEB_SEARCH', $this->absolute_path . 'search.' . PHP_EXT);
		define('PHPBBWEB_SITEMAP', $this->absolute_path . 'sitemap.' . PHP_EXT);
		define('PHPBBWEB_FILE', $this->absolute_path . 'download/phpbbweb_file.' . PHP_EXT);

		define('PHPBB_STYLE', $this->absolute_board . 'style.' . PHP_EXT);
		define('PHPBB_VIEWFORUM', $this->absolute_board . 'viewforum.' . PHP_EXT);
		define('PHPBB_VIEWTOPIC', $this->absolute_board . 'viewtopic.' . PHP_EXT);

		// the phpBB web template is never stored in the database
		$user->theme['template_storedb'] = false;

		$this->template_path = '/phpbbweb';

		// Include the web language file
		$user->add_lang('mods/phpbbweb');
	}

	/**
	* @description: Get our config values
	* @see: cache.php -> obtain_config()
	**/
	function obtain_config()
	{
		global $db;
		
		$webconfig = array();

		$sql = 'SELECT config_name, config_value
				FROM ' . PHPBBWEB_CONFIG_TABLE;
		$result = $db->sql_query($sql);

		while ($row = $db->sql_fetchrow($result))
		{
			$webconfig[$row['config_name']] = $row['config_value'];
		}
		$db->sql_freeresult($result);

		return $webconfig;
	}

	// --> DOMAIN SETTING <-- //
	function phpbbweb_build_url($with_script_path = false, $force_script_path = true)
	{
		global $user;
		global $webconfig, $phpEx;

		if (!isset($webconfig['seo']))
		{
			$url = (!empty($_SERVER['REQUEST_URI'])) ? $_SERVER['REQUEST_URI'] : getenv('REQUEST_URI');

			if (preg_match('#(search|sitemap)/#i', $url))
			{
				$redirect = preg_replace('#(search|sitemap)/#', "$1.$phpEx?", $url);
				redirect($redirect);
			}
		//	return ($with_script_path) ? PHPBBWEB_ROOT : PHPBB_ROOT_PATH;
			return ($with_script_path) ? ((PHPBBWEB_ROOT == './') ? PHPBBWEB_ROOT : '') : PHPBB_ROOT_PATH;
		}
		
		if (isset($webconfig['seo_phpbb']) && !$with_script_path)
		{
			return $webconfig['seo_phpbb'];
		}
		if (isset($webconfig['seo_phpbbweb']) && $with_script_path)
		{
			return $webconfig['seo_phpbbweb'];
		}

		$absolute = generate_board_url(true) . htmlspecialchars($user->page['script_path']);

		if (defined('IN_ADMIN'))
		{
			$absolute = str_replace('adm/', '', $absolute);
			$with_script_path = $force_script_path;
		//	$with_script_path = true;
		}

		// 2 separate locations possible: within phpbb directory and just outside of it.
		$clear_phpbb_root_path = $clear_phpbbweb_root_path = '';
		if (PHPBBWEB_ROOT == './')
		{
			$clear_phpbb_root_path = preg_replace('#\.\/(\w+)#', '$1', PHPBB_ROOT_PATH);
			$absolute .= $clear_phpbb_root_path;
		}
		else
		{
			$clear_phpbbweb_root_path = str_replace(array('.', '/'), array('', ''), PHPBBWEB_ROOT);
			if ($with_script_path)
			{
				$absolute .= $clear_phpbbweb_root_path;
			}
			else
			{
				$absolute = str_replace("$clear_phpbbweb_root_path/", '', $absolute);
			}
		}

		// Add a slash to the end if we do not have one
		if (substr($absolute, -1) != '/')
		{
			$absolute .= '/';
		}

		return $absolute;
	}

	/**
	* @description: Generate page header
	* @param: (string) 		$page_title = the page title
	* @version: 1.0.2
	**/
	function page_header($page_title = '')
	{
		global $user, $template;
		global $config, $webconfig, $phpEx;

		page_header($page_title, false);

		$zone_offset = (int) $user->timezone + (int) $user->dst;

		$template->assign_vars(array(
			'PHPBBWEB_MANE'			=> ($webconfig['sitename'] != '') ? $webconfig['sitename'] : $config['sitename'],
			'PHPBBWEB_DESC'			=> ($webconfig['description'] != '') ? $webconfig['description'] : $config['site_desc'],
			'PHPBBWEB_BG'			=> $this->get_bg(),
			'PHPBBWEB_LOGO'			=> $this->get_logo(),
			'PHPBBWEB_CSS'			=> $this->get_stylesheet(),
			
			'PHPBBWEB_META_DESC'	=> ($webconfig['meta_disable'] && $webconfig['meta_description'] != '') ? $webconfig['meta_description'] : '',
			'PHPBBWEB_META_KEY'		=> ($webconfig['meta_disable'] && $webconfig['meta_keywords'] != '') ? $webconfig['meta_keywords'] : '',
			'PHPBBWEB_META_ABSRT'	=> ($webconfig['meta_disable'] && $webconfig['meta_abstract'] != '') ? $webconfig['meta_abstract'] : '',
			'PHPBBWEB_META_VERIFY'	=> ($webconfig['meta_disable'] && $webconfig['meta_google_verify'] != '') ? $webconfig['meta_google_verify'] : '',
			'PHPBBWEB_FAVICON'		=> ($webconfig['favicon']) ? true : false,

			'PHPBBWEB_TEMPLATE_PATH'=> $this->template_path,

			'U_INDEX'				=> append_sid(PHPBBWEB_INDEX),
			'S_CURRENT_PAGE'		=> str_replace($user->page['page_dir'] . '/', '', $user->page['page']),
			'U_SEARCH'				=> ($webconfig['allow_search']) ? append_sid(PHPBBWEB_SEARCH) : false,
			'S_VIEWS'				=> $this->counters(),
			'U_SITEMAP'				=> ($webconfig['site_map']) ? append_sid(PHPBBWEB_SITEMAP) : false,

			'S_PHPBBWEB_DISABLED'	=> ($webconfig['disable']) ? true : false,
			'L_PHPBBWEB_DISABLED'	=> ($webconfig['disable_msg']) ? $webconfig['disable_msg'] : $user->lang['BOARD_DISABLED'],
			'S_DISPLAY_USER'		=> false,
			'S_CLOCK'				=> ($webconfig['live_clock']) ? $this->clock() : false,

			'T_TEMPLATE_PATH'		=> "{$this->absolute_board}styles/" . $user->theme['template_path'] . '/template',
			'T_STYLESHEET_LINK'		=> (!$user->theme['theme_storedb']) ? "{$this->absolute_board}styles/" . $user->theme['theme_path'] . '/theme/stylesheet.css' : append_sid(PHPBB_STYLE, 'id=' . $user->theme['style_id'] . '&amp;lang=' . $user->data['user_lang']),
		));

		// Is board disabled and user not an admin or moderator?
		if ($webconfig['disable'])
		{
			global $user, $auth;
			if (!defined('IN_LOGIN') && !$auth->acl_gets('a_board'))
			{
				if ($user->data['is_bot'])
				{
					header('HTTP/1.1 503 Service Unavailable');
				}

				$message = (!empty($webconfig['disable_msg'])) ? $webconfig['disable_msg'] : $user->lang['BOARD_DISABLED'];
				trigger_error($message);
			 }
		}

		return;
	}

	/**
	* @description: display the custom css
	*
	* @return: (string)
	* @version: OK
	**/
	function get_stylesheet()
	{
		global $template;
		global $webconfig;

		$css = '';
		if (trim($webconfig['stylesheet']) != '')
		{
			$css .= htmlspecialchars_decode(trim($webconfig['stylesheet']));
		}

		// Let's find out the main column width
		$webconfig['margin_left'] = $webconfig['margin_right'] = 0;
		$webconfig['width_left'] = $webconfig['width_right'] = 0;

		switch ($webconfig['column_design'])
		{
			case COLUMN2_LEFT: // 20 = 2 columns => Contenido principal a la derecha, barra de secciones y bloques a la izquierda
				$webconfig['margin_left'] = (int) $webconfig['leftsidebar_width'] + MARGIN_EXTRA;
				$webconfig['width_left']  = (int) $webconfig['leftsidebar_width'];
			break;
			case COLUMN2_RIGHT: // 21 = 2 columns => Contenido principal a la izquierda, barra de secciones y bloques a la derecha
				$webconfig['margin_right'] = (int) $webconfig['rightsidebar_width'] + MARGIN_EXTRA;
				$webconfig['width_right']  = (int) $webconfig['rightsidebar_width'];
			break;
			case COLUMN3_LEFT: // 30 = 3 columns => Contenido principal al centro, barra de secciones a la izquierda, bloques a la derecha
			case COLUMN3_RIGHT: // 31 = 3 columns => Contenido principal al centro, barra de secciones a la derecha, bloques a la izquierda
				$webconfig['margin_left'] = (int) $webconfig['leftsidebar_width'] + MARGIN_EXTRA;
				$webconfig['width_left']  = (int) $webconfig['leftsidebar_width'];
				$webconfig['margin_right'] = (int) $webconfig['rightsidebar_width'] + MARGIN_EXTRA;
				$webconfig['width_right']  = (int) $webconfig['rightsidebar_width'];
			break;
		}

		$template->assign_vars(array(
			'COLUMN_DESIGN'			=> $webconfig['column_design'],
			'PHPBBWEB_MARGIN_RIGHT'	=> (int) $webconfig['margin_right'],
			'PHPBBWEB_MARGIN_LEFT'	=> (int) $webconfig['margin_left'],
			'PHPBBWEB_LEFT_WIDTH'	=> (int) $webconfig['width_left'],
			'PHPBBWEB_RIGHT_WIDTH'	=> (int) $webconfig['width_right'],
		));
		
		return $css;
	}

	/**
	* @description: Generate the clock time
	* @param: 				$gmepoch = a date;
	* @return: (string) 	$time . $midnight = a formated hour HH:MM:SS am/pm
	* @version: OK
	**/
	function clock($gmepoch = '')
	{
		global $user, $template;
		global $webconfig;

		if (!$webconfig['live_clock'])
		{
			return false;
		}
		$zone_offset = (int) $user->timezone + (int) $user->dst;

		$date = preg_split('/(H:i|g:i)/', $user->lang['default_dateformat']);

		$gmepoch = ($gmepoch) ? $gmepoch : time();

		$time = gmdate('H:i:s', $gmepoch + $zone_offset);

		list($h, $m, $s) = explode(':', $time);
		$midnight = ( (int) $h > 12) ? ' pm' : ' am';

		$template->assign_vars(array(
			'CURRENT_DATE'	=> sprintf($user->lang['CURRENT_TIME'], $user->format_date(time() + $zone_offset, $date[0], true)),
			'CURRENT_TIME'	=> $time . $midnight,
		));

		return true;
	}

	/**
	* @description: Get the header background image
	*
	* @return: image src
	* @version: OK
	**/
	function get_bg()
	{
		global $user;
		global $webconfig;

		if ($webconfig['random_bg'])
		{
			$path_to_images = $this->absolute_board . 'styles/' . $user->theme['template_path'] . '/template' . $this->template_path . '/theme/images/bg';

			$images = $this->scan_disk($path_to_images);

			return $images[array_rand($images)];
		}
		return false;
	}

	/**
	* @description: Get the image logo
	*
	* @return: image src
	* @version: OK
	**/
	function get_logo()
	{
		global $user;
		global $webconfig;

		$path_to_images = $this->absolute_board . 'styles/' . $user->theme['template_path'] . '/template' . $this->template_path . '/theme/images/logo';

		if ($webconfig['random_logo'])
		{
			$images = $this->scan_disk($path_to_images);

			return $images[array_rand($images)];
		}
		else
		{
			return $path_to_images . '/' . $webconfig['logo'];
		}
	}

	/**
	* @description: Scan a specified folder for images
	*
	* @param: (string)		$path_to_images
	* @return: (array)		$files_ary
	* @version: OK
	**/
	function scan_disk($path_to_images)
	{
		$files_ary = array();

		$dp = @opendir($path_to_images);

		if ($dp)
		{
			while (($file = readdir($dp)) !== false)
			{
				if (preg_match('#\.(?:gif|jpg|png)$#', $file))
				{
					$files_ary[] = "$path_to_images/$file";
				}
			}
			closedir($dp);
		}
		return $files_ary;
	}

	/**
	* @description: Search for each category items to build the main menu
	* @return: (integer)	$navbar_first = a default category identifier
	* @version: 1.0.4
	**/
	function navbar($category_id = 0, $section_id = 0)
	{
		global $db, $template;
		global $webconfig, $config;

		// Start initial var setup
		$navbar_items = 0;
		$category_active = false;

		$sql = 'SELECT *
			FROM ' . PHPBBWEB_PAGE_TABLE . '
			WHERE page_approved = 1 AND page_type = ' . PAGE_CATEGORY . '
			ORDER BY page_order ASC';
		$result = $db->sql_query($sql);

		while ($row = $db->sql_fetchrow($result))
		{
			$category_active = (!$category_active) ? (($category_id == $row['page_id']) ? true : false) : $category_active;

			$template->assign_block_vars('navbar', array(
				'CATEGORY_ID'		=> $row['page_id'],
				'CATEGORY_ACTIVE'	=> ($category_id == $row['page_id']) ? true : false,
				'CATEGORY_NAME'		=> $row['page_subject'],
				'U_CATEGORY'		=> append_sid(PHPBBWEB_INDEX, array('category' => $row['page_id'])),
				'S_NEW_WINDOW'		=> ($row['redirect_url'] != '' && $row['redirect_open'] == REDIRECT_POPWINDOWS) ? true : false,
				'S_NEW_TAB'			=> ($row['redirect_url'] != '' && $row['redirect_open'] == REDIRECT_NEWWINDOWS) ? true : false,
			));
			$navbar_items++;
		}
		$db->sql_freeresult($result);

		$contact_mail = (isset($webconfig['email']) && $webconfig['email']) ? $webconfig['email'] : ((isset($config['board_email']) && $config['board_email']) ? $config['board_email'] : '');
		// Check if email is enabled
		$contact_form = ($webconfig['contact'] && ($config['email_enable']) && $contact_mail) ? true : false;

		$template->assign_vars(array(
			'S_NAVBAR'			=> ($navbar_items || $contact_form) ? true : false,
			'S_NAVIGATION'		=> ($webconfig['breadcrumbs']) ? true : false,
			'NAVIGATION'		=> $this->breadcrumbs(),
			// we have an active category ?, if not index is the one
			'CATEGORY_ACTIVE'	=> $category_active,
			'S_CONTACT_FORM'	=> $contact_form,
			'U_CONTACT_FORM'	=> append_sid(PHPBBWEB_INDEX, array('mode' => 'email')),
		));

		return;
	}

	/**
	* @description: Build navigation links for given page
	* @param: (integer)		$category_id = category identifier
	* @param: (integer)		$section_id = section identifier
	* @return: (string)		$navigation = html
	* @version: 1.0.3
	**/
	function breadcrumbs()
	{
		global $webconfig;

		if (!$webconfig['breadcrumbs'])
		{
			return false;
		}

		global $category_id, $section_id;

		$navigation = '';
		$navigation_separator = ' <strong>&#8249;</strong> ';

		if ($category_id)
		{
			$category_data = $this->get_page_data($category_id, PAGE_CATEGORY);
			$navigation .= $navigation_separator . '<a href="' . append_sid(PHPBBWEB_INDEX, array("category" => $category_data['page_id'])) . '">' . $category_data['page_subject'] . '</a>';
		}

		if ($section_id)
		{
			$section_data = $this->get_page_data($section_id, PAGE_SECTION);
			$navigation .= $navigation_separator . '<a href="' . append_sid(PHPBBWEB_INDEX, array('section' => $section_data['page_id'])) . '">' . $section_data['page_subject'] . '</a>';
		}

		return $navigation;
	}

	/**
	* @description: Search for each category items if have a section to build the left menu
	* @param: (integer)		$category_id = category identifier
	* @return: (integer)	$section_first = a default section identifier
	* @version: 1.0.4
	**/
	function right_menu($category_id, $section_id)
	{
		global $db, $template;

		// Start initial var setup
		$category_id = (int) $category_id;

		if (!$category_id)
		{
			return;
		}

		$section_data = array();

		$sql = 'SELECT *
			FROM ' . PHPBBWEB_PAGE_TABLE . "
			WHERE parent_id = $category_id AND page_type = " . PAGE_SECTION . " AND page_approved = 1
			ORDER BY page_order ASC";
		$result = $db->sql_query($sql);
		while ($row = $db->sql_fetchrow($result))
		{
			$section_data[] = $row;
		}
		$db->sql_freeresult($result);

		foreach ($section_data as $row)
		{
			$active = ($section_id == $row['page_id']) ? true : false;

			$template->assign_block_vars('section', array(
				'SECTION_ID'	=> $row['page_id'],
				'SECTION_NAME'	=> $row['page_subject'],
				'U_SECTION'		=> ($active) ? '' : append_sid(PHPBBWEB_INDEX, array('section' => $row['page_id'])),
				'S_NEW_WINDOW'		=> ($row['redirect_url'] != '' && $row['redirect_open'] == REDIRECT_POPWINDOWS) ? true : false,
				'S_NEW_TAB'			=> ($row['redirect_url'] != '' && $row['redirect_open'] == REDIRECT_NEWWINDOWS) ? true : false,
			));
		}

		$category_data = $this->get_page_data($category_id, PAGE_CATEGORY);

		$template->assign_vars(array(
			'S_SECTIONS'			=> sizeof($section_data),
			'S_CATEGORY_SUBJECT'	=> $category_data['page_subject'],
			'U_CATEGORY'			=> append_sid(PHPBBWEB_INDEX, array('category' => $category_data['page_id'])),
		));

		return;
	}

	/**
	* @description: Display Extra blocks
	*	We do not use param here on propose ;)
	* @version: 102
	**/
	function right_blocks()
	{
		global $db, $template;
		global $category_id, $section_id;

		// Start initial var setup
		$block_items = 0;
		$block_data = array();
		// Get the category identifier
		$category_id = request_var('category', $category_id);
		// Get the section identifier
		$section_id = request_var('section', $section_id);

		// Get global blocks goes first
		$sql = 'SELECT *
			FROM ' . PHPBBWEB_PAGE_TABLE . "
			WHERE page_type = " . PAGE_BLOCK . "
				AND global_block = 1
				AND page_approved = 1
			ORDER BY page_order ASC";
		$result = $db->sql_query($sql);

		while ($row = $db->sql_fetchrow($result))
		{
			$block_data[] = $row;
		}
		$db->sql_freeresult($result);

		$sql_where = ($category_id) ? "parent_id = $category_id" : (($section_id) ? "parent_id = $section_id" : "parent_id = 0");

		$sql = 'SELECT *
			FROM ' . PHPBBWEB_PAGE_TABLE . "
			WHERE page_type = " . PAGE_BLOCK . "
				AND $sql_where 
				AND global_block <> 1
				AND page_approved = 1
			ORDER BY page_order ASC";
		$result = $db->sql_query($sql);

		while ($row = $db->sql_fetchrow($result))
		{
			$block_data[] = $row;
		}
		$db->sql_freeresult($result);

		foreach ($block_data as $row)
		{
			$data = array(
				'mode'				=> 'block', 
				'id'				=> $row['page_id'],
				'text'				=> $row['page_text'],
				'bbcode_bitfield'	=> $row['bbcode_bitfield'],
				'bbcode_uid'		=> $row['bbcode_uid'],
				'attachment'		=> 0,
			);

			$template->assign_block_vars('block', array(
				'BLOCK_ID'		=> $row['page_id'],
				'BLOCK_CAT_ID'	=> $row['parent_id'],
				'BLOCK_SEC_ID'	=> $row['parent_id'],
				'BLOCK_SUBJECT'	=> $row['page_subject'],
				'BLOCK_CONTENT'	=> $this->parse_content($data),
			));
			$block_items++;
		}

		$template->assign_vars(array(
			'S_BLOCKS' => sizeof($block_data),
		));
	}

	/**
	* @description: Display text for a section
	* @param: (integer)		$category_id = category identifier
	* @return: (integer)	$section_first = a default section identifier
	* @version: 1.0.4
	**/
	function display_content($category_id, $section_id)
	{
		global $user, $template;
		global $webconfig, $portal_topic_id;

		$category_id = (int) $category_id;
		$section_id = (int) $section_id;
		
		$data = array();

		/**
		* If we do not have a category or section identifier, 
		* means that we are in the very site index
		* If we have a welcome message, display it!
		**/
		if (!$category_id && !$section_id && $webconfig['welcome_message'] != '' && $webconfig['welcome_message_approved'])
		{
			// Have we any block to display at right sidebar ?
			$class = ($webconfig['allow_search'] || $webconfig['portal_stat'] || ($webconfig['portal_recent_topics'] && $webconfig['portal_recent_topics_limit'] > 0)) ? '' : 'wide';
			$data = array(
				'mode'				=> 'welcome',
				'id'				=> 1,
				'class'				=> $class,
				'subject'			=> '',
				'description'		=> '',
				'text'				=> $webconfig['welcome_message'],
				'bbcode_bitfield'	=> $webconfig['welcome_message_bbcode_bitfield'],
				'bbcode_uid'		=> $webconfig['welcome_message_bbcode_uid'],
				// Force this : main page can't be redirected ;)
				'redirect'			=> 0,
				'redirect_url'		=> '',
				'attachment'		=> $webconfig['welcome_message_attachment'],
			);
		}

		if ($category_id)
		{
			$row = $this->get_page_data($category_id, PAGE_CATEGORY);

			if ($row['page_approved'] && (trim($row['page_text']) != '' || (isset($row['redirect']) && $row['redirect'] == 1 && $row['redirect_url'] != '')))
			{
				$data = array(
					'mode'				=> 'category',
					'id'				=> $row['page_id'],
					'class'				=> $row['page_class'],
					'subject'			=> $row['page_subject'],
					'description'		=> $row['page_description'],
					'text'				=> $row['page_text'],
					'bbcode_bitfield'	=> $row['bbcode_bitfield'],
					'bbcode_uid'		=> $row['bbcode_uid'],
					'redirect'			=> $row['redirect'],
					'redirect_url'		=> $row['redirect_url'],
					'attachment'		=> $row['page_attachment'],
				);
			}
			unset($row);
		}

		if ($section_id)
		{
			$row = $this->get_page_data($section_id, PAGE_SECTION);

			if ($row['page_approved'] && (trim($row['page_text']) != '' || (isset($row['redirect']) && $row['redirect'] == 1 && $row['redirect_url'] != '')))
			{
				$data = array(
					'mode'				=> 'section',
					'id'				=> $row['page_id'],
					'category_id'		=> $row['parent_id'],
					'class'				=> $row['page_class'],
					'subject'			=> $row['page_subject'],
					'description'		=> $row['page_description'],
					'text'				=> $row['page_text'],
					'bbcode_bitfield'	=> $row['bbcode_bitfield'],
					'bbcode_uid'		=> $row['bbcode_uid'],
					'redirect'			=> $row['redirect'],
					'redirect_url'		=> $row['redirect_url'],
					'attachment'		=> $row['page_attachment'],
				);
				global $category_id;

				$category_id = $row['parent_id'];
			}
			unset($row);
		}

		/**
		* We do not have anything to display?
		* let's try to find out what we can display to do not leave emty the site index
		**/
		if (!sizeof($data))
		{
			return $this->get_default_page($category_id, $section_id);
		}
		else if ($data['mode'] == 'welcome')
		{
			// Do not display if there are no importan post to display or there is a requested topic from the 'portal_important_topics'
			if ($webconfig['portal_important_posts'] != '' &&  !$portal_topic_id)
			{
				$this->phpbbweb_portal_important('important_posts', $webconfig['portal_important_posts']);
			}

			// Do not display if there are no recent topics to display or there is a requested topic from the 'portal_important_topics'
			if ($webconfig['portal_recent_topics'] && $webconfig['portal_recent_topics_limit'] > 0 &&  !$portal_topic_id)
			{
				$this->phpbbweb_portal_recent_topics($webconfig['portal_recent_topics_limit']);
			}

			if ($webconfig['portal_important_topics'] != '') // &&  !$portal_topic_id)
			{
				$this->phpbbweb_portal_important('important_topics', $webconfig['portal_important_topics']);
			}

			if ($webconfig['portal_stat'])
			{
				$this->phpbbweb_portal_get_stat();
			}
		}

		// Check if we need to redirect
		if ($data['redirect'] == 1 && $data['redirect_url'] != '')
		{
			$this_page = $user->extract_current_page(PHPBBWEB_ROOT);

			// Do not redirect_url id the page is the current page
			if (strpos($data['redirect_url'], substr($this_page['page'], 0, 199)) === false)
			{
			//	phpbbweb_redirect($data['redirect_url']);
				redirect($data['redirect_url']);
			}
		}

		// Display text
		$template->assign_vars(array(
			'PAGE_TITLE'		=> ($section_id || $category_id) ? censor_text($data['subject']) : $user->lang['INDEX'],
			'MAIN_ID'			=> $data['id'],
			'MAIN_CLASS'		=> strtolower($data['class']),
			'MAIN_TITLE'		=> censor_text($data['subject']),
			'MAIN_CONTENT'		=> $this->parse_content($data),
		));

		/**
		* We overwrite $category_id if there is no category specified
		* to be able to display the correct menu list.
		* One downside is that the user currently viewing this topic/post is not taken into account.
		**/
		if (!$category_id && isset($data['category_id']))
		{
			global $category_id;
			$category_id = $data['category_id'];
		}
	}

	/**
	* Adds a list with a number of recent topics to the index.php
	*
	* @param integer	$num_items = Number of items to fetch.
	* @version: 1.0.2
	**/
	function phpbbweb_portal_recent_topics($num_items = 5)
	{
		global $auth, $db, $user, $template, $cache;
		global $phpbb_root_path, $phpEx, $config, $webconfig;

		$forum_ids_read = array_keys($auth->acl_getf('f_read', true));
		if (empty($forum_ids_read))
		{
			return false;
		}

		$in_fid_ary = array_diff($forum_ids_read, $this->get_passworded_forums());
		if (empty($in_fid_ary))
		{
			return false;
		}

		include($phpbb_root_path . 'includes/functions_display.' . $phpEx);

		// Grab icons
		$icons = $cache->obtain_icons();

		// Add global forum
		$in_fid_ary[] = 0;

		// We really have to get the post ids first!
		$sql = 'SELECT topic_id, forum_id, topic_type, topic_last_post_id, topic_last_post_time
			FROM ' . TOPICS_TABLE . '
			WHERE ' . $db->sql_in_set('forum_id', $in_fid_ary) . '
				AND topic_moved_id = 0
				AND topic_approved = 1
			ORDER BY topic_last_post_time DESC';
		$result = $db->sql_query_limit($sql, $num_items);

		$post_ids = array();
		$forum_ids = $ga_topic_ids = array();
		while ($row = $db->sql_fetchrow($result))
		{
			$post_ids[] = (int) $row['topic_last_post_id'];
			
			if ($row['topic_type'] == POST_GLOBAL)
			{
				$ga_topic_ids[] = $row['topic_id'];
			}
			else
			{
				$forums[$row['forum_id']][] = $row['topic_id'];
			}
		}
		$db->sql_freeresult($result);

		if (empty($post_ids))
		{
			return false;
		}

		$topic_tracking_info = array();
		foreach ($forum_ids as $forum_id => $topic_ids)
		{
			$topic_tracking_info[$forum_id] = get_complete_topic_tracking($forum_id, $topic_ids, $ga_topic_ids);
		}

		$sql = array(
			'SELECT'	=> 'f.forum_id, f.forum_name, 
							t.*, 
							p.post_id, p.post_time',
			'FROM'		=> array(
				TOPICS_TABLE	=> 't',
				POSTS_TABLE		=> 'p',
			),
			'LEFT_JOIN'	=> array(
				array(
					'FROM'	=> array(FORUMS_TABLE => 'f'),
					'ON'	=> 'p.forum_id = f.forum_id',
				),
			),
			'WHERE'		=> 'p.topic_id = t.topic_id
							AND ' . $db->sql_in_set('p.post_id', $post_ids),
			'ORDER_BY'	=> 'p.post_time DESC',
		);

		// Query database
		$sql = $db->sql_build_query('SELECT', $sql);

		$result = $db->sql_query($sql);

		// Iterate through items
		$recent_topics_items = 0;
		while ($row = $db->sql_fetchrow($result))
		{
			$forum_id = $row['forum_id'];
			$topic_id = $row['topic_id'];
			$post_id = $row['post_id'];
			$replies = ($auth->acl_get('m_approve', $forum_id)) ? $row['topic_replies_real'] : $row['topic_replies'];
			$unread_topic = (isset($topic_tracking_info[$forum_id][$topic_id]) && $row['topic_last_post_time'] > $topic_tracking_info[$forum_id][$topic_id]) ? true : false;
			$topic_unapproved = (!$row['topic_approved'] && $auth->acl_get('m_approve', $forum_id)) ? true : false;
			$posts_unapproved = ($row['topic_approved'] && $row['topic_replies'] < $row['topic_replies_real'] && $auth->acl_get('m_approve', $forum_id)) ? true : false;

			$view_forum_url = append_sid(PHPBB_VIEWFORUM, 'f=' . $forum_id);
			$view_topic_url = append_sid(PHPBB_VIEWTOPIC, 'f=' . $forum_id . '&amp;t=' . $topic_id);

			$folder_img = $folder_alt = $topic_type = '';
			switch ($row['topic_type'])
			{
				case POST_GLOBAL:
					$topic_type = $user->lang['VIEW_TOPIC_GLOBAL'];
					$folder_img = (!$unread_topic) ? 'global_read' : 'global_unread';
				break;
				case POST_ANNOUNCE:
					$topic_type = $user->lang['VIEW_TOPIC_ANNOUNCEMENT'];
					$folder_img = (!$unread_topic) ? 'announce_read' : 'announce_unread';
				break;
				case POST_STICKY:
					$topic_type = $user->lang['VIEW_TOPIC_STICKY'];
					$folder_img = (!$unread_topic) ? 'sticky_read' : 'sticky_unread';
				break;
				default:
					$topic_type = '';
					$folder_img = (!$unread_topic) ? 'topic_read' : 'topic_unread';
					if ($config['hot_threshold'] && $replies >= $config['hot_threshold'] && $row['topic_status'] != ITEM_LOCKED)
					{
						$folder_img .= '_hot';
					}
				break;
			}

			if ($row['topic_status'] == ITEM_LOCKED)
			{
				$topic_type = $user->lang['VIEW_TOPIC_LOCKED'];
				$folder_img .= '_locked';
			}
			if ($row['topic_poster'] == $user->data['user_id'])
			{
				$folder_img .= '_mine';
			}
			if ($row['topic_type'] == POST_GLOBAL)
			{
				$global_announce_list[$row['topic_id']] = true;
			}

			$folder_alt = ($unread_topic) ? 'NEW_POSTS' : (($row['topic_status'] == ITEM_LOCKED) ? 'TOPIC_LOCKED' : 'NO_NEW_POSTS');
			if ($row['poll_start'] && $row['topic_status'] != ITEM_MOVED)
			{
				$topic_type = $user->lang['VIEW_TOPIC_POLL'];
			}

			$template->assign_block_vars('recent_topics', array(
				'FORUM_ID'					=> $forum_id,
				'TOPIC_ID'					=> $topic_id,
				'POST_ID'					=> $post_id,
				'TOPIC_FOLDER_IMG'			=> $user->img($folder_img, $folder_alt),
				'TOPIC_FOLDER_IMG_SRC'		=> $user->img($folder_img, $folder_alt, false, '', 'src'),
				'TOPIC_ICON_IMG'			=> (!empty($icons[$row['icon_id']])) ? $icons[$row['icon_id']]['img'] : '',
				'TOPIC_FOLDER_IMG_ALT'		=> $user->lang[$folder_alt],
				'S_UNREAD_TOPIC'			=> $unread_topic,
				'U_NEWEST_POST'				=> $view_topic_url . '&amp;view=unread#unread',
				'TOPIC_TITLE'				=> censor_text($row['topic_title']),
				'S_TOPIC_UNAPPROVED'		=> $topic_unapproved,
				'S_POSTS_UNAPPROVED'		=> $posts_unapproved,
				'UNAPPROVED_IMG'			=> ($topic_unapproved || $posts_unapproved) ? $user->img('icon_topic_unapproved', ($topic_unapproved) ? 'TOPIC_UNAPPROVED' : 'POSTS_UNAPPROVED') : '',
				'S_TOPIC_REPORTED'			=> ($row['topic_reported'] && $auth->acl_get('m_report', $forum_id)) ? true : false,
				'PAGINATION'				=> topic_generate_pagination($replies, $view_topic_url),
				'ATTACH_ICON_IMG'			=> ($auth->acl_get('u_download') && $auth->acl_get('f_download', $forum_id) && $row['topic_attachment']) ? $user->img('icon_topic_attach', $user->lang['TOTAL_ATTACHMENTS']) : '',
				'TOPIC_AUTHOR_FULL'			=> get_username_string('full', $row['topic_poster'], $row['topic_first_poster_name'], $row['topic_first_poster_colour']),
				'FIRST_POST_TIME'			=> $user->format_date($row['topic_time']),
				'U_VIEW_TOPIC'				=> $view_topic_url,
				'U_VIEW_FORUM'				=> $view_forum_url,
				'FORUM_NAME'				=> $row['forum_name'],
				'REPLIES'					=> $replies,
				'VIEWS'						=> $row['topic_views'],
				'LAST_POST_AUTHOR_FULL'		=> get_username_string('full', $row['topic_last_poster_id'], $row['topic_last_poster_name'], $row['topic_last_poster_colour']),
				'U_LAST_POST'				=> $view_topic_url . '&amp;p=' . $row['topic_last_post_id'] . '#p' . $row['topic_last_post_id'],
				'LAST_POST_IMG'				=> ($unread_topic) ? $user->img('icon_topic_newest', 'VIEW_NEWEST_POST') : $user->img('icon_topic_latest', 'VIEW_LATEST_POST'),
				'LAST_POST_TIME'			=> $user->format_date($row['topic_last_post_time']),
			));
			$recent_topics_items++;
		}
		$db->sql_freeresult($result);

		$template->assign_vars(array(
			'PORTAL_RECENT_POSITION'	=> $webconfig['portal_recent_topics'],
			'PORTAL_RECENT_TOPICS'		=> ($recent_topics_items) ? true : false,
		));
	}

	/**
	* Built a block with specified topics
	*
	* @param: array		$selected_ids = topics to display
	* @version: 1.0.4
	**/
	function phpbbweb_portal_important($block = 'important_topics', $selected_ids)
	{
		$selected_ids = (!empty($selected_ids)) ? unserialize(trim($selected_ids)) : array();

		if (empty($selected_ids))
		{
			return;
		}

		global $template, $db, $auth, $user;
		global $phpbb_root_path, $phpEx, $config;

		if ($block == 'important_posts')
		{
			// Go ahead and pull all data for this topic
			$sql = $db->sql_build_query('SELECT', array(
				'SELECT'	=> 'u.*, p.*',
				'FROM'		=> array(
					USERS_TABLE		=> 'u',
					POSTS_TABLE		=> 'p',
				),
				'WHERE'		=> $db->sql_in_set('p.post_id', $selected_ids) . '
					AND u.user_id = p.poster_id',
				'ORDER BY p.post_time'
			));

			$result = $db->sql_query($sql);

			$postcount	= 0;
			if ($result = $db->sql_query($sql))
			{
				while ($row = $db->sql_fetchrow($result))
				{
					$message = utf8_normalize_nfc($row['post_text']);
					$uid = $row['bbcode_uid'];
					$bitfield = $row['bbcode_bitfield'];
					$allow_bbcode = $row['enable_bbcode'];
					$allow_urls = $row['enable_magic_url'];
					$allow_smilies = $row['enable_smilies'];
					$options = (($allow_bbcode) ? OPTION_FLAG_BBCODE : 0) + (($allow_smilies) ? OPTION_FLAG_SMILIES : 0) + (($allow_urls) ? OPTION_FLAG_LINKS : 0);
					$message = generate_text_for_display($message, $uid, $bitfield, $options);

					// Pull attachment data
					$attachments = $attach_list = $update_count = array();
					$has_attachments = false;
					$total_posts = 1;
					// Does post have an attachment? If so, add it to the list
					if ($row['post_attachment'] && $config['allow_attachments'])
					{
						$post_id = (int) $row['post_id'];
						$forum_id = (int) $row['forum_id'];
						$attach_list[] = $post_id;

						if ($row['post_approved'])
						{
							$has_attachments = true;
						}
					}

					// Pull attachment data
					if (sizeof($attach_list))
					{
						if ($auth->acl_get('u_download') && $auth->acl_get('f_download', $forum_id))
						{
							$sql = 'SELECT *
							FROM ' . ATTACHMENTS_TABLE . '
							WHERE ' . $db->sql_in_set('post_msg_id', $attach_list) . '
								AND in_message = 0
							ORDER BY filetime DESC, post_msg_id ASC';
							$result = $db->sql_query($sql);
							
							while ($row_attach = $db->sql_fetchrow($result))
							{
								$attachments[$row_attach['post_msg_id']][] = $row_attach;
							}
							$db->sql_freeresult($result);
						}
						else
						{
							$display_notice = true;
						}

						if (!empty($attachments[$post_id]))
						{
							parse_attachments($forum_id, $message, $attachments[$post_id], $update_count);
						}
					}

					$template->assign_block_vars('important_posts', array(
						'POSTS_TITLE'	=> $row['post_subject'],
						'TOPIC_ID'		=> $row['topic_id'],
						'POST_ID'		=> $row['post_id'],
						'POSTS_MESSAGE'		=> $message,
						'U_VIEW_TOPIC'		=> append_sid(PHPBB_VIEWTOPIC, array('f' => $row['forum_id'], 't' => $row['topic_id'])),
						'POST_AUTHOR_FULL'	=> get_username_string('full', $row['poster_id'], $row['username'], $row['user_colour'], $row['post_username']),
						'POST_DATE'			=> $user->format_date($row['post_time'], false, false),
						'MINI_POST_IMG'		=> $user->img('icon_post_target', 'POST'),
						'U_MINI_POST'		=> append_sid(PHPBB_VIEWTOPIC, 'p=' . $row['post_id']) . '#p' . $row['post_id'],
						'S_HAS_ATTACHMENTS'	=> (!empty($attachments[$row['post_id']])) ? true : false,
					));

					// Display not already displayed Attachments for this post, we already parsed them. ;)
					if (!empty($attachments[$row['post_id']]))
					{
						foreach ($attachments[$row['post_id']] as $attachment)
						{
							$template->assign_block_vars('important_posts.attachments', array(
								'DISPLAY_ATTACHMENT'	=> $attachment)
							);
						}
					}

					$postcount++;
				}
				$db->sql_freeresult($result);
			}

			$template->assign_vars(array(
				'S_PORTAL_IMPORTANT_POSTS'	=> $postcount,
			));

			return;
		}

		if ($block == 'important_topics')
		{
			// Go ahead and pull all data for this topic
			$sql = 'SELECT forum_id, topic_id, topic_title
				FROM ' . TOPICS_TABLE . "
				WHERE " . $db->sql_in_set('topic_id', $selected_ids) . "
				ORDER BY topic_time";
			$result = $db->sql_query($sql);

			$postcount	= 0;
			if ($result = $db->sql_query($sql))
			{
				while ($row = $db->sql_fetchrow($result))
				{
					$template->assign_block_vars('important_topics', array(
						'TOPIC_TITLE'	=> $row['topic_title'],
						'TOPIC_ID'		=> $row['topic_id'],
						'U_TOPIC'		=> append_sid(PHPBBWEB_INDEX, array('topic' => $row['topic_id'])),
					));
					$postcount++;
				}
				$db->sql_freeresult($result);
			}

			$template->assign_vars(array(
				'S_PORTAL_IMPORTANT_TOPICS'	=> $postcount,
			));
		}
	}

	/**
	* Enter description here...
	*
	* @param: integer	$topic_id = topic to display
	* @version: 1.0.3
	**/
	function display_topic_content($topic_id)
	{
		global $template, $db, $auth, $user;
		global $phpbb_root_path, $phpEx, $config, $webconfig;

		$sql = array(
			'SELECT'	=> 'f.forum_id, f.forum_name, f.forum_password, 
							t.topic_id, t.topic_title, t.topic_poster, t.topic_first_poster_name, t.topic_replies, t.topic_views, t.topic_time, t.topic_type, t.topic_first_poster_colour, t.topic_approved, 
							p.topic_id, p.poster_id, p.post_id, p.post_time, p.post_attachment, p.post_approved, p.post_text, p.bbcode_uid, p.bbcode_bitfield, p.enable_bbcode, p.enable_smilies, p.enable_magic_url, p.post_attachment',
			'FROM'		=> array(
				TOPICS_TABLE	=> 't',
				POSTS_TABLE		=> 'p',
			),
			'LEFT_JOIN'	=> array(
				array(
					'FROM'	=> array(FORUMS_TABLE => 'f'),
					'ON'	=> 'p.forum_id = f.forum_id',
				),
			),
			'WHERE'		=> "p.topic_id = t.topic_id
							AND t.topic_id = $topic_id",
			'ORDER_BY'	=> 'p.post_time ASC',
		);
		$sql = $db->sql_build_query('SELECT', $sql);
		$result = $db->sql_query_limit($sql, 1);
		$topic_data = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);

		$selected_ids = $webconfig['portal_important_topics'];
		$selected_ids = (!empty($selected_ids)) ? unserialize(trim($selected_ids)) : array();

		if (!in_array($topic_id, $selected_ids))
		{
			$topic_data = array();
		}
		if (!$topic_data)
		{
			phpbbweb_msg_handler('NO_TOPIC');
		}
		else
		{
			// Have we any block to display at right sidebar ?
			$class = ($webconfig['allow_search'] || $webconfig['portal_stat'] || ($webconfig['portal_recent_topics'] && $webconfig['portal_recent_topics_limit'] > 0)) ? '' : 'wide';
			$topic_data = array_merge($topic_data, array(
				'mode'		=> 'welcome',
				'class'		=> $class,
			));

			$forum_id = $topic_data['forum_id'];
			$topic_id = $topic_data['topic_id'];
			$post_id = $topic_data['post_id'];

			// Start auth check
			if (!$topic_data['topic_approved'] && !$auth->acl_get('m_approve', $forum_id))
			{
				phpbbweb_msg_handler('NO_TOPIC');
			}
			// Forum is passworded ... check whether access has been granted to this
			if (!$auth->acl_get('f_read', $forum_id) || $topic_data['forum_password'])
			{
				phpbbweb_msg_handler('SORRY_AUTH_READ');
			}

			// Display text
			$flags = OPTION_FLAG_BBCODE + OPTION_FLAG_SMILIES+ OPTION_FLAG_LINKS;
			$message = generate_text_for_display($topic_data['post_text'], $topic_data['bbcode_uid'], $topic_data['bbcode_bitfield'], $flags);

			// Pull attachment data
			$attachments = $attach_list = $update_count = array();
			$has_attachments = false;
			$total_posts = 1;
			// Does post have an attachment? If so, add it to the list
			if ($topic_data['post_attachment'] && $config['allow_attachments'])
			{
				$attach_list[] = (int) $post_id;

				if ($topic_data['post_approved'])
				{
					$has_attachments = true;
				}
			}

			// Pull attachment data
			if (sizeof($attach_list))
			{
				if ($auth->acl_get('u_download') && $auth->acl_get('f_download', $forum_id))
				{
					$sql = 'SELECT *
						FROM ' . ATTACHMENTS_TABLE . '
						WHERE ' . $db->sql_in_set('post_msg_id', $attach_list) . '
							AND in_message = 0
						ORDER BY filetime DESC, post_msg_id ASC';
					$result = $db->sql_query($sql);
					while ($row_attach = $db->sql_fetchrow($result))
					{
						$attachments[$row_attach['post_msg_id']][] = $row_attach;
					}
					$db->sql_freeresult($result);
				}
				else
				{
					$display_notice = true;
				}

				if (!empty($attachments[$post_id]))
				{
					parse_attachments($forum_id, $message, $attachments[$post_id], $update_count);
				}
			}

			$template->assign_vars(array(
				'MAIN_CONTENT'		=> false,
				'S_ROW_COUNT'		=> $post_id,
				'POST_ID'			=> "f_{$forum_id}_t_{$topic_id}_p_{$post_id}",
				'POST_CLASS'		=> strtolower($topic_data['class']),

				'U_FORUM'			=> append_sid(PHPBB_VIEWFORUM, array('f' => $forum_id)),
				'FORUM_NAME'		=> $topic_data['forum_name'],

				'TOPIC_TITLE'		=> $topic_data['topic_title'],
				'U_TOPIC'			=> append_sid(PHPBB_VIEWTOPIC, array('f' => $forum_id, 't' => $topic_id)),

				'POST_CONTENT'		=> $message,
				'MAIN_DESC'			=> $this->display_description($topic_data['post_text'], $topic_data['bbcode_uid'], ''),
				'S_HAS_ATTACHMENTS'	=> (!empty($attachments[$post_id])) ? true : false,

				'TOPIC_VIEWS'		=> $topic_data['topic_views'],
				'TOPIC_REPLIES'		=> $topic_data['topic_replies'],
				'TOPIC_TIME'		=> $user->format_date($topic_data['topic_time']),
				'MINI_POST_IMG'		=> $user->img('icon_post_target', 'POST'),
				'U_MINI_POST'		=> append_sid(PHPBB_VIEWTOPIC, 'p=' . $post_id) . (($topic_data['topic_type'] == POST_GLOBAL) ? '&amp;f=' . $forum_id : '') . '#p' . $post_id,

				'TOPIC_AUTHOR_FULL'	=> get_username_string('full', $topic_data['topic_poster'], $topic_data['topic_first_poster_name'], $topic_data['topic_first_poster_colour']),
			));

			// Display not already displayed Attachments for this post, we already parsed them. ;)
			if (!empty($attachments[$post_id]))
			{
				foreach ($attachments[$post_id] as $attachment)
				{
					$template->assign_block_vars('post_attachment', array(
						'DISPLAY_ATTACHMENT'	=> $attachment)
					);
				}
			}
		}

		$template->set_filenames(array(
			'body' => 'phpbbweb/phpbbweb_index_body.html')
		);

		page_footer();
	}

	/**
	* Show forum Statistics
	* @version: 1.0.2
	**/
	function phpbbweb_portal_get_stat()
	{
		global $template, $user, $config;

		// Which timezone?
		$tz = ($user->data['user_id'] != ANONYMOUS) ? strval(doubleval($user->data['user_timezone'])) : strval(doubleval($config['board_timezone']));

		// Days since board start
		$boarddays = (time() - $config['board_startdate']) / 86400;

		// Assign index specific vars
		$template->assign_vars(array(
			'S_PORTAL_STAT'			=> true,
			'STAT_BOARD_STARTED'	=> $user->format_date($config['board_startdate']),
			'STAT_BOARD_DAYS'		=> floor(abs((time() - $config['board_startdate']) / (60 * 60 * 24))),
			'STAT_BOARD_VERSION'	=> $config['version'],
			'STAT_TIMEZONE'			=> ($user->data['user_dst'] || ($user->data['user_id'] != ANONYMOUS && $config['board_dst'])) ? $user->lang['tz'][$tz] . ' - ' . $user->lang['tz']['dst'] : $user->lang['tz'][$tz], '',

			'STAT_TOTAL_POSTS'		=> $config['num_posts'],
			'STAT_POSTS_PER_DAY'	=> sprintf('%.2f', $config['num_posts'] / $boarddays),
			'STAT_TOTAL_TOPICS'		=> $config['num_topics'],
			'STAT_TOPICS_PER_DAY'	=> sprintf('%.2f', $config['num_topics'] / $boarddays),
			'STAT_TOTAL_USERS'		=> $config['num_users'],
			'STAT_TOTAL_ATTACH'		=> $config['num_files'],
			'STAT_USERS_PER_DAY'	=> sprintf('%.2f', $config['num_users'] / $boarddays),
			'STAT_NEWEST_USER'		=> get_username_string('full', $config['newest_user_id'], $config['newest_username'], $config['newest_user_colour']),
			'PORTAL_ONLINE_USERS'	=> sprintf($user->lang['RECORD_ONLINE_USERS'], $config['record_online_users'], $user->format_date($config['record_online_date'], false, true)),
		));
	}

	/**
	* Enter description here...
	*
	* @return unknown
	**/
	function get_passworded_forums()
	{
		global $db, $user;

		// Exclude passworded forums
		$sql = 'SELECT f.forum_id, fa.user_id
			FROM ' . FORUMS_TABLE . ' f
			LEFT JOIN ' . FORUMS_ACCESS_TABLE . " fa
				ON (fa.forum_id = f.forum_id
					AND fa.session_id = '" . $db->sql_escape($user->session_id) . "')
			WHERE f.forum_password <> ''";
		$result = $db->sql_query($sql);

		$forum_ids = array();
		while ($row = $db->sql_fetchrow($result))
		{
			$forum_id = (int) $row['forum_id'];

			if ($row['user_id'] != $user->data['user_id'])
			{
				$forum_ids[$forum_id] = $forum_id;
			}
		}
		$db->sql_freeresult($result);

		return $forum_ids;
	}

	/**
	* @description: We do not have anything to display?
	* let's try to find out what we can display to do not leave emty the site index
	* @param: (integer)		$category_id = category identifier
	* @return: (integer)	$section_first = a default section identifier
	* @version: OK
	**/
	function get_default_page($category_id = 0, $section_id = 0)
	{
		global $db;

		$new_category_id = 0;
		$new_section_id = 0;

		if (!$category_id && !$section_id)
		{
			// Start finding the first enabled category that contain text
			$sql = 'SELECT page_id, parent_id, page_type, page_approved, page_order, page_text, redirect, redirect_url 
					FROM ' . PHPBBWEB_PAGE_TABLE . "
					WHERE parent_id = 0 AND page_type = " . PAGE_CATEGORY . " AND page_approved = 1
					ORDER BY page_order ASC";
			$result_c = $db->sql_query($sql);

			while ($row = $db->sql_fetchrow($result_c))
			{
				$categoryid = $row['page_id'];
				// If this category is enabled and have a text, we can break here
				if ($row['page_text'] != '' || (isset($row['redirect']) && $row['redirect'] == 1 && $row['redirect_url'] != ''))
				{
					$new_category_id = $categoryid;
					break;
				}
				else
				{
					// then find the first enabled section that contain text
					$sql = 'SELECT page_id, parent_id, page_type, page_approved, page_order, page_text, redirect, redirect_url 
							FROM ' . PHPBBWEB_PAGE_TABLE . "
							WHERE parent_id = $categoryid AND page_type = " . PAGE_SECTION . " AND page_approved = 1
							ORDER BY page_order ASC";
					$result_s = $db->sql_query($sql);

					while ($row = $db->sql_fetchrow($result_s))
					{
						// If this section is enabled and have a text, we can break here
						if ($row['page_text'] != '' || (isset($row['redirect']) && $row['redirect'] == 1 && $row['redirect_url'] != ''))
						{
							$new_section_id = $row['page_id'];
							break;
						}
					}
					$db->sql_freeresult($result_s);
				}

				if ($new_category_id || $new_section_id)
				{
					break;
				}
			}
			$db->sql_freeresult($result_c);

			if ($new_category_id || $new_section_id)
			{
				global $category_id, $section_id;

				$category_id = $new_category_id;
				$section_id = $new_section_id;

				return $this->display_content($new_category_id, $new_section_id);
			}
			else
			{
				phpbbweb_msg_handler('NO_PAGE');
			}
		}
		// Start finding the first enabled section that contain text for this category
		else if ($category_id)
		{
			$sql = 'SELECT page_id, parent_id, page_type, page_approved, page_order, page_text, redirect, redirect_url 
					FROM ' . PHPBBWEB_PAGE_TABLE . "
					WHERE parent_id = $category_id AND page_type = " . PAGE_SECTION . " AND page_approved = 1
					ORDER BY page_order ASC";
			$result_s = $db->sql_query($sql);

			while ($row = $db->sql_fetchrow($result_s))
			{
				// If this section is enabled and have a text, we can break here
				if ($row['page_text'] != '' || ($row['redirect'] == 1 && $row['redirect_url'] != ''))
				{
					$new_section_id = $row['page_id'];
					break;
				}
			}
			$db->sql_freeresult($result_s);

			if ($new_section_id)
			{
				global $section_id;

				$section_id = $new_section_id;
				return $this->display_content($category_id, $section_id);
			}
			else
			{
				phpbbweb_msg_handler('NO_CATEGORY_DATA');
			}
		}
		else
		{
			$msg = ($category_id) ? 'NO_CATEGORY_DATA' : (($section_id) ? 'NO_SECTION_DATA' : 'NO_PAGE');
			phpbbweb_msg_handler($msg);
		}
	}

	/**
	* @description: parse a text for Display
	* @param: (array)		$row = message content
	* @version: OK
	**/
	function parse_content(&$row)
	{
		global $user, $auth, $db, $template;
		global $config;

		$has_attachments = $display_notice = false;

		$mode = $row['mode'];

		$message = $row['text'];
		$bitfield = $row['bbcode_bitfield'];
		$uid = $row['bbcode_uid'];
		$id = (int) $row['id'];

		$message = $this->undo_specialchars($message, $bitfield);

		// Parse the message and subject
		$message = censor_text($message);

		// Does post have an attachment? If so, add it to the list
		$attachments = $update_count = array();
		if ($row['attachment'] && $config['allow_attachments'])
		{
			$has_attachments = true;

			if ($auth->acl_get('u_download'))
			{
				$sql = 'SELECT *
					FROM ' . PHPBBWEB_ATTACHMENTS_TABLE . "
					WHERE page_id = $id
						AND in_message = 0
					ORDER BY filetime DESC";
				$result = $db->sql_query($sql);

				while ($row = $db->sql_fetchrow($result))
				{
					$attachments[] = $row;
				}
				$db->sql_freeresult($result);
			}
			else
			{
				$display_notice = true;
			}
		}

		// Instantiate BBCode if need be
		if ($bitfield)
		{
			if (!class_exists('bbcode'))
			{	
				// Patch for ABBC3 and global compatibility 
                global $phpbb_root_path, $phpEx;

				include(PHPBB_ROOT_PATH . 'includes/bbcode.' . PHP_EXT);
			}
			$bbcode = new bbcode($bitfield);

			// Second parse bbcode here
			$bbcode->bbcode_second_pass($message, $uid, $bitfield);
		}

		$message = bbcode_nl2br($message);
		$message = smiley_text($message);

		if (!empty($attachments))
		{
			phpbbweb_parse_attachments(true, $message, $attachments, $update_count);

			// Display not already displayed Attachments for this post, we already parsed them. ;)
			foreach ($attachments as $attachment)
			{
				$template->assign_block_vars('attachment', array(
					'DISPLAY_ATTACHMENT'	=> $attachment,
				));
			}

			// Update the attachment view counters... but only for humans and if this is the first 'page view'
			if (sizeof($update_count) && (isset($user->data['session_page']) && !$user->data['is_bot'] && isset($user->data['session_created'])))
			{
				$sql = 'UPDATE ' . PHPBBWEB_ATTACHMENTS_TABLE . '
					SET download_count = download_count + 1
					WHERE ' . $db->sql_in_set('attach_id', array_unique($update_count));
				$db->sql_query($sql);
			}
		}

		// Display text
		$template->assign_vars(array(
			'MAIN_DESC'			=> $this->display_description($row['text'], $uid, ((isset($row['description']) && $row['mode'] != 'block') ? $row['description'] : '')),
			'S_DISPLAY_NOTICE'	=> $display_notice && $has_attachments,
			'S_HAS_ATTACHMENTS'	=> (!empty($attachments)) ? true : false,
		));

		unset($attachments);

		return $message;
	}

	/**
	* Enter description here...
	*
	* @param (string) $content = page text
	* @param (string) $uid = bbcode 
	* @param (string) $description = page description
	* 
	* @version: 1.0.3-pl2
	**/
	function display_description($content = '', $uid = '', $description = '')
	{
		global $config, $webconfig;

		if (!$webconfig['meta_description_dynamic'] && (!$content && !$description))
		{
			return;
		}

		global $template;

		// If this page have his own description, use it!
		if ($description != '')
		{
			$template->assign_block_vars('metawordcloud', array(
				'WORD' 	=> trim(strip_tags($description)),
			));
		}
		// If this page have not his own description, generate it from the content
		else
		{
			$meta_description = '';
			if ($uid)
			{
				$text_only_message = str_replace('[*:' . $uid . ']', '&sdot;&nbsp;', $content);
				$text_only_message = $this->undo_specialchars($text_only_message, $uid);
				// no BBCode in text only message
				strip_bbcode($text_only_message, $uid);
				$meta_description = $text_only_message;
			}
			else
			{
				$meta_description = $content;
			}

			// The meta description tag should not have more than 250 characters
			$meta_limit = 250;
			$meta_count = 0;
			// Select min length depending on the method used to search
			$word_length = (basename($config['search_type']) == 'fulltext_native') ? $config['fulltext_native_min_chars'] : $config['fulltext_mysql_min_word_len'];

			$meta_description_array = preg_split("/[\s\.,]+/", $meta_description);
			$meta_description_array = array_unique($meta_description_array);
			$meta_description_limit = (int) ($meta_limit - sizeof($meta_description_array));

			if ($meta_description_limit > 0)
			{
				$_description = '';
				foreach ($meta_description_array as $description)
				{
					// remove short words
					if (strlen($description) < $word_length + 1)
					{
						continue;
					}
					if ($meta_count > $meta_limit)
					{
						break;
					}

					$template->assign_block_vars('metawordcloud', array(
						'WORD' 	=> $description,
					));
				}
			}
		}
	}

	/**
	* Generrate Meta description fo this page
	*
	* @param unknown_type $text
	* @param unknown_type $uid
	* @return unknown
	* 
	* @version: 1.0.0
	**/
	function undo_specialchars($text = '', $uid = '')
	{
	//	$text = str_replace(array("[html:$uid]", "[/html:$uid]"), array('[html]', '[/html]'), $text);
		// Delete the return at the end of any html bbcode
		$text = preg_replace("#\[\/html\](\n)#is", '[/html]', $text);
		
		$text_ary = explode('[html]', $text);
		$text = '';
		foreach ($text_ary as $tmp)
		{
			if (strpos($tmp, '[/html]'))
			{
				$tmp = explode('[/html]', $tmp, 2);
			//	$text .= html_entity_decode_utf8(str_replace(array("\r\n", "\n"), ' ', $tmp[0])) . $tmp[1];
				$text .= htmlspecialchars_decode(str_replace(array("\r\n", "\n"), ' ', $tmp[0])) . $tmp[1];
			}
			else
			{
				$text .= $tmp;
			}
		}

		return str_replace(array('[html]', '[/html]'), '', $text);
	}

	/**
	* @description: Send an e-mail
	* @version: OK
	**/
	function contact_form()
	{
		global $db, $user, $template;
		global $config, $webconfig;

		$contact_mail		= (isset($webconfig['email']) && $webconfig['email']) ? $webconfig['email'] : ((isset($config['board_email']) && $config['board_email']) ? $config['board_email'] : '');
		$site_name			= (isset($webconfig['sitename']) && $webconfig['sitename']) ? $webconfig['sitename'] : ((isset($config['sitename']) && $config['sitename']) ? $config['sitename'] : '');

		// Check if email is enabled
		$contact_form = ($webconfig['contact'] && ($config['email_enable']) && $contact_mail) ? true : false;
		if (!$contact_form)
		{
			phpbbweb_msg_handler($user->lang['CONTACT_EMAIL_DISABLED']);
		}

		// Are we trying to abuse the facility?
		if (time() - $user->data['user_emailtime'] < $config['flood_interval'])
		{
			phpbbweb_msg_handler($user->lang['CONTACT_FLOOD_LIMIT']);
		}

		$subject_error = $name_error = $email_error = $message_error = $confirm_error = $form_error = $confirm_error = $confirm_explain = '';

		$subject	= utf8_normalize_nfc(request_var('subject', '', true));
		$name		= utf8_normalize_nfc(request_var('name', '', true));
		$email		= strtolower(request_var('email', ''));
		$email_lang = request_var('lang', $config['default_lang']);
		$message	= utf8_normalize_nfc(request_var('message', '', true));
		$cc			= (isset($_POST['cc_email'])) ? true : false;
		$submit		= (isset($_POST['submit'])) ? true : false;
		$error		= false;

		$form_name	= 'contact_form';
		add_form_key($form_name);

		if (!$user->data['is_registered'] && $webconfig['contact_captcha'])
		{
			$user->add_lang('ucp');
			include(PHPBB_ROOT_PATH . 'includes/captcha/captcha_factory.' . PHP_EXT);
			$captcha =& phpbb_captcha_factory::get_instance($config['captcha_plugin']);
			$captcha->init(CONFIRM_REG);
		}
		else
		{
			$email_lang = $user->data['user_lang'];
			$name = ($name) ? $name : $user->data['username'];
			$email = ($email) ? $email :  $user->data['user_email'];
		}

		if ($submit)
		{
			if (!check_form_key($form_name))
			{
				$error = true;
				$form_error = $user->lang['CONTACT_SUBJECT_ERROR'];
			}

			if (!$subject)
			{
				$error = true;
				$subject_error = $user->lang['CONTACT_SUBJECT_ERROR'];
			}

			if (!$name)
			{
				$error = true;
				$name_error = $user->lang['CONTACT_NAME_ERROR'];
			}

			if (!$email || !preg_match('/^' . get_preg_expression('email') . '$/i', $email))
			{
				$error = true;
				$email_error = $user->lang['CONTACT_EMAIL_ERROR'];
			}

			if (!$message)
			{
				$error = true;
				$message_error = $user->lang['CONTACT_MESSAGE_ERROR'];
			}

			if (!$user->data['is_registered'] && $webconfig['contact_captcha'])
			{
				$captcha_data = array(
					'message'	=> utf8_normalize_nfc($message),
					'subject'	=> utf8_normalize_nfc($subject),
					'username'	=> utf8_normalize_nfc($name),
				);
				$vc_response = $captcha->validate($captcha_data);

				if ($vc_response)
				{
					$error = true;
					$confirm_error = $vc_response;
				}
			}

			$mail_return = false;
			if (!$error)
			{
				$user_id	= ($user->data['is_registered']) ? $user->data['user_id'] : ANONYMOUS;

				include_once(PHPBB_ROOT_PATH . 'includes/functions_messenger.' . PHP_EXT);
				$messenger	= new messenger();

				$mail_to_users = array();

				$mail_to_users[] = array(
					'email_lang'		=> $email_lang,
					'email'				=> $contact_mail,
					'name'				=> $site_name,
					'user_jabber'		=> '',
					'user_notify_type'	=> NOTIFY_EMAIL,
				);

				// the user request a copy ?
				if ($cc)
				{
					$mail_to_users[] = array(
						'email_lang'		=> $email_lang,
						'email'				=> $email,
						'name'				=> $name,
						'user_jabber'		=> ($user_id) ? $user->data['user_jabber'] : '',
						'user_notify_type'	=> ($user_id) ? $user->data['user_notify_type'] : NOTIFY_EMAIL,
					);
				}

				foreach ($mail_to_users as $row)
				{
					$messenger->headers('X-AntiAbuse: Board servername - ' . $config['server_name']);
					$messenger->headers('X-AntiAbuse: User_id - ' . $user->data['user_id']);
					$messenger->headers('X-AntiAbuse: Username - ' . $name);
					$messenger->headers('X-AntiAbuse: User IP - ' . $user->ip);

					$messenger->template('phpbbweb_contact', $row['email_lang']);
					$messenger->replyto($row['email']);
					$messenger->from($row['email']);
					$messenger->to($row['email'], $row['name']);
					$messenger->subject(htmlspecialchars_decode($subject));

					$messenger->assign_vars(array(
						'SITE_NAME'			=> htmlspecialchars_decode($site_name),
						'CONTACT_NAME'		=> htmlspecialchars_decode($name),
						'CONTACT_EMAIL'		=> $email,
						'CONTACT_SUBJECT'	=> htmlspecialchars_decode($subject),
						'CONTACT_MESSAGE'	=> htmlspecialchars_decode($message),
					));

					$mail_return = $messenger->send($row['user_notify_type']);
				}
				unset($messenger);

				if ($mail_return)
				{
					$sql = 'UPDATE ' . USERS_TABLE . '
						SET user_emailtime = ' . time() . '
						WHERE user_id = ' . $user_id;
					$result = $db->sql_query($sql);

					phpbbweb_msg_handler($user->lang['CONTACT_EMAIL_SEND'], '', E_USER_NOTICE);
				}
				else
				{
					phpbbweb_msg_handler($user->lang['CONTACT_EMAIL_FAIL'], '', E_USER_WARNING);
				}
			}
		}

		if (!$user->data['is_registered'] && $webconfig['contact_captcha'])
		{
			$confirm_explain = sprintf($user->lang['CONTACT_CONFIRM_EXPLAIN'], '<a href="mailto:' . htmlspecialchars($contact_mail) . '">', '</a>');
			// Confirmation code handling (stolen from posting.php)
			// Plugins have to use is_solved to force themselves to be displayed.
			if ((isset($captcha) && $captcha->is_solved() === false))
			{
				$template->assign_vars(array(
					'S_CONFIRM_CODE'	=> true,
					'CAPTCHA_TEMPLATE'	=> $captcha->get_template(),
				));
			}
		}

		$template->assign_vars(array(
			'S_CONTACT'				=> true,
			'PAGE_TITLE'			=> $user->lang['CONTACT_TITLE'],
			'CONTACT_TITLE_ACTIVE'	=> true,
			'S_CONTACT_MAIL'		=> (!$webconfig['email_display'] && $webconfig['email'] != '') ? str_replace(array('@', '.'), array('&nbsp;@&nbsp;', '&nbsp;.&nbsp;'), $webconfig['email']) : '',
			'S_CONTACT_MESSENGER'	=> (!$webconfig['messenger_display'] && $webconfig['messenger'] != '') ? str_replace(array('@', '.'), array('&nbsp;@&nbsp;', '&nbsp;.&nbsp;'), $webconfig['messenger']) : '',

			'FORM_ERROR'			=> $form_error,
			'U_ACTION'				=> append_sid(PHPBBWEB_INDEX, array('mode' => 'email')),

			'CONTACT_NAME'			=> $name,
			'CONTACT_NAME_ERROR'	=> $name_error,

			'CONTACT_EMAIL'			=> $email,
			'CONTACT_EMAIL_ERROR'	=> $email_error,

			'CONTACT_SUBJECT'		=> $subject,
			'CONTACT_SUBJECT_ERROR'	=> $subject_error,

			'CONTACT_MESSAGE'		=> $message,
			'CONTACT_MESSAGE_ERROR'	=> $message_error,

			'CONTACT_CC'			=> $cc,

			'L_CONFIRM_EXPLAIN'		=> $confirm_explain,
			'CONTACT_CONFIRM_ERROR'	=> $confirm_error,
		));

		$template->set_filenames(array(
			'body' => 'phpbbweb/phpbbweb_contact_body.html')
		);

		page_footer();
	}

	/**
	* @description: Get page|block info
	* @param: (integer)		$page_id = page identifier
	* @param: (boolean)		$page_type = ('PAGE_CATEGORY', 0)|('PAGE_SECTION', 1)|('PAGE_BLOCK', 2)
	* @return: (array)		page data
	* 
	* @version: 1.0.0
	**/
	function get_page_data($page_id = 0, $page_type = PAGE_CATEGORY)
	{
		global $user, $db;

		$page_id = (int) $page_id;

		$sql = 'SELECT * 
			FROM ' . PHPBBWEB_PAGE_TABLE . " 
			WHERE page_id = $page_id AND page_type = $page_type";
		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);

		if (!$row)
		{
			phpbbweb_msg_handler($user->lang['NO_PAGE']); // . " :: $page_id");
		}

		return $row;
	}

	/**
	* @description: Update view counters... but not for the creator and only for humans and if this is the first 'page view'
	*
	* @param: (integer)		$category_id = category identifier
	* @param: (integer)		$category_id = category identifier
	**/
	function counters($update_views = false)
	{
		global $db, $user, $template;
		global $webconfig;
		global $category_id, $section_id;

		$update_views = (!$webconfig['views_counter']) ? false : $update_views;
		if (!$update_views)
		{
			return false;
		}

		// Give us some basic information
		$ttl				= 30;
		$category_id		= (int) $category_id;
		$section_id			= (int) $section_id;
		$mode				= request_var('mode', '');

		$this->mode			= '';
		$this->time_now		= time();
		$this->page			= $user->extract_current_page(PHPBB_ROOT_PATH);
		$this->session_page	= substr($this->page['page'], 0, 199);

		// Only update views DB a half minute or so after last update or if page changes
		$this->update_views	= ($this->time_now - $user->data['session_time'] > $ttl || $user->data['session_page'] != $this->session_page) ? true : $update_views;
	//	Only update views DB a half minute or so after last update and not if page changes
	//	$this->update_views	= ($this->time_now - $user->data['session_time'] > $ttl) ? true : $update_views;

		if (isset($this->session_page) && !$user->data['is_bot'] && $this->update_views)
		{
			if (!$section_id && !$category_id && !$mode && ($this->page['page'] === $this->session_page) && ($webconfig['owner_id'] != $user->data['user_id']))
			{
				$sql = 'UPDATE ' . PHPBBWEB_CONFIG_TABLE . "
						SET config_value = '" . $db->sql_escape((int) $webconfig['page_views'] + 1) . "'
						WHERE config_name = '" . $db->sql_escape('page_views') . "'";
				$db->sql_query($sql);

				if ($db->sql_affectedrows())
				{
					$this->mode = 'index';
				}
			}
			// First section to avoid categories
			else if ($section_id && ((strpos($this->session_page, "section=$section_id") !== false && strpos($this->session_page, 'category=') === false) || isset($user->data['session_created'])))
			{
				$sql = 'UPDATE ' . PHPBBWEB_PAGE_TABLE . "
						SET page_views = page_views + 1 
						WHERE page_id = $section_id AND page_type = " . PAGE_SECTION . "
						AND owner_id <> " . $user->data['user_id'];
				$db->sql_query($sql);

				if ($db->sql_affectedrows())
				{
					$this->mode = 'section';
				}
			}
			else if ($category_id && ((strpos($this->session_page, "category=$category_id") !== false && strpos($this->session_page, 'section=') === false) || isset($user->data['session_created'])))
			{
				$sql = 'UPDATE ' . PHPBBWEB_PAGE_TABLE . "
						SET page_views = page_views + 1 
						WHERE page_id = $category_id AND page_type = " . PAGE_CATEGORY . "
						AND owner_id <> " . $user->data['user_id'];
				$db->sql_query($sql);

				if ($db->sql_affectedrows())
				{
					$this->mode = 'category';
				}
			}
		}
		return defined('DEBUG') ? $this->mode : false;
	}

}

// php.net, laurynas dot butkus at gmail dot com, http://us.php.net/manual/en/function.html-entity-decode.php#75153
function html_entity_decode_utf8($string)
{
	static $trans_tbl;

	// replace numeric entities
	$string = preg_replace('~&#x([0-9a-f]+);~ei', '_code2utf8(hexdec("\\1"))', $string);
	$string = preg_replace('~&#([0-9]+);~e', '_code2utf8(\\1)', $string);

	// replace literal entities
	if (!isset($trans_tbl))
	{
		$trans_tbl = array();

		foreach (get_html_translation_table(HTML_ENTITIES) as $val => $key)
		{
			$trans_tbl[$key] = utf8_encode($val);
		}
	}

	return strtr($string, $trans_tbl);
}

// Returns the utf string corresponding to the unicode value (from php.net, courtesy - romans@void.lv)
function _code2utf8($num)
{
	$return = '';

	if ($num < 128)
	{
		$return = chr($num);
	}
	else if ($num < 2048)
	{
		$return = chr(($num >> 6) + 192) . chr(($num & 63) + 128);
	}
	else if ($num < 65536)
	{
		$return = chr(($num >> 12) + 224) . chr((($num >> 6) & 63) + 128) . chr(($num & 63) + 128);
	}
	else if ($num < 2097152)
	{
		$return = chr(($num >> 18) + 240) . chr((($num >> 12) & 63) + 128) . chr((($num >> 6) & 63) + 128) . chr(($num & 63) + 128);
	}

	return $return;
}

/**
* @description: output an error message
*
* @param (string)		$msg_text
* @param (string)		$action
* @param (integer)		$errno
* @return output an error message
* Value		Constant			PHP	Description
* 1			E_ERROR					Fatal run-time errors. Errors that cannot be recovered from. Execution of the script is halted
* 2			E_WARNING				Non-fatal run-time errors. Execution of the script is not halted
* 4			E_PARSE					Compile-time parse errors. Parse errors should only be generated by the parser
* 8			E_NOTICE				Run-time notices. The script found something that might be an error, but could also happen when running a script normally
* 16		E_CORE_ERROR		4	Fatal errors at PHP startup. This is like an E_ERROR in the PHP core
* 32		E_CORE_WARNING		4	Non-fatal errors at PHP startup. This is like an E_WARNING in the PHP core
* 64		E_COMPILE_ERROR		4	Fatal compile-time errors. This is like an E_ERROR generated by the Zend Scripting Engine
* 128		E_COMPILE_WARNING	4	Non-fatal compile-time errors. This is like an E_WARNING generated by the Zend Scripting Engine
* 256		E_USER_ERROR		4	Fatal user-generated error. This is like an E_ERROR set by the programmer using the PHP function trigger_error(
* 512		E_USER_WARNING		4	Non-fatal user-generated warning. This is like an E_WARNING set by the programmer using the PHP function trigger_error()
* 1024		E_USER_NOTICE		4	User-generated notice. This is like an E_NOTICE set by the programmer using the PHP function trigger_error()
* 2048		E_STRICT			5	Run-time notices. PHP suggest changes to your code to help interoperability and compatibility of the code
* 4096		E_RECOVERABLE_ERROR	5	Catchable fatal error. This is like an E_ERROR but can be caught by a user defined handle (see also set_error_handler())
* 8191		E_ALL				5	All errors and warnings, except of level E_STRICT
**/
function phpbbweb_msg_handler($msg_text, $action = '', $errno = '')
{
	global $user, $template;
	global $phpbbweb;

	switch ($errno)
	{
		case E_NOTICE :
		case E_USER_NOTICE :
			$msg_lang = 'INFORMATION';
			$msg_class = 'successbox';
		break;

		default:
		case E_WARNING :
		case E_USER_WARNING :
			$msg_lang = 'WARNING';
			$msg_class = 'errorbox';
		break;

		case E_ERROR :
		case E_USER_ERROR :
			$msg_lang = 'ERROR';
			$msg_class = 'errorbox';
		break;
	}

	$msg_text = (!empty($user->lang[$msg_text])) ? $user->lang[$msg_text] : $msg_text;
	$msg_title = (isset($user->lang['PHPBBWEB_' . $msg_lang])) ? $user->lang['PHPBBWEB_' . $msg_lang] : $user->lang['INFORMATION'];

	$phpbbweb->page_header($msg_title);

	$template->set_filenames(array(
		'body' => 'phpbbweb/phpbbweb_message_body.html')
	);

	$template->assign_vars(array(
		'MESSAGE_ERROR'	=> true,
		'MESSAGE_CLASS'	=> $msg_class,
		'MESSAGE_TITLE'	=> $msg_title,
		'MESSAGE_TEXT'	=> $msg_text,
		'MESSAGE_LINK'	=> ($action != '') ? phpbbweb_add_link($action) :  phpbbweb_add_link(PHPBBWEB_INDEX),
	));

	// Avoid recursion 
	global $category_id, $section_id;
	$category_id = 0;
	$section_id = 0;
	
//	$phpbbweb->navbar($category_id, $section_id);
	page_footer();

	// If we notice an error not handled here we pass this back to PHP by returning false
	// This may not work for all php versions
	return false;
}

/**
* @description: Generate back link
*
* @param: (string) link
* @return: html link
**/
function phpbbweb_add_link($u_action)
{
	global $user;
	
	$lang_return_index = str_replace('%s', '', $user->lang['RETURN_INDEX']);
	return sprintf($user->lang['RETURN_INDEX'], '<a href="' . append_sid($u_action) . '" title="' . $lang_return_index . '">&laquo; ', '</a>');
}

/**
* Redirects the user to another page then exits the script nicely
*/
function phpbbweb_redirect($url, $return = false)
{
//	return redirect($url, $return = false, $disable_cd_check = false);
	
	global $user;

	if (empty($user->lang))
	{
		$user->add_lang('common');
	}

	// Make sure no &amp;'s are in, this will break the redirect
	$url = str_replace('&amp;', '&', $url);

	// Determine which type of redirect we need to handle...
	$url_parts = @parse_url($url);

	if ($url_parts === false)
	{
		// Malformed url, redirect to current page...
		$url = generate_board_url() . '/' . $user->page['page'];
	}
	else if (!empty($url_parts['scheme']) && !empty($url_parts['host']))
	{
		// Full URL
	}
	else if ($url[0] == '/')
	{
		// Absolute uri, prepend direct url...
		$url = generate_board_url(true) . $url;
	}
	else
	{
		// Relative uri
		$pathinfo = pathinfo($url);

		// Is the uri pointing to the current directory?
		if ($pathinfo['dirname'] == '.')
		{
			$url = str_replace('./', '', $url);

			// Strip / from the beginning
			if ($url && substr($url, 0, 1) == '/')
			{
				$url = substr($url, 1);
			}

			if ($user->page['page_dir'])
			{
				$url = generate_board_url() . '/' . $user->page['page_dir'] . '/' . $url;
			}
			else
			{
				$url = generate_board_url() . '/' . $url;
			}
		}
		else
		{
			// Used ./ before, but $phpbb_root_path is working better with urls within another root path
			$root_dirs = explode('/', str_replace('\\', '/', phpbb_realpath(PHPBB_ROOT_PATH)));
			$page_dirs = explode('/', str_replace('\\', '/', phpbb_realpath($pathinfo['dirname'])));
			$intersection = array_intersect_assoc($root_dirs, $page_dirs);

			$root_dirs = array_diff_assoc($root_dirs, $intersection);
			$page_dirs = array_diff_assoc($page_dirs, $intersection);

			$dir = str_repeat('../', sizeof($root_dirs)) . implode('/', $page_dirs);

			// Strip / from the end
			if ($dir && substr($dir, -1, 1) == '/')
			{
				$dir = substr($dir, 0, -1);
			}

			// Strip / from the beginning
			if ($dir && substr($dir, 0, 1) == '/')
			{
				$dir = substr($dir, 1);
			}

			$url = str_replace($pathinfo['dirname'] . '/', '', $url);

			// Strip / from the beginning
			if (substr($url, 0, 1) == '/')
			{
				$url = substr($url, 1);
			}

			$url = $dir . '/' . $url;
			$url = generate_board_url() . '/' . $url;
		}
	}

	// Make sure no linebreaks are there... to prevent http response splitting for PHP < 4.4.2
	if (strpos(urldecode($url), "\n") !== false || strpos(urldecode($url), "\r") !== false || strpos($url, ';') !== false)
	{
		trigger_error('Tried to redirect to potentially insecure url.', E_USER_ERROR);
	}

	// Now, also check the protocol and for a valid url the last time...
	$allowed_protocols = array('http', 'https', 'ftp', 'ftps');
	$url_parts = parse_url($url);

	if ($url_parts === false || empty($url_parts['scheme']) || !in_array($url_parts['scheme'], $allowed_protocols))
	{
		trigger_error('Tried to redirect to potentially insecure url.', E_USER_ERROR);
	}

	if ($return)
	{
		return $url;
	}

	// Redirect via an HTML form for PITA webservers
	if (@preg_match('#Microsoft|WebSTAR|Xitami#', getenv('SERVER_SOFTWARE')))
	{
		header('Refresh: 0; URL=' . $url);

		echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">';
		echo '<html xmlns="http://www.w3.org/1999/xhtml" dir="' . $user->lang['DIRECTION'] . '" lang="' . $user->lang['USER_LANG'] . '" xml:lang="' . $user->lang['USER_LANG'] . '">';
		echo '<head>';
		echo '<meta http-equiv="content-type" content="text/html; charset=utf-8" />';
		echo '<meta http-equiv="refresh" content="0; url=' . str_replace('&', '&amp;', $url) . '" />';
		echo '<title>' . $user->lang['REDIRECT'] . '</title>';
		echo '</head>';
		echo '<body>';
		echo '<div style="text-align: center;">' . sprintf($user->lang['URL_REDIRECT'], '<a href="' . str_replace('&', '&amp;', $url) . '">', '</a>') . '</div>';
		echo '</body>';
		echo '</html>';

		exit;
	}

$this_page			= $user->extract_current_page(PHPBBWEB_ROOT);
$this_session_page	= substr($this_page['page'], 0, 199);
print_r("session_page => ($this_session_page)<br />");
print_r("redirect_url => ($url)<br />");
die("<br /><b>FIN</b>");

	// Behave as per HTTP/1.1 spec for others
	header('Location: ' . $url);
	exit;
}

/**
* @description: General attachment parsing
*	basically wirls like parse_attachments only change the table name
*
* @param mixed $forum_id The forum id the attachments are displayed in (false if in private message)
* @param string &$message The post/private message
* @param array &$attachments The attachments to parse for (inline) display. The attachments array will hold templated data after parsing.
* @param array &$update_count The attachment counts to be updated - will be filled
* @param bool $preview If set to true the attachments are parsed for preview. Within preview mode the comments are fetched from the given $attachments array and not fetched from the database.
*
* @see: root/includes/function_content.php -> parse_attachments()
**/
function phpbbweb_parse_attachments($forum_id, &$message, &$attachments, &$update_count, $preview = false)
{
	if (!sizeof($attachments))
	{
		return;
	}

	global $template, $cache, $user, $auth;
	global $config;

	$user->add_lang('viewtopic');

	$compiled_attachments = array();

	if (!isset($template->filename['attachment_tpl']))
	{
		$template->set_filenames(array(
			'attachment_tpl'	=> 'attachment.html')
		);
	}

	$forum_id = (int) $forum_id;	//	$forum_id = ($forum_id == true) ? 1 : $forum_id;

	$extensions = $cache->obtain_attach_extensions($forum_id);

	// Look for missing attachment information...
	$attach_ids = array();
	foreach ($attachments as $pos => $attachment)
	{
		// If is_orphan is set, we need to retrieve the attachments again...
		if (!isset($attachment['extension']) && !isset($attachment['physical_filename']))
		{
			$attach_ids[(int) $attachment['attach_id']] = $pos;
		}
	}

	// Grab attachments (security precaution)
	if (sizeof($attach_ids))
	{
		global $db;

		$new_attachment_data = array();

		$sql = 'SELECT *
			FROM ' . PHPBBWEB_ATTACHMENTS_TABLE . '
			WHERE ' . $db->sql_in_set('attach_id', array_keys($attach_ids));
		$result = $db->sql_query($sql);

		while ($row = $db->sql_fetchrow($result))
		{
			if (!isset($attach_ids[$row['attach_id']]))
			{
				continue;
			}

			// If we preview attachments we will set some retrieved values here
			if ($preview)
			{
				$row['attach_comment'] = $attachments[$attach_ids[$row['attach_id']]]['attach_comment'];
			}

			$new_attachment_data[$attach_ids[$row['attach_id']]] = $row;
		}
		$db->sql_freeresult($result);

		$attachments = $new_attachment_data;
		unset($new_attachment_data);
	}

	// Sort correctly
	if ($config['display_order'])
	{
		// Ascending sort
		krsort($attachments);
	}
	else
	{
		// Descending sort
		ksort($attachments);
	}

	foreach ($attachments as $attachment)
	{
		if (!sizeof($attachment))
		{
			continue;
		}

		// We need to reset/empty the _file block var, because this function might be called more than once
		$template->destroy_block_vars('_file');

		$block_array = array();

		// Some basics...
		$attachment['extension'] = strtolower(trim($attachment['extension']));
		$filename = PHPBB_ROOT_PATH . $config['upload_path'] . '/' . utf8_basename($attachment['physical_filename']);
		$thumbnail_filename = PHPBB_ROOT_PATH . $config['upload_path'] . '/thumb_' . utf8_basename($attachment['physical_filename']);

		$upload_icon = '';

		if (isset($extensions[$attachment['extension']]))
		{
			if ($user->img('icon_topic_attach', '') && !$extensions[$attachment['extension']]['upload_icon'])
			{
				$upload_icon = $user->img('icon_topic_attach', '');
			}
			else if ($extensions[$attachment['extension']]['upload_icon'])
			{
				$upload_icon = '<img src="' . PHPBB_ROOT_PATH . $config['upload_icons_path'] . '/' . trim($extensions[$attachment['extension']]['upload_icon']) . '" alt="" />';
			}
		}

		$filesize = get_formatted_filesize($attachment['filesize'], false);

		$comment = bbcode_nl2br(censor_text($attachment['attach_comment']));

		$block_array += array(
			'UPLOAD_ICON'		=> $upload_icon,
			'FILESIZE'			=> $filesize['value'],
			'SIZE_LANG'			=> $filesize['unit'],
			'DOWNLOAD_NAME'		=> utf8_basename($attachment['real_filename']),
			'COMMENT'			=> $comment,
		);

		$denied = false;
		if (!extension_allowed($forum_id, $attachment['extension'], $extensions))
		{
			$denied = true;

			$block_array += array(
				'S_DENIED'			=> true,
				'DENIED_MESSAGE'	=> sprintf($user->lang['EXTENSION_DISABLED_AFTER_POSTING'], $attachment['extension'])
			);
		}

		if (!$denied)
		{
			$l_downloaded_viewed = $download_link = '';
			$display_cat = $extensions[$attachment['extension']]['display_cat'];

			if ($display_cat == ATTACHMENT_CATEGORY_IMAGE)
			{
				if ($attachment['thumbnail'])
				{
					$display_cat = ATTACHMENT_CATEGORY_THUMB;
				}
				else
				{
					if ($config['img_display_inlined'])
					{
						if ($config['img_link_width'] || $config['img_link_height'])
						{
							$dimension = @getimagesize($filename);

							// If the dimensions could not be determined or the image being 0x0 we display it as a link for safety purposes
							if ($dimension === false || empty($dimension[0]) || empty($dimension[1]))
							{
								$display_cat = ATTACHMENT_CATEGORY_NONE;
							}
							else
							{
								$display_cat = ($dimension[0] <= $config['img_link_width'] && $dimension[1] <= $config['img_link_height']) ? ATTACHMENT_CATEGORY_IMAGE : ATTACHMENT_CATEGORY_NONE;
							}
						}
					}
					else
					{
						$display_cat = ATTACHMENT_CATEGORY_NONE;
					}
				}
			}

			// Make some descisions based on user options being set.
			if (($display_cat == ATTACHMENT_CATEGORY_IMAGE || $display_cat == ATTACHMENT_CATEGORY_THUMB) && !$user->optionget('viewimg'))
			{
				$display_cat = ATTACHMENT_CATEGORY_NONE;
			}

			if ($display_cat == ATTACHMENT_CATEGORY_FLASH && !$user->optionget('viewflash'))
			{
				$display_cat = ATTACHMENT_CATEGORY_NONE;
			}

			$download_link = append_sid(PHPBBWEB_FILE, 'id=' . $attachment['attach_id']);

			switch ($display_cat)
			{
				// Images
				case ATTACHMENT_CATEGORY_IMAGE:
					$l_downloaded_viewed = 'VIEWED_COUNT';
					$inline_link = append_sid(PHPBBWEB_FILE, 'id=' . $attachment['attach_id']);
					$download_link .= '&amp;mode=view';

					$block_array += array(
						'S_IMAGE'		=> true,
						'U_INLINE_LINK'		=> $inline_link,
					);

					$update_count[] = $attachment['attach_id'];
				break;

				// Images, but display Thumbnail
				case ATTACHMENT_CATEGORY_THUMB:
					$l_downloaded_viewed = 'VIEWED_COUNT';
					$thumbnail_link = append_sid(PHPBBWEB_FILE, 'id=' . $attachment['attach_id'] . '&amp;t=1');
					$download_link .= '&amp;mode=view';

					$block_array += array(
						'S_THUMBNAIL'		=> true,
						'THUMB_IMAGE'		=> $thumbnail_link,
					);

					$update_count[] = $attachment['attach_id'];
				break;

				// Windows Media Streams
				case ATTACHMENT_CATEGORY_WM:
					$l_downloaded_viewed = 'VIEWED_COUNT';

					// Giving the filename directly because within the wm object all variables are in local context making it impossible
					// to validate against a valid session (all params can differ)
					// $download_link = $filename;

					$block_array += array(
						'U_FORUM'		=> generate_board_url(),
						'ATTACH_ID'		=> $attachment['attach_id'],
						'S_WM_FILE'		=> true,
					);

					// Viewed/Heared File ... update the download count
					$update_count[] = $attachment['attach_id'];
				break;

				// Real Media Streams
				case ATTACHMENT_CATEGORY_RM:
				case ATTACHMENT_CATEGORY_QUICKTIME:
					$l_downloaded_viewed = 'VIEWED_COUNT';

					$block_array += array(
						'S_RM_FILE'			=> ($display_cat == ATTACHMENT_CATEGORY_RM) ? true : false,
						'S_QUICKTIME_FILE'	=> ($display_cat == ATTACHMENT_CATEGORY_QUICKTIME) ? true : false,
						'U_FORUM'			=> generate_board_url(),
						'ATTACH_ID'			=> $attachment['attach_id'],
					);

					// Viewed/Heared File ... update the download count
					$update_count[] = $attachment['attach_id'];
				break;

				// Macromedia Flash Files
				case ATTACHMENT_CATEGORY_FLASH:
					list($width, $height) = @getimagesize($filename);

					$l_downloaded_viewed = 'VIEWED_COUNT';

					$block_array += array(
						'S_FLASH_FILE'	=> true,
						'WIDTH'			=> $width,
						'HEIGHT'		=> $height,
						'U_VIEW_LINK'	=> $download_link . '&amp;view=1',
					);

					// Viewed/Heared File ... update the download count
					$update_count[] = $attachment['attach_id'];
				break;

				default:
					$l_downloaded_viewed = 'DOWNLOAD_COUNT';

					$block_array += array(
						'S_FILE'		=> true,
					);
				break;
			}

			$l_download_count = (!isset($attachment['download_count']) || $attachment['download_count'] == 0) ? $user->lang[$l_downloaded_viewed . '_NONE'] : (($attachment['download_count'] == 1) ? sprintf($user->lang[$l_downloaded_viewed], $attachment['download_count']) : sprintf($user->lang[$l_downloaded_viewed . 'S'], $attachment['download_count']));

			$block_array += array(
				'U_DOWNLOAD_LINK'		=> $download_link,
				'L_DOWNLOAD_COUNT'		=> $l_download_count
			);
		}

		$template->assign_block_vars('_file', $block_array);

		$compiled_attachments[] = $template->assign_display('attachment_tpl');
	}

	$attachments = $compiled_attachments;
	unset($compiled_attachments);

	$tpl_size = sizeof($attachments);

	$unset_tpl = array();

	preg_match_all('#<!\-\- ia([0-9]+) \-\->(.*?)<!\-\- ia\1 \-\->#', $message, $matches, PREG_PATTERN_ORDER);

	$replace = array();
	foreach ($matches[0] as $num => $capture)
	{
		// Flip index if we are displaying the reverse way
		$index = ($config['display_order']) ? ($tpl_size-($matches[1][$num] + 1)) : $matches[1][$num];

		$replace['from'][] = $matches[0][$num];
		$replace['to'][] = (isset($attachments[$index])) ? $attachments[$index] : sprintf($user->lang['MISSING_INLINE_ATTACHMENT'], $matches[2][array_search($index, $matches[1])]);

		$unset_tpl[] = $index;
	}

	if (isset($replace['from']))
	{
		$message = str_replace($replace['from'], $replace['to'], $message);
	}

	$unset_tpl = array_unique($unset_tpl);

	// Needed to let not display the inlined attachments at the end of the post again
	foreach ($unset_tpl as $index)
	{
		unset($attachments[$index]);
	}
}

?>