<?php
/**
* @package: phpBB 3.0.8 :: phpBB Web => phpbb root
* @version: $Id: install_phpbbweb.php, v1.0.3-pl2 2010/12/10 10:12:10 leviatan21 Exp $
* @copyright: leviatan21 < info@mssti.com > (Gabriel) http://www.mssti.com/phpbb3/
* @license: http://opensource.org/licenses/gpl-license.php GNU Public License 
* @author: leviatan21 - http://www.phpbb.com/community/memberlist.php?mode=viewprofile&u=345763
*
**/

/**
* @ignore
**/
define('UMIL_AUTO', true);
define('IN_PHPBB', true);

$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

if (!defined('DEBUG'))
{
	@define('DEBUG', true);
}

if (!defined('IN_INSTALL'))
{
	@define('IN_INSTALL', true);
}

$user->session_begin();
$auth->acl($user->data);
$user->setup();

if (!file_exists($phpbb_root_path . 'umil/umil_auto.' . $phpEx))
{
	trigger_error('Please download the latest UMIL (Unified MOD Install Library) from: <a href="http://www.phpbb.com/mods/umil/" onclick="window.open(this.href);return false;">phpBB.com/mods/umil</a>', E_USER_ERROR);
}

$mod_data = array(
	'config'	=> 'phpbb_web',
	'name'		=> 'PHPBBWEB_TITLE',
	'version'	=> '1.0.4',
	'language'	=> 'mods/phpbbweb',
);

// The name of the mod to be displayed during installation.
$mod_name = $mod_data['name'];

// The name of the config variable which will hold the currently installed version
$version_config_name = $mod_data['config'];

// Add the language file if one was specified
if (isset($mod_data['language']))
{
	$user->add_lang($mod_data['language']);
}
/*
* The language file which will be included when installing
* Language entries that should exist in the language file for UMIL (replace $mod_name with the mod's name you set to $mod_name above)
* $mod_name
* 'INSTALL_' . $mod_name
* 'INSTALL_' . $mod_name . '_CONFIRM'
* 'UPDATE_' . $mod_name
* 'UPDATE_' . $mod_name . '_CONFIRM'
* 'UNINSTALL_' . $mod_name
* 'UNINSTALL_' . $mod_name . '_CONFIRM'
*/

// Logo Image
$logo_img = './../phpbbweb/styles/prosilver/theme/images/logo/phpbbweb_logo.gif';

// The array of versions and actions within each.
$versions = array(
	// Version 1.0.0
	'1.0.0' => array(
		// Modules
		'module_add' => array(
			// First category
			array('acp', 'ACP_CAT_DOT_MODS', 'ACP_PHPBBWEB_CONFIGURATION_TITLE'),
			// settings
			array('acp', 'ACP_PHPBBWEB_CONFIGURATION_TITLE', array(
					'module_basename'	=> 'phpbbweb',
					'module_langname'	=> 'ACP_PHPBBWEB_SETTINGS',
					'module_mode'		=> 'settings',
					'module_auth'		=> 'acl_a_board',
				),
			),
			// features
			array('acp', 'ACP_PHPBBWEB_CONFIGURATION_TITLE', array(
					'module_basename'	=> 'phpbbweb',
					'module_langname'	=> 'ACP_PHPBBWEB_FEATURES',
					'module_mode'		=> 'features',
					'module_auth'		=> 'acl_a_board',
				),
			),
			// message
			array('acp', 'ACP_PHPBBWEB_CONFIGURATION_TITLE', array(
					'module_basename'	=> 'phpbbweb',
					'module_langname'	=> 'ACP_PHPBBWEB_WELCOME',
					'module_mode'		=> 'message',
					'module_auth'		=> 'acl_a_board',
				),
			),
			// stylesheet
			array('acp', 'ACP_PHPBBWEB_CONFIGURATION_TITLE', array(
					'module_basename'	=> 'phpbbweb',
					'module_langname'	=> 'ACP_PHPBBWEB_CSS',
					'module_mode'		=> 'stylesheet',
					'module_auth'		=> 'acl_a_board',
				),
			),
			// Second category
			array('acp', 'ACP_CAT_DOT_MODS', 'ACP_PHPBBWEB_MANAGEMENT_TITLE'),
			// manage
			array('acp', 'ACP_PHPBBWEB_MANAGEMENT_TITLE', array(
					'module_basename'	=> 'phpbbweb',
					'module_langname'	=> 'ACP_PHPBBWEB_MANAGE',
					'module_mode'		=> 'manage',
					'module_auth'		=> 'acl_a_board',
				),
			),
		),

		// Add table
		'table_add'	=> array(
			// config info
			array('phpbb_phpbbweb_config', 
				array(
					'COLUMNS'		=> array(
						'config_name'			=> array('VCHAR:255',	''),	// VARCHAR(255)
						'config_value'			=> array('MTEXT',		''),	// MEDIUMTEXT
					),
					'PRIMARY_KEY'	=> 'config_name',
				),
			),
			// Pages info
			array('phpbb_phpbbweb_pages', 
				array(
					'COLUMNS'		=> array(
						'page_id'				=> array('UINT',		0),		// MEDIUMINT(8)
						'parent_id'				=> array('UINT',		0),		// MEDIUMINT(8)
						'page_order'			=> array('UINT',		0),		// MEDIUMINT(8)
						'page_class'			=> array('VCHAR:255',	''),	// VARCHAR(255)
						'page_approved'			=> array('TINT:1',		1),		// TINYINT(1)
						'page_subject'			=> array('VCHAR:255',	''),	// VARCHAR(255)
						'page_text'				=> array('MTEXT',		''),	// MEDIUMTEXT
						'enable_bbcode'			=> array('TINT:1',		1),		// TINYINT(1)
						'enable_smilies'		=> array('TINT:1',		1),		// TINYINT(1)
						'enable_magic_url'		=> array('TINT:1',		1),		// TINYINT(1)
						'bbcode_bitfield'		=> array('VCHAR:255',	''),	// VARCHAR(255)
						'bbcode_uid'			=> array('VCHAR:8',		''),	// VARCHAR(8)
						'page_views'			=> array('UINT',		0),		// MEDIUMINT(8)
						'owner_id'				=> array('UINT',		0),		// MEDIUMINT(8)
						'redirect'				=> array('TINT:1',		0),		// TINYINT(1)
						'redirect_url'			=> array('VCHAR:255',	''),	// VARCHAR(255)
						'page_attachment'		=> array('TINT:1',		0),		// TINYINT(1)
						'page_type'				=> array('TINT:4',		0),		// TINYINT(4)
						'is_orphan'				=> array('TINT:1',		0),		// TINYINT(1)
					),
					'PRIMARY_KEY'	=> 'page_id',
					'KEYS'			=> array(
						'page_order'	=> array('INDEX', 'page_order'),
						'page_approved'	=> array('INDEX', 'page_approved'),
						'page_type'		=> array('INDEX', 'page_type'),
					),
				),
			),
			// Pages info
			array('phpbb_phpbbweb_attachments', 
				array(
					'COLUMNS'		=> array(
						'attach_id'				=> array('UINT', NULL, 'auto_increment'),// MEDIUMINT(8)
						'page_id'				=> array('UINT',		0),		// MEDIUMINT(8)
						'in_message'			=> array('TINT:1',		1),		// TINYINT(1)
						'poster_id'				=> array('UINT',		0),		// MEDIUMINT(8)
						'is_orphan'				=> array('TINT:1',		0),		// TINYINT(1)
						'physical_filename'		=> array('VCHAR:255',	''),	// VARCHAR(255)
						'real_filename'			=> array('VCHAR:255',	''),	// VARCHAR(255)
						'download_count'		=> array('UINT',		0),		// MEDIUMINT(8)
						'attach_comment'		=> array('TEXT',		''),	// TEXT
						'extension'				=> array('VCHAR:100',	''),	// VARCHAR(100)
						'mimetype'				=> array('VCHAR:100',	''),	// VARCHAR(100)
						'filesize'				=> array('INT:20',		0),		// INT(20)
						'filetime'				=> array('INT:11',		0),		// INTEGER
						'thumbnail'				=> array('TINT:1',		0),		// TINYINT(1)
					),
					'PRIMARY_KEY'	=> 'attach_id',
					'KEYS'			=> array(
						'filetime'		=> array('INDEX', 'filetime'),
						'poster_id'		=> array('INDEX', 'poster_id'),
						'is_orphan'		=> array('INDEX', 'is_orphan'),
					),
				),
			),
		),
		// Now we need to insert some data.
		'table_row_insert'	=> array(
			array('phpbb_phpbbweb_config', 
				array(
					// settings
					array(
						'config_name'	=> 'disable',
						'config_value'	=> 0,
					),
					array(
						'config_name'	=> 'disable_msg',
						'config_value'	=> 'This will make the board unavailable to guest',
					),
					array(
						'config_name'	=> 'sitename',
						'config_value'	=> 'yourdomain.com',
					),
					array(
						'config_name'	=> 'description',
						'config_value'	=> 'A short text to describe your site',
					),
					array(
						'config_name'	=> 'version',
						'config_value'	=> $mod_data['version'],
					),
					array(
						'config_name'	=> 'owner_id',
						'config_value'	=> 0,
					),
					array(
						'config_name'	=> 'page_views',
						'config_value'	=> 0,
					),
					array(
						'config_name'	=> 'stylesheet',
						'config_value'	=> '',
					),
					// message
					array(
						'config_name'	=> 'welcome_message',
						'config_value'	=> '[b:2zw5ow3j]This is the [color=#FF0000:2zw5ow3j]Welcome example page[/color:2zw5ow3j] in your phpBB Web installation.[/b:2zw5ow3j]',
					),
					array(
						'config_name'	=> 'welcome_message_approved',
						'config_value'	=> 1,
					),
					array(
						'config_name'	=> 'welcome_message_bbcode_bitfield',
						'config_value'	=> 'Qg==',
					),
					array(
						'config_name'	=> 'welcome_message_bbcode_uid',
						'config_value'	=> '2zw5ow3j',
					),
					array(
						'config_name'	=> 'welcome_message_enable_bbcode',
						'config_value'	=> 1,
					),
					array(
						'config_name'	=> 'welcome_message_enable_smilies',
						'config_value'	=> 1,
					),
					array(
						'config_name'	=> 'welcome_message_enable_urls',
						'config_value'	=> 1,
					),
					array(
						'config_name'	=> 'welcome_message_attachment',
						'config_value'	=> 0,
					),

					// features
					array(
						'config_name'	=> 'views_counter',
						'config_value'	=> 0,
					),
					array(
						'config_name'	=> 'favicon',
						'config_value'	=> 0,
					),
					array(
						'config_name'	=> 'live_clock',
						'config_value'	=> 0,
					),
					array(
						'config_name'	=> 'random_logo',
						'config_value'	=> 0,
					),
					array(
						'config_name'	=> 'logo',
						'config_value'	=> 'phpbbweb_logo.gif',
					),
					array(
						'config_name'	=> 'random_bg',
						'config_value'	=> 0,
					),
					array(
						'config_name'	=> 'contact',
						'config_value'	=> 0,
					),
					array(
						'config_name'	=> 'contact_captcha',
						'config_value'	=> 1,
					),
					array(
						'config_name'	=> 'email',
						'config_value'	=> '',
					),
					array(
						'config_name'	=> 'email_display',
						'config_value'	=> 1,
					),
					array(
						'config_name'	=> 'messenger',
						'config_value'	=> '',
					),
					array(
						'config_name'	=> 'messenger_display',
						'config_value'	=> 1,
					),
					array(
						'config_name'	=> 'meta_disable',
						'config_value'	=> 0,
					),
					array(
						'config_name'	=> 'meta_abstract',
						'config_value'	=> 'META Abstract',
					),
					array(
						'config_name'	=> 'meta_description',
						'config_value'	=> 'META Description',
					),
					array(
						'config_name'	=> 'meta_keywords',
						'config_value'	=> 'META Keywords',
					),
					array(
						'config_name'	=> 'meta_google_verify',
						'config_value'	=> '',
					),
				),
			),
		),
		/**
		'custom' => 'custom_100',
		**/
	),
	// Version 1.0.1
	'1.0.1' => array(
		// Now we need to insert some data.
		'table_row_insert'	=> array(
			array('phpbb_phpbbweb_config', 
				array(
					// settings
					array(
						'config_name'	=> 'allow_search',
						'config_value'	=> 1,
					),
				),
			),
		),
		/**
		'custom' => 'custom_101',
		**/
	),
	// Version 1.0.2
	'1.0.2' => array(
		// Add a new row
		'table_column_add' => array(
			array(
				'phpbb_phpbbweb_pages', 'page_time', array('INT:11', 0)		// INTEGER
			),
		),
		// Update own version
		'table_row_update' => array(
			array('phpbb_phpbbweb_config',
				array(
					'config_name'		=> 'version',
				),
				array(
					'config_value'		=> $mod_data['version'],
				),
			),
		),
		// Now we need to insert some data.
		'table_row_insert'	=> array(
			array('phpbb_phpbbweb_config', 
				array(
					// settings
					array(
						'config_name'	=> 'breadcrumbs',
						'config_value'	=> 1,
					),
					array(
						'config_name'	=> 'site_map',
						'config_value'	=> 1,
					),
					array(
						'config_name'	=> 'portal_recent_topics',
						'config_value'	=> 'sidebar',
					),
					array(
						'config_name'	=> 'portal_recent_topics_limit',
						'config_value'	=> 0,
					),
					array(
						'config_name'	=> 'portal_stat',
						'config_value'	=> 0,
					),
				),
			),
		),
		/**
		'custom' => 'custom_102',
		**/
	),
	// Version 1.0.3
	'1.0.3' => array(
		// Update own version
		'table_row_update' => array(
			array('phpbb_phpbbweb_config',
				array(
					'config_name'		=> 'version',
				),
				array(
					'config_value'		=> $mod_data['version'],
				),
			),
		),
		// Now we need to insert some data.
		'table_row_insert'	=> array(
			array('phpbb_phpbbweb_config', 
				array(
					// settings
					array(
						'config_name'	=> 'portal_important_topics',
						'config_value'	=> '',
					),
					array(
						'config_name'	=> 'column_design',
						'config_value'	=> 21,
					),
					array(
						'config_name'	=> 'leftsidebar_width',
						'config_value'	=> 250,
					),
					array(
						'config_name'	=> 'rightsidebar_width',
						'config_value'	=> 200,
					),
					array(
						'config_name'	=> 'meta_description_dynamic',
						'config_value'	=> 0,
					),
				),
			),
		),
		/**
		'custom' => 'custom_103',
		**/
	),
	// Version 1.0.3-PL1
	'1.0.3-pl1' => array(
		// Add a new row
		'table_column_add' => array(
			array(
				'phpbb_phpbbweb_pages', 'global_block', array('INT:11', 0)		// INTEGER
			),
		),
		/**
		'custom' => 'custom_103PL1',
		**/
	),
	// Version 1.0.3-PL2
	'1.0.3-pl2' => array(
		// Add a new row
		'table_column_add' => array(
			array(
				'phpbb_phpbbweb_pages', 'page_description', array('VCHAR:255', '')	// VARCHAR(255)
			),
		),
		'custom' => 'custom_103PL2',
	),
	// Version 1.0.4
	'1.0.4' => array(
		// Now we need to insert some data.
		'table_row_insert'	=> array(
			array('phpbb_phpbbweb_config', 
				array(
					// settings
					array(
						'config_name'	=> 'portal_important_posts',
						'config_value'	=> '',
					),
				),
			),
		),
		// Add a new row
		'table_column_add' => array(
			array(
				'phpbb_phpbbweb_pages', 'redirect_open', array('TINT:1', 0) // TINYINT(1)
			),
		),
		/**
		'custom' => 'custom_104',
		**/
	),
);

// Include the UMIF Auto file and everything else will be handled automatically.
include($phpbb_root_path . 'umil/umil_auto.' . $phpEx);

function custom_103PL2($action, $version)
{
	global $db, $table_prefix, $umil;

	if ($action != 'uninstall' && $umil->table_column_exists('phpbb_phpbbweb_pages', 'description'))
	{
		$umil->table_column_remove('phpbb_phpbbweb_pages', 'description');
	}	

	/**
	* Return a string
	* 	The string will be shown as the action performed (command).  It will show any SQL errors as a failure, otherwise success
	**/
	return array(
		'command'	=> 'TABLE_COLUMN_REMOVE',
		'result'	=> 'SUCCESS',
	);
}

?>