<?php
/**
* @package: phpBB 3.0.8 :: phpBB Web => root
* @version: $Id: search.php, v1.0.1 2010-10-08 10:10:08 leviatan21 Exp $
* @copyright: leviatan21 < info@mssti.com > (Gabriel) http://www.mssti.com/phpbb3/
* @license: http://opensource.org/licenses/gpl-license.php GNU Public License 
* @author: leviatan21 - http://www.phpbb.com/community/memberlist.php?mode=viewprofile&u=345763
**/

define('IN_PHPBBWEB', true);
if (!file_exists( "./config.php" ))
{
	die("<p>The <b>./config.php</b> file could not be found.</p>");
}
include("./config.php");

$user->add_lang('search');

$submit			= request_var('submit', false);
$keywords		= utf8_normalize_nfc(request_var('keywords', '', true));
$add_keywords	= utf8_normalize_nfc(request_var('add_keywords', '', true));
$hilit			= '';
$return_chars	= request_var('ch', 300);
$search_pages	= request_var('pid', array(0));
$start			= request_var('start', 0);
$search_terms	= request_var('terms', '');
$search_fields	= request_var('sf', 'all');

// show_results should not change after this
$per_page = $config['posts_per_page'];

// Generate page header
$phpbbweb->page_header($user->lang['SEARCH']);

// Display the main menu, the breadcrumbs
$phpbbweb->navbar();

if (!$webconfig['allow_search'])
{
	phpbbweb_msg_handler($user->lang['NO_SEARCH']);
}

// Search results page
if ($submit)
{
	// if we search in an existing search result just add the additional keywords. But we need to use "all search terms"-mode
	// so we can keep the old keywords in their old mode, but add the new ones as required words
	if ($add_keywords)
	{
		if ($search_terms == 'all')
		{
			$keywords .= ' ' . $add_keywords;
		}
		else
		{
			$search_terms = 'all';
			$keywords = implode(' |', explode(' ', preg_replace('#\s+#u', ' ', $keywords))) . ' ' . $add_keywords;
		}
	}

	// define some vars for urls
	$hilit = implode('|', explode(' ', preg_replace('#\s+#u', ' ', str_replace(array('+', '-', '|', '(', ')', '&quot;'), ' ', $keywords))));

	// Do not allow *only* wildcard being used for hilight
	$hilit = (strspn($hilit, '*') === strlen($hilit)) ? '' : $hilit;

	$u_hilit = urlencode(htmlspecialchars_decode(str_replace('|', ' ', $hilit)));
	$u_search_pages = implode('&amp;pid%5B%5D=', $search_pages);

	$u_search = append_sid(PHPBBWEB_SEARCH);
	$u_search .= ($u_hilit) ? '&amp;keywords=' . urlencode(htmlspecialchars_decode($keywords)) : '';
	$u_search .= ($search_terms != 'all') ? '&amp;terms=' . $search_terms : '';
	$u_search .= ($search_fields != 'all') ? '&amp;sf=' . $search_fields : '';
	$u_search .= ($return_chars != 300) ? '&amp;ch=' . $return_chars : '';

	if ($hilit)
	{
		// Remove bad highlights
		$hilit_array = array_filter(explode('|', $hilit), 'strlen');
		foreach ($hilit_array as $key => $value)
		{
			$hilit_array[$key] = str_replace('\*', '\w*?', preg_quote($value, '#'));
			$hilit_array[$key] = preg_replace('#(^|\s)\\\\w\*\?(\s|$)#', '$1\w+?$2', $hilit_array[$key]);
		}
		$hilit = implode('|', $hilit_array);
	}

	$search_where = '';
	if (sizeof($search_pages))
	{
		$search_where = ' (page_approved = 1 AND ' . $db->sql_in_set('page_id', $search_pages, false) . ') AND ';
	}
	else
	{
		$search_where = ' page_approved = 1 AND ';
	}

	$term = $highlight = '';
	$split = explode(' ', $keywords);
	foreach ($split as $seachword)
	{
		if ($search_fields == 'all')
		{
			$search_where .= $term . "(page_subject LIKE '%$seachword%' OR page_text LIKE '%$seachword%') ";
		}
		else if ($search_fields == 'titleonly')
		{
			$search_where .= $term . "(page_subject LIKE '%$seachword%') ";
		}
		else if ($search_fields == 'msgonly')
		{
			$search_where .= $term . "(page_text LIKE '%$seachword%') ";
		}
		$term = ($search_terms == 'all') ? 'AND ' : 'OR ';
		$highlight .= $seachword . '+';
	}

	$sql = 'SELECT *
		FROM ' . PHPBBWEB_PAGE_TABLE . "
		WHERE $search_where
		ORDER BY page_type ASC, page_order ASC";
	$result = $db->sql_query_limit($sql, $per_page, $start);

	$total_match_count = 0;
	$text_only_message = '';
	$rowset = array();

	while ($row = $db->sql_fetchrow($result))
	{
		// Replace naughty words such as farty pants
		$row['page_subject'] = censor_text($row['page_subject']);

		// We pre-process some variables here for later usage
		$row['page_text'] = censor_text($row['page_text']);

	//	$text_only_message = $row['page_text'];
		$data = array(
			'mode'				=> ($row['page_type'] == PAGE_CATEGORY) ? 'category' : (($row['page_type'] == PAGE_SECTION) ? 'section' : 'block'),
			'id'				=> $row['page_id'],
			'category_id'		=> $row['parent_id'],
			'class'				=> $row['page_class'],
			'subject'			=> $row['page_subject'],
			'text'				=> $row['page_text'],
			'bbcode_bitfield'	=> $row['bbcode_bitfield'],
			'bbcode_uid'		=> $row['bbcode_uid'],
			'redirect'			=> $row['redirect'],
			'redirect_url'		=> $row['redirect_url'],
			'attachment'		=> $row['page_attachment'],
		);
		$text_only_message = $phpbbweb->parse_content($data);

		// make list items visible as such
		if ($row['bbcode_uid'])
		{
			$text_only_message = str_replace('[*:' . $row['bbcode_uid'] . ']', '&sdot;&nbsp;', $text_only_message);
			// no BBCode in text only message
			strip_bbcode($text_only_message, $row['bbcode_uid']);
			$row['page_text'] = $text_only_message;
		}

		if ($return_chars == -1 || utf8_strlen($text_only_message) < ($return_chars + 3))
		{
			$row['display_text_only'] = false;
		}
		else
		{
			$row['display_text_only'] = true;
			$row['page_text'] = $text_only_message;
		}
		$rowset[] = $row;
	}
	$db->sql_freeresult($result);


	// Add the welcome page ?
	if ($webconfig['welcome_message'] != '' && $webconfig['welcome_message_approved'])
	{
		if (preg_match('#(' . $seachword . ')#i', $webconfig['welcome_message']))
		{
			$class = ($webconfig['allow_search'] || $webconfig['portal_stat'] || ($webconfig['portal_recent_topics'] && $webconfig['portal_recent_topics_limit'] > 0)) ? '' : 'wide';
			$data = array(
				'mode'				=> 'welcome',
				'id'				=> 0,
				'page_id'			=> 0,
				'class'				=> $class,
				'subject'			=> '',
				'page_subject'		=> '',
				'text'				=> $webconfig['welcome_message'],
				'bbcode_bitfield'	=> $webconfig['welcome_message_bbcode_bitfield'],
				'bbcode_uid'		=> $webconfig['welcome_message_bbcode_uid'],
				// Force this : main page can't be redirected ;)
				'redirect'			=> 0,
				'redirect_url'		=> '',
				'attachment'		=> $webconfig['welcome_message_attachment'],
			);
			$text_only_message = $phpbbweb->parse_content($data);

			// make list items visible as such
			if ($data['bbcode_uid'])
			{
				$text_only_message = str_replace('[*:' . $data['bbcode_uid'] . ']', '&sdot;&nbsp;', $text_only_message);
				// no BBCode in text only message
				strip_bbcode($text_only_message, $data['bbcode_uid']);
				$data['page_text'] = $text_only_message;
			}

			if ($return_chars == -1 || utf8_strlen($text_only_message) < ($return_chars + 3))
			{
				$data['display_text_only'] = false;
			}
			else
			{
				$data['display_text_only'] = true;
				$data['page_text'] = $text_only_message;
			}

			$rowset[] = $data;
		}
	}


	unset($text_only_message);

	if ($hilit)
	{
		// Remove bad highlights
		$hilit_array = array_filter(explode('|', $hilit), 'strlen');
		foreach ($hilit_array as $key => $value)
		{
			$hilit_array[$key] = str_replace('\*', '\w*?', preg_quote($value, '#'));
			$hilit_array[$key] = preg_replace('#(^|\s)\\\\w\*\?(\s|$)#', '$1\w+?$2', $hilit_array[$key]);
		}
		$hilit = implode('|', $hilit_array);
	}

	foreach ($rowset as $row)
	{
		// Replace naughty words such as farty pants
		$row['page_subject'] = censor_text($row['page_subject']);

		if ($row['display_text_only'])
		{
			// now find context for the searched words
			$row['page_text'] = get_context($row['page_text'], array_filter(explode('|', $hilit), 'strlen'), $return_chars);
			$row['page_text'] = bbcode_nl2br($row['page_text']);
		}
		else
		{
			$row['page_text'] = bbcode_nl2br($row['page_text']);
			$row['page_text'] = smiley_text($row['page_text']);
		}

		if ($hilit)
		{
			// post highlighting
			$row['page_text'] = preg_replace('#(?!<.*)(?<!\w)(' . $hilit . ')(?!\w|[^<>]*(?:</s(?:cript|tyle))?>)#is', '<span class="posthilit">$1</span>', $row['page_text']);
			$row['page_subject'] = preg_replace('#(?!<.*)(?<!\w)(' . $hilit . ')(?!\w|[^<>]*(?:</s(?:cript|tyle))?>)#is', '<span class="posthilit">$1</span>', $row['page_subject']);
		}

		$template->assign_block_vars('result', array(
		//	'U_CATEGORIE'	=> append_sid(PHPBBWEB_INDEX, array('category' => $row['page_id'])),
			'U_ARTICLE'		=> ($row['page_id']) ? append_sid(PHPBBWEB_INDEX, array('section' => $row['page_id'])) : append_sid(PHPBBWEB_INDEX),
		//	'U_BLOCK'		=> append_sid(PHPBBWEB_INDEX, array('section' => $row['page_id'])),
			'TITLE'			=> $row['page_subject'],
			'DESCRIPTION'	=> $row['page_text'],
		));
		$total_match_count++;
	}

	$template->assign_vars(array(
		'U_SEARCH'			=> append_sid(PHPBBWEB_SEARCH, false, true, 0), // We force no ?sid= appending by using 0
		'S_SEARCH_ACTION'	=> $u_search,
		'PAGINATION'		=> generate_pagination($u_search, $total_match_count, $per_page, $start),
		'PAGE_NUMBER'		=> on_page($total_match_count, $per_page, $start),
		'SEARCH_MATCHES'	=> ($total_match_count == 1) ? sprintf($user->lang['FOUND_SEARCH_MATCH'], $total_match_count) : sprintf($user->lang['FOUND_SEARCH_MATCHES'], $total_match_count),
		'KEYWORD'			=> $keywords,
	));

	$template->set_filenames(array(
		'body' => 'phpbbweb/phpbbweb_search_result.html')
	);
}
// Search query page
else
{
	// Number of chars returned
	$s_characters = '<option value="-1">' . $user->lang['ALL_AVAILABLE'] . '</option>';
	$s_characters .= '<option value="0">0</option>';
	$s_characters .= '<option value="25">25</option>';
	$s_characters .= '<option value="50">50</option>';

	for ($i = 100; $i <= 1000 ; $i += 100)
	{
		$selected = ($i == 300) ? ' selected="selected"' : '';
		$s_characters .= '<option value="' . $i . '"' . $selected . '>' . $i . '</option>';
	}

	$template->assign_vars(array(
		'U_SEARCH'				=> append_sid(PHPBBWEB_SEARCH, false, true, 0), // We force no ?sid= appending by using 0
		'S_PAGE_OPTION'			=> make_page_select($search_pages),
		'S_CHARACTER_OPTIONS'	=> $s_characters,
	));

	$template->set_filenames(array(
		'body' => 'phpbbweb/phpbbweb_search_body.html')
	);
}

// Generate page footer
page_footer();

function make_page_select($select_id)
{
	global $db;

	if (!is_array($select_id))
	{
		$select_id = array($select_id);
	}

	// Get Sections
	$row_s = array();
	$sql_s = 'SELECT * 
			FROM ' . PHPBBWEB_PAGE_TABLE . ' 
			WHERE page_type = ' . PAGE_SECTION . ' 
			ORDER BY page_order ASC';
	$result_s = $db->sql_query($sql_s);
	while ($row = $db->sql_fetchrow($result_s))
	{
		$row_s[] = $row;
	}
	$db->sql_freeresult($result_s);

	// Get Categories
	$row_c = array();
	$sql_c = 'SELECT * 
			FROM ' . PHPBBWEB_PAGE_TABLE . ' 
			WHERE page_type = ' . PAGE_CATEGORY . ' 
			ORDER BY page_order ASC';
	$result_c = $db->sql_query($sql_c);
	while ($row = $db->sql_fetchrow($result_c))
	{
		$row_c[] = $row;
	}
	$db->sql_freeresult($result_c);

	// Get Blocks
	$row_b = array();
	$sql_b = 'SELECT * 
			FROM ' . PHPBBWEB_PAGE_TABLE . ' 
			WHERE page_type = ' . PAGE_BLOCK . ' 
			ORDER BY page_order ASC';
	$result_b = $db->sql_query($sql_b);
	while ($row = $db->sql_fetchrow($result_b))
	{
		$row_b[] = $row;
	}
	$db->sql_freeresult($result_b);

	$option_list = '';
	// Go trough all categories
	foreach ($row_c as $rowc)
	{
		$selectedc = in_array($rowc['page_id'], $select_id) ? ' selected="selected"' : '';

		$option_list .= '<option value="' . $rowc['page_id'] . '"' . $selectedc . '>' . $rowc['page_subject'] . '</option>' . "\r";

		// Go trough Sections for this category
		foreach ($row_s as $rows)
		{
			if ($rows['parent_id'] == $rowc['page_id'])
			{
				$selecteds = in_array($rows['page_id'], $select_id) ? ' selected="selected"' : '';
				$option_list .= '<option value="' . $rows['page_id'] . '"' . $selecteds . '>&nbsp;&nbsp;' . $rows['page_subject'] . '</option>' . "\r";

				// Go trough Blocks for this section
				foreach ($row_b as $rowb)
				{
					if ($rowb['parent_id'] == $rows['page_id'])
					{
						$selecteds = in_array($rowb['page_id'], $select_id) ? ' selected="selected"' : '';
						$option_list .= '<option value="' . $rowb['page_id'] . '"' . $selecteds . '>&nbsp;&nbsp;&nbsp;&nbsp;' . $rowb['page_subject'] . '</option>' . "\r";
					}
				}
			}
		}

		// Go trough Blocks for this category
		foreach ($row_b as $rowb)
		{
			if ($rowb['parent_id'] == $rowc['page_id'])
			{
				$selecteds = in_array($rowb['page_id'], $select_id) ? ' selected="selected"' : '';
				$option_list .= '<option value="' . $rowb['page_id'] . '"' . $selecteds . '>&nbsp;&nbsp;&nbsp;&nbsp;' . $rowb['page_subject'] . '</option>' . "\r";
			}
		}
	}

	return $option_list;
}

?>