<?php
/**
* @package: phpBB 3.0.8 :: phpBB Web => root
* @version: $Id: sitemap.php, v1.0.4 2011-01-20 11:01:20 leviatan21 Exp $
* @copyright: leviatan21 < info@mssti.com > (Gabriel) http://www.mssti.com/phpbb3/
* @license: http://opensource.org/licenses/gpl-license.php GNU Public License 
* @author: leviatan21 - http://www.phpbb.com/community/memberlist.php?mode=viewprofile&u=345763
**/

define('IN_PHPBBWEB', true);
if (!file_exists( "./config.php" ))
{
	die("<p>The <b>./config.php</b> file could not be found.</p>");
}
include("./config.php");

/**
* @ignore
*	http://www.sitemaps.org/protocol.php
* 	http://www.sitemappro.com/examples.html
*	http://www.scottandrew.com/weblog/articles/dom_espanol
*******************************************************************************************************************************************************************************************************
*		<urlset>
*			required
*			Encapsulates the file and references the current protocol standard.
*
*		<url>
*			required
*			Parent tag for each URL entry. The remaining tags are children of this tag.
*
*		<loc>
*			required
*			URL of the page. This URL must begin with the protocol (such as http) and end with a trailing slash, if your web server requires it. This value must be less than 2,048 characters.
*
*		<lastmod>
*			optional
*			The date of last modification of the file. This date should be in W3C Datetime format. This format allows you to omit the time portion, if desired, and use YYYY-MM-DD.
*			Note that this tag is separate from the If-Modified-Since (304) header the server can return, and search engines may use the information from both sources differently.
*
*		<changefreq>
*			optional
*			How frequently the page is likely to change. This value provides general information to search engines and may not correlate exactly to how often they crawl the page. Valid values are:
*				always
*				hourly
*				daily
*				weekly
*				monthly
*				yearly
*				never
*			The value "always" should be used to describe documents that change each time they are accessed. The value "never" should be used to describe archived URLs.
*			Please note that the value of this tag is considered a hint and not a command. Even though search engine crawlers may consider this information when making decisions, 
*			they may crawl pages marked "hourly" less frequently than that, and they may crawl pages marked "yearly" more frequently than that. 
*			Crawlers may periodically crawl pages marked "never" so that they can handle unexpected changes to those pages.
*
*		<priority>
*			optional
*			The priority of this URL relative to other URLs on your site. Valid values range from 0.0 to 1.0. 
*			This value does not affect how your pages are compared to pages on other sites—it only lets the search engines know which pages you deem most important for the crawlers.
*			The default priority of a page is 0.5.
*			Please note that the priority you assign to a page is not likely to influence the position of your URLs in a search engine's result pages. 
*			Search engines may use this information when selecting between URLs on the same site, so you can use this tag to increase the likelihood that your most important pages are present in a search index.
*			Also, please note that assigning a high priority to all of the URLs on your site is not likely to help you. Since the priority is relative, it is only used to select between URLs on your site.
*
*	Entity escaping
* 		Your Sitemap file must be UTF-8 encoded (you can generally do this when you save the file). 
* 		As with all XML files, any data values (including URLs) must use entity escape codes for the characters listed in the function sitemap_content()
* 		In addition, all URLs (including the URL of your Sitemap) must be URL-escaped and encoded for readability by the web server on which they are located. 
* 		However, if you are using any sort of script, tool, or log file to generate your URLs (anything except typing them in by hand), this is usually already done for you. 
* 		Please check to make sure that your URLs follow the  RFC-3986 standard for URIs, the RFC-3987  standard for IRIs, and the XML standard.
*******************************************************************************************************************************************************************************************************************
* Sitemap: http://www.mysite.com/sitemap.xml
* 
* Quieren hacernos más facil señalar a Google dónde está nuestro sitemap para que la indexación sea más rápida y automatizada. 
* Para ello, ahora podemos señalar desde nuestro robot.txt la ubicación de nuestro sitemap.xml. 
* Solo tenemos que añadir una línea similar a ésta al robot.txt:
* Solo hay que asegurarse de incluir la URL completa del sitemap, incluido http://.
* Leer más: http://www.adseok.com/google/tu-sitemapxml-en-tu-robottxt/
**/

// Give us some basic information
sitemap_init();

// Set a browser
$format = strtolower(request_var('format', sitemap_format(), true));

// Run the sql and fill the data
$rowset	= sitemap_branch();

// Okay, lets dump out the page ...
if (sizeof($rowset))
{
	if ($format == 'xml')
	{
		// Send Header
		header("Content-Type: text/xml; charset=UTF-8");

		sitemap_make_tree($rowset);

		$zone_offset = (int) $user->timezone + (int) $user->dst;
		$template->assign_vars(array(
			'S_XML_SITEMAP'	=> true,
			'ENCODING'		=> '<?xml version="1.0" encoding="UTF-8"?>',
			'U_INDEX'		=> PHPBBWEB_INDEX,
			'INDEX_LASTMOD'	=> date("Y-m-d\TH:i:sP", time() + $zone_offset),
			'INDEX_FREQ'	=> FREQ_INDEX,
			'INDEX_PRIO'	=> PRIO_INDEX,
		));

		$template->set_filenames(array(
			'body' => 'phpbbweb/phpbbweb_sitemap_body.html')
		);

		$template->display('body');

		unset($rowset);
		garbage_collection();
		exit_handler();
	}
	else if ($format == 'txt')
	{
		// application/xhtml+xml not used because of IE
		header("Content-type: text/html; charset=UTF-8");

		sitemap_make_tree($rowset);

		$template->assign_vars(array(
			'S_LIST_SITEMAP'	=> true,
			'U_INDEX'			=> PHPBBWEB_INDEX . "\r\n",
		));

		$template->set_filenames(array(
			'body' => 'phpbbweb/phpbbweb_sitemap_body.html')
		);

		$template->display('body');

		unset($rowset);
		garbage_collection();
		exit_handler();
	}
	else
	{
		// Generate page header
		$phpbbweb->page_header($user->lang['ACP_SITEMAP']);

		// Display the main menu
		$phpbbweb->navbar(0, 0);

		if (!$webconfig['site_map'])
		{
			phpbbweb_msg_handler($user->lang['SITE_MAP_DISABLED']);
		}

		$template->assign_vars(array(
			'S_HTML_SITEMAP'	=> true,
		));

		sitemap_make_tree($rowset);

		$template->set_filenames(array(
			'body' => 'phpbbweb/phpbbweb_sitemap_body.html')
		);
		
		unset($rowset);
		page_footer();
	}
}
else
{
	phpbbweb_msg_handler('SITE_MAP_DISABLED');
}

/**
* Define initial vars
**/
function sitemap_init()
{
	global $phpEx;

	define('FREQ_INDEX', 'monthly');
	define('FREQ_CATERORY', 'weekly');
	define('FREQ_SECTION', 'weekly');

	define('PRIO_INDEX', '1.0');
	define('PRIO_CATERORY', '0.8');
	define('PRIO_SECTION', '0.5');
}

/**
* Get site branch...
*
* @return unknown
**/
function sitemap_branch()
{
	global $db, $user;

	$rowset = array();

	$zone_offset = (int) $user->timezone + (int) $user->dst;
	
	// Get all Categories - Start
	$sql_category = 'SELECT * 
			FROM ' . PHPBBWEB_PAGE_TABLE . ' 
			WHERE page_type = ' . PAGE_CATEGORY . ' 
			ORDER BY page_order ASC';
	$result_category = $db->sql_query($sql_category);

	while ($row = $db->sql_fetchrow($result_category))
	{
		$row['page_time'] = ($row['page_time']) ? $row['page_time'] : time();
		$rowset[$row['page_id']] = array(
			'category_id'	=> $row['page_id'],
			'type'			=> PAGE_CATEGORY,
			'loc'			=> append_sid(PHPBBWEB_INDEX, array('category' => $row['page_id'])), 
			'name'			=> $row['page_subject'],
			'lastmod'		=> date("Y-m-d\TH:i:sP", $row['page_time'] + $zone_offset),
			'frequently'	=> FREQ_CATERORY,
			'priority'		=> PRIO_CATERORY,
		);
	}
	$db->sql_freeresult($result_category);
	// Get all Categories - End

	// Get all Sections for each Category - Start
	foreach ($rowset as $categories => $category)
	{
		$sql_section = 'SELECT * 
				FROM ' . PHPBBWEB_PAGE_TABLE . ' 
				WHERE parent_id = ' . $category['category_id'] . ' AND page_type = ' . PAGE_SECTION . ' 
				ORDER BY page_order ASC';
		$result_section = $db->sql_query($sql_section);

		while ($row = $db->sql_fetchrow($result_section))
		{
			$row['page_time'] = ($row['page_time']) ? $row['page_time'] : time();
			$rowset[$category['category_id']]['section'][$row['page_id']] = array(
				'category_id'	=> $category['category_id'],
				'section_id'	=> $row['page_id'],
				'type'			=> PAGE_SECTION,
				'loc'			=> append_sid(PHPBBWEB_INDEX, array('section' => $row['page_id'])), 
				'name'			=> $row['page_subject'],
				'lastmod'		=> date("Y-m-d\TH:i:sP", $row['page_time'] + $zone_offset),
				'frequently'	=> FREQ_SECTION,
				'priority'		=> PRIO_SECTION,
			);
		}
		$db->sql_freeresult($result_section);
	}
	// Get all Sections for each Category - End

	return $rowset;
}

/**
* Your Sitemap file must be UTF-8 encoded 
* As with all XML files, any data values (including URLs) must use entity escape codes for the characters listed in the table below.
*
* @param string		$content => link or name
* @return string	UTF-8 encoded
**/
function sitemap_content($content)
{
	$content = str_replace(
	array(
			'&',		// Ampersand		&	&amp;
			"'",		// Single Quote		'	&apos;
			'"',		// Double Quote		"	&quot;
			'>',		// Greater Than		>	&gt;
			'<',		// Less Than		<	&lt;
	),
	array(
			'&amp;',	// Ampersand		&	&amp;
			'&apos;',	// Single Quote		'	&apos;
			'&quot;',	// Double Quote		"	&quot;
			'&gt;',		// Greater Than		>	&gt;
			'&lt;',		// Less Than		<	&lt;
	), $content);

	// Other control characters
	$content = preg_replace('#(?:[\x00-\x1F\x7F]+|(?:\xC2[\x80-\x9F])+)#', '', $content);

	return $content;
}

function sitemap_make_tree($rowset)
{
	global $template, $user;

	foreach ($rowset as $categories => $category)
	{
		$template->assign_block_vars('sitemap_category', array(
			'CAT_ID'		=> $category['category_id'],
			'CAT_URL'		=> $category['loc'],
			'CAT_LINK'		=> $category['loc'] . "\r\n",
			'CAT_XML'		=> sitemap_content($category['loc']), 
			'CAT_TITLE'		=> $user->lang['TYPE_CATEGORY'],
			'CAT_NAME'		=> $category['name'],
			'CAT_LASTMOD'	=> $category['lastmod'],
			'CAT_FREQ'		=> $category['frequently'],
			'CAT_PRIO'		=> $category['priority'],
			'HAVE_SECTIONS'	=> (isset($category['section'])) ? true : false,
		));

		if (isset($category['section']))
		{
			foreach ($category['section'] as $sections => $section)
			{
				$template->assign_block_vars('sitemap_category.section', array(
					'CAT_ID'		=> $section['category_id'],
					'SEC_ID'		=> $section['section_id'],
					'SEC_URL'		=> $section['loc'],
					'SEC_LINK'		=> $section['loc'] . "\r\n",
					'SEC_XML'		=> sitemap_content($section['loc']), 
					'SEC_TITLE'		=> $user->lang['TYPE_SECTION'],
					'SEC_NAME'		=> $section['name'],
					'SEC_LASTMOD'	=> $section['lastmod'],
					'SEC_FREQ'		=> $section['frequently'],
					'SEC_PRIO'		=> $section['priority'],
				));
			}
		}
	}
}

/**
* Get a browser...
*
* @return string
**/
function sitemap_format()
{
	$user_agent = (!empty($_SERVER['HTTP_USER_AGENT'])) ? htmlspecialchars((string) $_SERVER['HTTP_USER_AGENT']) : '';

	if (strpos(strtolower($user_agent), 'google') !== false)
	{
		return "xml";
	}
	if (strpos(strtolower($user_agent), 'yahoo') !== false)
	{
		return "txt";
	}
	return strtolower($user_agent);
}

?>